require('dotenv').load();

var keystone = require('keystone');

global.__base = __dirname + '/';

var project_prefix='nestle_gelato_v5';

if (keystone.get('env') == 'production') {
	var dbPrefix=project_prefix+'_production';
	var nodePort = 3004;
	base_url='http://www.nestlegelato.com.br';
}else if (keystone.get('env') == 'staging') {
	var dbPrefix=project_prefix+'_staging';
	var nodePort = 3005;
	base_url='http://nestle-gelato.staging.ws';
	//base_url='http://www.nestlegelato.com.br';
}else if (keystone.get('env') == 'ddll') {
	var dbPrefix=project_prefix+'_ddll';
	var nodePort = 3004;
	base_url='http://nestle-gelato.ddll.co';
}else if (keystone.get('env') == 'webstack') {
	var dbPrefix=project_prefix+'_production';
	var nodePort = 3004;
	base_url='http://nestlegelato.gabrielgiacomini.com';
}else{
	var dbPrefix=project_prefix+'_development';
	var nodePort = 3004;
	base_url='http://localhost:3004';
}

console.log('dbPrefix=',dbPrefix);

keystone.init({
	'name': 'nestle-gelato',
	'brand': 'Nestlé Gelato',
	'port': nodePort,
	//'less': 'public',
	'static': 'public',
	'favicon': 'public/favicon.ico',
	'views': global.__base+'templates/views',
	'view engine': 'jade',
	'viewCache' : true,
	'emails': 'templates/emails',
	'session store':'mongo',
	'auto update': true,
	'session': true,
	'auth': true,
	'model prefix' : dbPrefix,
	'user model': 'User',
	'cookie secret': '[QSFInqsofgiqsogisqghpqsog(NZkbXnrCQ2<1#0+Ti:<$T=%KxbFX_TIB(AmdiAM'
});

if (keystone.get('env') == 'production') {
	keystone.set('cloudinary config', {
		cloud_name: 'nestle-gelato',
		api_key: '867581475762161',
		api_secret: 'JQxkHjmd4wb5mmV6SiuVemH4iyY'
	});
}else if (keystone.get('env') == 'staging') {
	keystone.set('cloudinary config', {
		cloud_name: 'nestle-gelato',
		api_key: '867581475762161',
		api_secret: 'JQxkHjmd4wb5mmV6SiuVemH4iyY'
	});
}else if (keystone.get('env') == 'ddll') {
	keystone.set('cloudinary config', {
		cloud_name: 'nestle-gelato',
		api_key: '867581475762161',
		api_secret: 'JQxkHjmd4wb5mmV6SiuVemH4iyY'
	});
}else if (keystone.get('env') == 'webstack') {
	keystone.set('cloudinary config', {
		cloud_name: 'nestle-gelato',
		api_key: '867581475762161',
		api_secret: 'JQxkHjmd4wb5mmV6SiuVemH4iyY'
	});
}else{
	keystone.set('cloudinary config', {
		cloud_name: 'nestle-gelato',
		api_key: '867581475762161',
		api_secret: 'JQxkHjmd4wb5mmV6SiuVemH4iyY'
	});
}



cachedResponses= {};
if (!(keystone.get('env') == 'development')) {
	compiledViews = require('./optimizers/views');
}

keystone.set('locals', {
	_: require('underscore'),
	env: keystone.get('env'),
	utils: keystone.utils,
	editable: keystone.content.editable
});

if (keystone.get('env') == 'production') {
	keystone.set('cloudinary prefix', project_prefix+'_production');
}else if (keystone.get('env') == 'staging') {
	keystone.set('cloudinary prefix', project_prefix+'_staging');
}else if (keystone.get('env') == 'ddll') {
	keystone.set('cloudinary prefix', project_prefix+'_ddll');
}else if (keystone.get('env') == 'ddll') {
	keystone.set('cloudinary prefix', project_prefix+'_webstack');
}else{
	keystone.set('cloudinary prefix', project_prefix+'_development');
}

keystone.set('cloudinary folders', true);
keystone.set('cloudinary secure', false);

keystone.import('models');
keystone.set('routes', require('./routes'));

keystone.set('nav', {
	'users': ['users',],
	'layout-contents': ['desktop-contents','mobile-contents','metadata',],
	'cards': ['cards','preauthorized-instagram-users','preauthorized-twitter-users','banned-instagram-users','banned-twitter-users'],
	'markers': ['markers',],
});

keystone.start();

if (keystone.get('env') == 'production') {
	require(global.__base+'tasks/instagram_fetch');
	require(global.__base+'tasks/twitter_fetch');
}else if (keystone.get('env') == 'staging') {
	require(global.__base+'tasks/instagram_fetch');
	require(global.__base+'tasks/twitter_fetch');
}else if (keystone.get('env') == 'ddll') {
	require(global.__base+'tasks/instagram_fetch');
	require(global.__base+'tasks/twitter_fetch');
}else if(keystone.get('env') == 'webstack'){
	require(global.__base+'tasks/instagram_fetch');
	require(global.__base+'tasks/twitter_fetch');
}else if(keystone.get('env') == 'development'){
	// require(global.__base+'tasks/instagram_fetch');
	// require(global.__base+'tasks/twitter_fetch');
}

console.log('Running as '+keystone.get('env')+' environment.');
