
var keystone = require('keystone'),
	Types = keystone.Field.Types,
	_ = require('underscore');


var Model = new keystone.List('PreauthorizedInstagramUsers', {
	map: { name: 'handle' },
	autokey: { path: 'slug', from: 'handle', unique: true },
	defaultSort: 'handle',
});

Model.add({
	handle: { type: String, initial: true, required: true, index: true },
});

function updateCache(){
	Model.model.find().exec(function(err, users) {
		var newList=[];
	    _.each(users,function(user){
	        newList.push(user.handle)
	    });
	    approved_instagram_users_handles=newList;
	    console.log('approved_instagram_users_handles updated ',approved_instagram_users_handles);
	});
}
var lazyCache = _.debounce(updateCache, 50);
Model.schema.post('save', function (item) { lazyCache(); });
Model.schema.post('remove', function (item) { lazyCache(); });
Model.schema.pre('update', function (next) { lazyCache(); next(); });
lazyCache();

Model.defaultColumns = 'handle';
Model.register();

