// 1. Video player state
var isShowingVideo = true;
var isPlayingVideo = false;
var isHidingVideo = false; /* Click to hide video state control */
var videoSeekUpdateInterval = 100;

var headerVideoId = 'DvI6I3pjz5U';
var product1VideoId = 'IjAx_MxYxg0';
var product2VideoId = 'pRSZXleEStE';
var product3VideoId = '8uxHiBTM4Do';
var product4VideoId = 'c7PNJ_J1VTU';
var currentVideoId = headerVideoId;

// 2. This code loads the IFrame Player API code asynchronously.
var tag = document.createElement('script');
tag.src = "https://www.youtube.com/iframe_api";
var firstScriptTag = document.getElementsByTagName('script')[0];
firstScriptTag.parentNode.insertBefore(tag, firstScriptTag);

// 3. This function creates an <iframe> (and YouTube player)
//    after the API code downloads.
var headerPlayer;
var productPlayer;
function onYouTubeIframeAPIReady() {

  headerPlayer = new YT.Player('video-container', {
    height: innerWidth,
    width: innerHeight,
    events: {
      'onReady': onHeaderPlayerReady,
      'onStateChange': onHeaderPlayerStateChange
    },
    playerVars: { 'autoplay': 0, 'controls': 0, 'showinfo': 0 },
  });

  productPlayer = new YT.Player('product-video-container', {
    height: innerWidth,
    width: innerHeight,
    events: {
      'onReady': onProductPlayerReady,
      'onStateChange': onProductPlayerStateChange
    },
    playerVars: { 'autoplay': 0, 'controls': 0, 'showinfo': 0 },
  });
}

// 4. The API will call this function when the video player is ready.
function onHeaderPlayerReady(event) {

}
function onHeaderPlayerStateChange(event) {

}
function onProductPlayerReady(event) {

}
function onProductPlayerStateChange(event) {

}

function stopVideo() {

  if (currentVideoId == headerVideoId) {
    headerPlayer.stopVideo();
  } else {
    productPlayer.stopVideo();
  }

  isPlayingVideo = false;
}

function playVideo(is_iOS) {

  isPlayingVideo = true;

  if (currentVideoId == headerVideoId) {
    $('#video-container').show();
    $('#product-video-container').hide();

    $('#video-close-button').show();
    $('#video-seek-bar-container').show();
    $('#product-video-close-button').hide();
    $('#product-video-seek-bar-container').hide();

    if (is_iOS == false) {
      headerPlayer.playVideo();
    }

  } else {
    $('#video-container').hide();
    $('#product-video-container').show();

    $('#video-close-button').hide();
    $('#video-seek-bar-container').hide();
    $('#product-video-close-button').show();
    $('#product-video-seek-bar-container').show();

    if (is_iOS == false) {
      productPlayer.playVideo();
    }
  }

  /* Update seek bar */
  setTimeout(updateSeekBar, videoSeekUpdateInterval);
}

/* Updates the seek bar in an interval */
function updateSeekBar() {
  if (isPlayingVideo) {

    /* Bar width */
    var barWidth = window.innerWidth;
    var currentTime = 0;
    var totalTime = 0;
    if (currentVideoId == headerVideoId) {

      currentTime = headerPlayer.getCurrentTime();
      totalTime = headerPlayer.getDuration();
      $('#video-seek-bar-white').css('width', (barWidth * (currentTime / totalTime)) + 'px');

      /* Bar left */
      var barLeft = 0;
      $('#video-seek-bar-white').css('left', barLeft + 'px');

    } else {

      currentTime = productPlayer.getCurrentTime();
      totalTime = productPlayer.getDuration();
      $('#product-video-seek-bar-white').css('width', (barWidth * (currentTime / totalTime)) + 'px');

      /* Bar left */
      var barLeft = 0;
      $('#product-video-seek-bar-white').css('left', barLeft + 'px');
    }

    setTimeout(updateSeekBar, videoSeekUpdateInterval);
  }
}

/* Click the X to hide the video */
function hideVideo() {

  stopVideo();

  if (currentVideoId == headerVideoId) {
    $('#video-container').hide();
    $('#product-video-container').hide();

    $('#video-close-button').hide();
    $('#video-seek-bar-container').hide();
    $('#product-video-close-button').hide();
    $('#product-video-seek-bar-container').hide();
  } else {
    $('#video-container').hide();
    $('#product-video-container').hide();

    $('#video-close-button').hide();
    $('#video-seek-bar-container').hide();
    $('#product-video-close-button').hide();
    $('#product-video-seek-bar-container').hide();
  }

  isShowingVideo = false;

  $('#products_navigation').css('display', 'block');
}

/* Hit esc to hide video */
$('body').keyup(function(e) {
  if(e.which == 27) {
    if (isShowingVideo) {
      hideVideo();
    }
  }
});

/* When clicking the bar, seek the video to that point */
function seekTo(x) {

  var barStart = 0;
  var barEnd = window.innerWidth;

  var barWidth = window.innerWidth;
  var totalTime = 0;
  if (currentVideoId == headerVideoId) {
    totalTime = headerPlayer.getDuration();
    if (x >= barStart && x <= barEnd) {
      headerPlayer.seekTo((x / barWidth) * totalTime);
    }
  } else {
    totalTime = productPlayer.getDuration();
    if (x >= barStart && x <= barEnd) {
      productPlayer.seekTo((x / barWidth) * totalTime);
    }
  }
}

/* Close button */
$('#video-close-button').click(function() {
  closeVideo();
});
$('#product-video-close-button').click(function() {
  closeVideo();
});

/* Play/pause when clicking anywhere in the video */
$('#video-controls').click(function(e) {
  videoControlsClick(e);
});
$('#product-video-controls').click(function(e) {
  videoControlsClick(e);
});

function loadNewVideo(videoId, is_iOS) {

  /* Hide the product navigation section */
  if (videoId == headerVideoId) {
    $('#products_navigation').css('display', 'block');
  } else {
    $('#products_navigation').css('display', 'none');
  }

  /* Close button */
  $('#video-close-button').unbind('click');
  $('#product-video-close-button').unbind('click');
  $('#video-close-button').click(function() {
    closeVideo();
  });
  $('#product-video-close-button').click(function() {
    closeVideo();
  });

  /* Video seeker bar controls */
  $('#video-seek-bar-container').unbind('click');
  $('#product-video-seek-bar-container').unbind('click');
  $('#video-seek-bar-container').click(function(e) {
    videoControlsClick(e);
  });
  $('#product-video-seek-bar-container').click(function(e) {
    videoControlsClick(e);
  });

  if (videoId == headerVideoId) {
    headerPlayer.cueVideoById(videoId);
  } else {
    productPlayer.cueVideoById(videoId);
  }

  playVideo(is_iOS);
}

function videoControlsClick(e) {

  /* Seek to if clicking the bar  */
  if (e.target.id == 'video-seek-bar-container' || e.target.id == 'video-seek-bar-white' || e.target.id == 'video-seek-bar-yellow'
   || e.target.id == 'product-video-seek-bar-container' || e.target.id == 'product-video-seek-bar-white' || e.target.id == 'product-video-seek-bar-yellow') {
    var clickX = e.pageX;
    seekTo(clickX);
    return;
  }

  /* Hiding video state control */
  if (isHidingVideo) {
    isHidingVideo = false;
    return;
  }

  /* Play/pause */
  if (isPlayingVideo) {
    stopVideo();
  } else {
    playVideo(is_iOS);
  }
}

function closeVideo() {
  hideVideo();
  isHidingVideo = true;
}

/* Called from site.js, as the user clicks 'view-product-video' */
function clickToWatchVideo(section, is_iOS) {

  if (section == 0) {
    currentVideoId = headerVideoId;
  } else if (section == 1) {
    currentVideoId = product1VideoId;
  } else if (section == 2) {
    currentVideoId = product2VideoId;
  } else if (section == 3) {
    currentVideoId = product3VideoId;
  } else if (section == 4) {
    currentVideoId = product4VideoId;
  }

  loadNewVideo(currentVideoId, is_iOS);
}
