var keystone = require('keystone');
var _ = require('underscore');
var Card = keystone.list('Card');
var url = require('url');
var async = require('async');
exports = module.exports = function(req, res) {

	var state=undefined;
	var hasHashtag=undefined;
	var isPreapproved=undefined;
	var isBanned=undefined;
	var cleanupUrl=false;
	var refreshUrl=false;
	
	var view = new keystone.View(req, res),
		locals = res.locals;

	var url = req.url;
	url = url.replace(/\/$/, '');
	console.log('url  = '+url);
	switch(url){

		case '/moderation/pending/hashtag/cleanup':
			state='pending';
			hasHashtag=true;
			//cleanupUrl='/moderation/pending/hashtag/cleanup';
			refreshUrl='/moderation/pending/hashtag';
		break;

		case '/moderation/pending/all/cleanup':
			state='pending';
			//hasHashtag=true;
			//cleanupUrl='/moderation/pending/hashtag/cleanup';
			refreshUrl='/moderation/pending/all';
		break;

		case '/moderation/pending/location/cleanup':
			state='pending';
			hasHashtag=false;
			//cleanupUrl='/moderation/pending/location/cleanup';
			refreshUrl='/moderation/pending/location';
		break;

		case '/moderation/rejected/cleanup':
			state='rejected';
			//cleanupUrl='/moderation/rejected/cleanup';
			refreshUrl='/moderation/rejected';
		break;

		case '/moderation/banned/cleanup':
			state='rejected';
			isBanned=true;
			//cleanupUrl='/moderation/rejected/cleanup';
			refreshUrl='/moderation/rejected';
		break;
	}

	

	var q=Card.model.find();
    q.sort('timestamp');
    q.limit(1000)
    if(!_.isUndefined(state)) q.where('state', state);
    if(!_.isUndefined(isPreapproved)) q.where('isFromPreapprovedUser', isPreapproved);
    if(!_.isUndefined(isBanned)) q.where('isFromBannedUser', isBanned);
    if(!_.isUndefined(hasHashtag)) q.where('isFromHashtag', hasHashtag);
    q.exec(function(err, items) {
        // do something with posts
        
        async.map(items, function(item,callback){
        	item.remove(function(err) {
		        callback(err,item);
		    });
        }, function(err, results){

			res.locals={ 
	        	deletedItems:results,
	        	url: url,
	        	cleanupUrl:cleanupUrl,
	        	refreshUrl:refreshUrl,
	        }

			view.render('moderation');
		});

        

    });
	
};
