var keystone = require('keystone'),
	cloudinary = require('cloudinary');

exports = module.exports = function(req, res) {
	
	if (!(keystone.get('env') == 'development')) {
		//get view from cache
		var cached=cachedResponses['index'];
		if(cached){
			//console.log('will send cached');
			res.send(cached);
			return;
		}
	}
	

	var view = new keystone.View(req, res),
		locals = res.locals;



	locals.section = 'home';
	locals.data = {};
	locals.base_url 		= base_url;
	locals.v				= '?v='+new Date().getTime();
	locals.cloudinary   	= cloudinary;
	locals.env          	= keystone.get('env');
	locals.cloud_name 		= keystone.get('cloudinary config').cloud_name;
	locals.metadata			= cachedResponses['metadata'];
	locals.desktop_content	= cachedResponses['desktop_content'];
	locals.mobile_content	= cachedResponses['mobile_content'];
	locals.cards			= cachedResponses['cards'];
	
	if (!(keystone.get('env') == 'development')) {
		//render compiled view and save in cache 
		view.render(compiledViews.renderFn('index','index'));

	}else if(req.query && req.query.pixelcheck){
		locals.pixelcheck=true;
		view.render('index');

	}else{
		view.render('index');
	}
	//
	
	
};
