var keystone = require('keystone');
var _ = require('underscore');
var Card = keystone.list('Card');
var url = require('url');

exports = module.exports = function(req, res) {

	var view = new keystone.View(req, res),
		locals = res.locals;

	var state=undefined;
	var hasHashtag=undefined;
	var isPreapproved=undefined;
	var isBanned=undefined;
	var cleanupUrl=false;
	var refreshUrl=false;

	var url = req.url;
	url = url.replace(/\/$/, '');
	console.log('url  = '+url);
	refreshUrl=url;
	switch(url){
	
		case '/moderation':
		case '/moderation/published':
			state='published'
		break;

		case '/moderation/pending/all':
			state='pending';
			//hasHashtag=true;
			cleanupUrl='/moderation/pending/all/cleanup';
		break;

		case '/moderation/pending/hashtag':
			state='pending';
			hasHashtag=true;
			cleanupUrl='/moderation/pending/hashtag/cleanup';
		break;

		case '/moderation/pending/location':
			state='pending';
			hasHashtag=false;
			cleanupUrl='/moderation/pending/location/cleanup';
		break;

		case '/moderation/preapprooved':
			isPreapproved=true;
		break;

		case '/moderation/banned':
			isBanned=true;
		break;

		case '/moderation/rejected':
			state='rejected';
			cleanupUrl='/moderation/rejected/cleanup';
		break;

		case '/moderation/archived':
			state='archived';
		break;
	}

	

	var q=Card.model.find();
    q.sort('-displayDate');
    q.limit(500)
    if(!_.isUndefined(state)) q.where('state', state);
    if(!_.isUndefined(isPreapproved)) q.where('isFromPreapprovedUser', isPreapproved);
    if(!_.isUndefined(isBanned)) q.where('isFromBannedUser', isBanned);
    if(!_.isUndefined(hasHashtag)) q.where('isFromHashtag', hasHashtag);
    q.exec(function(err, items) {
        // do something with posts
        console.log('items.length=',items.length);


        res.locals = { 
        	items:items,
        	url: url,
        	cleanupUrl:cleanupUrl,
        	refreshUrl:refreshUrl,
        }

        if (!(keystone.get('env') == 'development')) {
			//render compiled view and save in cache 
			view.render(compiledViews.renderFn('moderation'));
		}else{
			view.render('moderation');
		}

    });
	
};
