
var _ = require('underscore');
var async = require('async');
var keystone = require('keystone');
var Card = keystone.list('Card');
var AuthorizedTwitterUsers = keystone.list('PreauthorizedTwitterUsers');
var BannedTwitterUsers = keystone.list('BannedTwitterUsers');
var shortid = require('shortid');
var tags = [ 'nestlegelato', 'lamiagelateria'  ];


function saveMedia(media){
    	
    //console.log('saveMedia',media);

	//return;

    
	var card = new Card.model({});
	card.origin='Twitter';
	card.unique_media_id = media.id_str;
	card.twitter_json_data= JSON.stringify(media,null,4);
	card.displayDate=media.created_at; //*100

	//console.log('save media '+card.unique_media_id+' '+media.created_at);
	
	//console.log('card.displayDate=',card.displayDate);

	card.twitter_created_at                                  	 = 	media.created_at;
	//card.twitter_id                                          	 = 	media.id;
	card.twitter_id_str                                      	 = 	media.id_str;
	card.twitter_text                                        	 = 	media.text;
	card.twitter_source                                      	 = 	media.source;
	card.twitter_truncated                                   	 = 	media.truncated;
	card.twitter_in_reply_to_status_id                       	 = 	media.in_reply_to_status_id;
	card.twitter_in_reply_to_status_id_str                   	 = 	media.in_reply_to_status_id_str;
	card.twitter_in_reply_to_user_id                         	 = 	media.in_reply_to_user_id;
	card.twitter_in_reply_to_user_id_str                     	 = 	media.in_reply_to_user_id_str;
	card.twitter_in_reply_to_screen_name                     	 = 	media.in_reply_to_screen_name;
	if(media.user){
		card.twitter_user_id                                     = 	media.user.id;
		card.twitter_user_id_str                                 = 	media.user.id_str;
		card.twitter_user_name                                   = 	media.user.name;
		card.twitter_user_screen_name                            = 	media.user.screen_name;
		card.twitter_user_location                               = 	media.user.location;
		card.twitter_user_url                                    = 	media.user.url;
		card.twitter_user_description                            = 	media.user.description;
		card.twitter_user_protected                              = 	media.user.protected;
		card.twitter_user_verified                               = 	media.user.verified;
		card.twitter_user_followers_count                        = 	media.user.followers_count;
		card.twitter_user_friends_count                          = 	media.user.friends_count;
		card.twitter_user_listed_count                           = 	media.user.listed_count;
		card.twitter_user_favourites_count                       = 	media.user.favourites_count;
		card.twitter_user_statuses_count                         = 	media.user.statuses_count;
		card.twitter_user_created_at                             = 	media.user.created_at;
		card.twitter_user_lang                                   = 	media.user.lang;
		card.twitter_user_contributors_enabled                   = 	media.user.contributors_enabled;
		card.twitter_user_is_translator                          = 	media.user.is_translator;
		card.twitter_user_profile_background_color               = 	media.user.profile_background_color;
		card.twitter_user_profile_background_image_url           = 	media.user.profile_background_image_url;
		card.twitter_user_profile_background_image_url_https     = 	media.user.profile_background_image_url_https;
		card.twitter_user_profile_background_tile                = 	media.user.profile_background_tile;
		card.twitter_user_profile_link_color                     = 	media.user.profile_link_color;
		card.twitter_user_profile_sidebar_border_color           = 	media.user.profile_sidebar_border_color;
		card.twitter_user_profile_sidebar_fill_color             = 	media.user.profile_sidebar_fill_color;
		card.twitter_user_profile_text_color                     = 	media.user.profile_text_color;
		card.twitter_user_profile_use_background_image           = 	media.user.profile_use_background_image;
		card.twitter_user_profile_image_url                      = 	media.user.profile_image_url;
		card.twitter_user_profile_image_url_https                = 	media.user.profile_image_url_https;
		card.twitter_user_profile_banner_url                     = 	media.user.profile_banner_url;
		card.twitter_user_default_profile                        = 	media.user.default_profile;
		card.twitter_user_default_profile_image                  = 	media.user.default_profile_image;
	}
	card.twitter_retweet_count                               	 = 	media.retweet_count;
	card.twitter_favorite_count                              	 = 	media.favorite_count;
	if(media.entities){
		card.twitter_entities_hashtags                           = 	_.reduce(media.entities.hashtags,		 function(memo, obj){ /*console.log('hashtag',obj);*/ var add=''; if(memo.length){ add+=', '; } add+=obj.text; return memo + add; }, '');
		//card.twitter_entities_trends                             = 	_.reduce(media.entities.trends,			 function(memo, obj){ console.log('trend',obj); var add=''; if(memo.length){ add+=', '; } add+=obj; return memo + add; }, '');
		card.twitter_entities_urls                               = 	_.reduce(media.entities.urls,			 function(memo, obj){ /*console.log('url',obj);*/ var add=''; if(memo.length){ add+=', '; } add+=obj.url; return memo + add; }, '');
		card.twitter_entities_user_mentions                      = 	_.reduce(media.entities.user_mentions,	 function(memo, obj){ /*console.log('mentions',obj); */ var add=''; if(memo.length){ add+=', '; } add+=obj.screen_name; return memo + add; }, '');
		//card.twitter_entities_symbols                            = 	_.reduce(media.entities.symbols,		 function(memo, obj){ console.log('symbols',obj); var add=''; if(memo.length){ add+=', '; } add+=obj; return memo + add; }, '');
		card.twitter_entities_media                              = 	_.reduce(media.entities.media,			 function(memo, obj){ /*console.log('media',obj); */ var add=''; if(memo.length){ add+=', '; } add+=obj.media_url; return memo + add; }, '');
	}
	card.twitter_favorited                                   	 = 	media.favorited;
	card.twitter_retweeted                                   	 = 	media.retweeted;
	card.twitter_possibly_sensitive                          	 = 	media.possibly_sensitive;
	card.twitter_filter_level                                	 = 	media.filter_level;
	card.twitter_lang                                        	 = 	media.lang;
	card.twitter_timestamp_ms                                	 = 	media.timestamp_ms;


	

	//if(media.filter){
	//	card.twitter_filter =media.filter;
	//}
	//if(media.link){
	//	card.twitter_link =media.link;
	//}
	//if(media.username){
	//	card.twitter_user_name = media.username;
	//}
	//if(media.user){
	//	card.twitter_user_name = media.user.username;
	//	card.twitter_user_profile_picture =media.user.profile_picture;
	//	card.twitter_user_full_name =media.user.full_name;
	//	card.twitter_user_id =media.user.id;
	//}


	/*media { id: 640985817599447000,
	  id_str: '640985817599447040',
	  indices: [ 86, 108 ],
	  media_url: 'http://pbs.twimg.com/tweet_video_thumb/COU9NHwUEAAfr88.png',
	  media_url_https: 'https://pbs.twimg.com/tweet_video_thumb/COU9NHwUEAAfr88.png',
	  url: 'http://t.co/Ik1EXMSvd4',
	  display_url: 'pic.twitter.com/Ik1EXMSvd4',
	  expanded_url: 'http://twitter.com/MLBGIFs/status/640985820027949056/photo/1',
	  type: 'photo',
	  sizes:
	   { medium: { w: 480, h: 270, resize: 'fit' },
	     thumb: { w: 150, h: 150, resize: 'crop' },
	     large: { w: 480, h: 270, resize: 'fit' },
	     small: { w: 340, h: 191, resize: 'fit' } },
	  source_status_id: 640985820027949000,
	  source_status_id_str: '640985820027949056' }

	 mentions { screen_name: 'juicemanrocks',
	  name: 'Don Miller',
	  id: 24102205,
	  id_str: '24102205',
	  indices: [ 3, 17 ] }
	mentions { screen_name: 'tcjoseph',
	  name: 'Tammi Joseph',
	  id: 207267377,
	  id_str: '207267377',
	  indices: [ 19, 28 ] }
	mentions { screen_name: 'HikersHell',
	  name: 'HellHikers',
	  id: 3039475755,

	  */



	
	
	
	
	
	
	
	

	
	
	card.display='Twitter Text';
	
	if(_.intersection(approved_twitter_users_handles,[card.twitter_user_screen_name]).length){
		card.isFromPreapprovedUser=true;
	}
	if(_.intersection(banned_twitter_users_handles,[card.twitter_user_screen_name]).length){
		card.isFromBannedUser=true;
	}

	if(media.entities){
		if(media.entities.hashtags){
			_.each(media.entities.hashtags,function(obj){
				if(_.intersection(tags,[obj.text,obj.text.toLowerCase()]).length){
					card.isFromHashtag=true;
				}
			});
		}
		//if(media.entities.trends){
		//	_.each(media.entities.trends,function(obj){
		//	});
		//}
		//if(media.entities.urls){
		//	_.each(media.entities.urls,function(obj){
		//	});
		//}
		//if(media.entities.user_mentions){
		//	_.each(media.entities.user_mentions,function(obj){
		//	});
		//}
		//if(media.entities.symbols){
		//	_.each(media.entities.symbols,function(obj){
		//	});
		//}
		if(media.entities.media){
			_.each(media.entities.media,function(obj){
				if(obj.type=='photo'){

					card.display='Twitter Image';

					card.twitter_picture_id  				= obj.id;
					card.twitter_picture_id_str  			= obj.id_str;
					card.twitter_picture_media_url  		= obj.media_url;
					card.twitter_picture_media_url_https  	= obj.media_url_https;
					card.twitter_picture_url  				= obj.url;
					card.twitter_picture_display_url  		= obj.display_url;
					card.twitter_picture_expanded_url  		= obj.expanded_url;
					card.twitter_picture_type  				= obj.type;
				}
			});
		}
	}



	
	

	

	if(card.isFromBannedUser){
		card.state='rejected';
	}else if(card.isFromPreapprovedUser){
		card.state='published';
	}else{
		card.state='pending';
	}
	

	

	//if(card.twitter_video_standard_resolution_url && card.twitter_video_standard_resolution_url.length){
	//	
	//}else{
		
	//}

	card.summary=card.display+' from @'+card.twitter_user_screen_name+' saying "'+card.twitter_text+'"';

	if(card.twitter_id_str>biggest_twitter_id){
		biggest_twitter_id=card.twitter_id_str;
	}

	card.shortid=shortid.generate();
	
	card.save(function(err) {
		if (err) {

			if(err.code==11000){
				console.error("Duplicate tweet ", card.unique_media_id, media.created_at);
			}else{
				console.error("Error adding tweet ", card.unique_media_id, media.created_at, err);
			}
			
			
		} else {
			console.log("Added tweet ", card.unique_media_id, media.created_at);
		}
	});
	
	
}

module.exports =  saveMedia;



/*
id: 640961034673479700,
  id_str: '640961034673479681',
  text: 'RT @NeuvooDisMexic: Nuevo #empleo en Nestle en #CiudaddeMéxico - #Becario #Compras Empaques #empleos http://t.co/ruyxBrR6tn http://t.co/Ejd…',
  source: '<a href="http://twitter.com" rel="nofollow">Twitter Web Client</a>',
  truncated: false,
  in_reply_to_status_id: null,
  in_reply_to_status_id_str: null,
  in_reply_to_user_id: null,
  in_reply_to_user_id_str: null,
  in_reply_to_screen_name: null,
  user:
   { id: 3291824470,
     id_str: '3291824470',
     name: 'José Pastor Ugalde',
     screen_name: 'MexicoPastor',
     location: 'Celaya, Guanajuato',
     url: null,
     description: 'Noviembre de 1951, Cajeme, Cd. Obregón, Sonora.',
     protected: false,
     verified: false,
     followers_count: 1447,
     friends_count: 1740,
     listed_count: 30,
     favourites_count: 1352,
     statuses_count: 7109,
     created_at: 'Wed May 20 19:08:09 +0000 2015',
     utc_offset: null,
     time_zone: null,
     geo_enabled: false,
     lang: 'es',
     contributors_enabled: false,
     is_translator: false,
     profile_background_color: '8B542B',
     profile_background_image_url: 'http://pbs.twimg.com/profile_background_images/629669476947099648/L37beocN.jpg',
     profile_background_image_url_https: 'https://pbs.twimg.com/profile_background_images/629669476947099648/L37beocN.jpg',
     profile_background_tile: false,
     profile_link_color: '9D582E',
     profile_sidebar_border_color: '000000',
     profile_sidebar_fill_color: '000000',
     profile_text_color: '000000',
     profile_use_background_image: true,
     profile_image_url: 'http://pbs.twimg.com/profile_images/601103956333490177/gjUn7qCO_normal.png',
     profile_image_url_https: 'https://pbs.twimg.com/profile_images/601103956333490177/gjUn7qCO_normal.png',
     profile_banner_url: 'https://pbs.twimg.com/profile_banners/3291824470/1438960013',
     default_profile: false,
     default_profile_image: false,
     following: null,
     follow_request_sent: null,
     notifications: null },
  geo: null,
  coordinates: null,
  place: null,
  contributors: null,
  retweeted_status:
   { created_at: 'Mon Sep 07 18:51:42 +0000 2015',
     id: 640960653507862500,
     id_str: '640960653507862528',
     text: 'Nuevo #empleo en Nestle en #CiudaddeMéxico - #Becario #Compras Empaques #empleos http://t.co/ruyxBrR6tn http://t.co/EjdYgMBULn',
     source: '<a href="http://neuvoo.ca" rel="nofollow">seed.mytweetsys.app.t00</a>',
     truncated: false,
     in_reply_to_status_id: null,
     in_reply_to_status_id_str: null,
     in_reply_to_user_id: null,
     in_reply_to_user_id_str: null,
     in_reply_to_screen_name: null,
     user:
      { id: 3301823864,
        id_str: '3301823864',
        name: 'Jobs Distribución M',
        screen_name: 'NeuvooDisMexic',
        location: 'Mexico City, Distrito Federal',
        url: 'http://neuvoo.com.mx/trabajos/?k=Venta+al+detalle&l=Mexico+City%2C+Distrito+Federal&r=15',
        description: '¿Buscas trabajos de Venta al detalle en Mexico City? Chequea nuestra página web http://t.co/EqwxnWFiAr',
        protected: false,
        verified: false,
        followers_count: 312,
        friends_count: 965,
        listed_count: 10,
        favourites_count: 0,
        statuses_count: 3472,
        created_at: 'Thu Jul 30 19:21:19 +0000 2015',
        utc_offset: null,
        time_zone: null,
        geo_enabled: false,
        lang: 'en',
        contributors_enabled: false,
        is_translator: false,
        profile_background_color: 'C0DEED',
        profile_background_image_url: 'http://abs.twimg.com/images/themes/theme1/bg.png',
        profile_background_image_url_https: 'https://abs.twimg.com/images/themes/theme1/bg.png',
        profile_background_tile: false,
        profile_link_color: '0084B4',
        profile_sidebar_border_color: 'C0DEED',
        profile_sidebar_fill_color: 'DDEEF6',
        profile_text_color: '333333',
        profile_use_background_image: true,
        profile_image_url: 'http://pbs.twimg.com/profile_images/626835302292811776/aM3ol2ae_normal.png',
        profile_image_url_https: 'https://pbs.twimg.com/profile_images/626835302292811776/aM3ol2ae_normal.png',
        profile_banner_url: 'https://pbs.twimg.com/profile_banners/3301823864/1438284157',
        default_profile: true,
        default_profile_image: false,
        following: null,
        follow_request_sent: null,
        notifications: null },
     geo: null,
     coordinates: null,
     place: null,
     contributors: null,
     retweet_count: 1,
     favorite_count: 0,
     entities:
      { hashtags: [Object],
        trends: [],
        urls: [Object],
        user_mentions: [],
        symbols: [],
        media: [Object] },
     extended_entities: { media: [Object] },
     favorited: false,
     retweeted: false,
     possibly_sensitive: false,
     filter_level: 'low',
     lang: 'es' },
  retweet_count: 0,
  favorite_count: 0,
  entities:
   { hashtags: [ [Object], [Object], [Object], [Object], [Object] ],
     trends: [],
     urls: [ [Object] ],
     user_mentions: [ [Object] ],
     symbols: [],
     media: [ [Object] ] },
  extended_entities: { media: [ [Object] ] },
  favorited: false,
  retweeted: false,
  possibly_sensitive: false,
  filter_level: 'low',
  lang: 'es',
  timestamp_ms: '1441651993803' }
*/