//request animation frame polyfill support
(function() {
    var lastTime = 0;
    var vendors = ['ms', 'moz', 'webkit', 'o'];
    for (var x = 0; x < vendors.length && !window.requestAnimationFrame; ++x) {
        window.requestAnimationFrame = window[vendors[x] + 'RequestAnimationFrame'];
        window.cancelAnimationFrame = window[vendors[x] + 'CancelAnimationFrame'] ||
            window[vendors[x] + 'CancelRequestAnimationFrame'];
    }

    if (!window.requestAnimationFrame)
        window.requestAnimationFrame = function(callback, element) {
            var currTime = new Date().getTime();
            var timeToCall = Math.max(0, 16 - (currTime - lastTime));
            var id = window.setTimeout(function() {
                    callback(currTime + timeToCall);
                },
                timeToCall);
            lastTime = currTime + timeToCall;
            return id;
        };

    if (!window.cancelAnimationFrame)
        window.cancelAnimationFrame = function(id) {
            clearTimeout(id);
        };
}());

function msieversion() {
    var ua = window.navigator.userAgent;
    var msie = ua.indexOf("MSIE ");

    if (msie > 0 || !!navigator.userAgent.match(/Trident.*rv\:11\./)) {
        return (parseInt(ua.substring(msie + 5, ua.indexOf(".", msie))));
    }
    return false;
}

function loadScript(src, callback) {

    var script = document.createElement("script");
    script.type = "text/javascript";
    if (callback) script.onload = callback;
    document.getElementsByTagName("head")[0].appendChild(script);
    script.src = src;
}

var is_google_api_loaded = false;
var is_google_maps_api_loaded = false;

function google_maps_loaded() {
    //console.log('google_maps_loaded has been called');
    is_google_maps_api_loaded = true;
}

/**
 * A few fixes to make the storytelling section work on mobile landscape.
 * I hate this
 */
function fixStorytellingLandscape(is_mobile, is_short_width, current_slug) {

    if ((is_mobile && is_short_width == false) && current_slug == '/storytelling/') {

        // 1. Push the card 5 down
        $('#storytelling_card5_background').css('top', '0px');

        // 2. Swap cards 3 and 4 positions
        if (is_short_width == false) {
            var card3 = $('#storytelling_card3_background');
            var card4 = $('#storytelling_card4_background');
            $('#storytelling_card3_background').remove();
            $('#storytelling_card4_background').remove();
            $('#storytelling_card3').append(card4);
            $('#storytelling_card4').append(card3);
        }

        // 3. Push the footer down
        var bodyHeight = 0;
        bodyHeight += parseInt($('#storytelling_header').css('height').replace('px', ''));
        bodyHeight += parseInt($('#storytelling_card1').css('height').replace('px', '')) * 2;
        bodyHeight += parseInt($('#storytelling_card5').css('height').replace('px', ''));

        $('#footer').css('top', bodyHeight + 'px');

    }
}

/**
 * The footer position gets messed up when switching sections
 */
var already_fixed_footer = false;

function fixFooterPosition(is_mobile, current_slug) {

    if (is_mobile && current_slug != '/storytelling/') {

        var bodyHeight = parseInt($('body').css('height').replace('px', ''));

        /* After the first time, don't take into consideration the footer height */
        if (already_fixed_footer) {
            var footerHeight = parseInt($('#footer').css('height').replace('px', ''));
            bodyHeight -= footerHeight;
        } else {
            already_fixed_footer = true;
        }

        $('#footer').css('top', bodyHeight + 'px');
    }
}

//not too much here
(function() {
    //test

    var PROFILE = false;
    if (PROFILE) var global_start = new Date().getTime();


    function addScript(src) {
        var s = document.createElement('script');
        s.setAttribute('src', src);
        document.body.appendChild(s);
    }

    var dom_is_loaded = false;
    window.onload = function() { /*suspectLoop();*/
        //console.log('is loaded');
        dom_is_loaded = true;
    };

    function calc_diff(current, destination) {
        if ((destination - current) == 0) return 0;
        var diff = (destination - current) / 2;
        //var abs_diff=Math.abs(diff);
        //var max_diff=Math.abs(destination-current);

        var maxmove = 0.08 * Math.max(1, Math.abs(destination - current));
        ////console.log('maxmove=',maxmove);
        //var minmove=0.005;
        if (diff < -maxmove) diff = -maxmove;
        else if (diff > maxmove) diff = maxmove;
        //else if(diff<0 && diff>-minmove){ diff=-Math.min(minmove,max_diff); }
        //else if(diff>0 && diff< minmove){ diff= Math.min(minmove,max_diff); }

        return diff;
    }

    function hasClass(el, className) {
        if (el.classList)
            return (el.classList.contains(className));
        else
            return (new RegExp('(^| )' + className + '( |$)', 'gi').test(el.className));
    }

    function addClass(el, className) {
        ////console.log('add class ',className,' to ',el.toString());
        if (el.classList)
            el.classList.add(className);
        else
            el.className += ' ' + className;
    }

    function add_class_to_list(elements, className) {
        Array.prototype.forEach.call(elements, function(element_el, i) { /*suspectLoop();*/

            addClass(element_el, className);
        });
    }

    function remove(el) {
        el.innerHTML = '';
        if (el.parentNode) {
            el.parentNode.removeChild(el);
        }

    }

    function remove_from_list(elements) {
        if (elements && elements.length) {
            Array.prototype.forEach.call(elements, function(element_el, i) { /*suspectLoop();*/
                ////console.log('remove',element_el.toString());
                remove(element_el);
            });
        }

    }




    var is_ready = false;

    var ready = function() {

        is_ready = true;
        if (PROFILE) console.log('Ready in: ' + ((new Date().getTime()) - global_start) + 'ms');

        //var updater_subscriptions_object={};
        //var updater_subscriptions_array=[];

        function closest_above(list, value) {
            var i = list.length - 2;
            while (i >= 0 && list[i] >= value) {
                i--;
            }
            return list[i + 1];
        }

        function calc_stoppoint(value) {
            return Math.ceil(value / 20) * 20;
        }


        var images_being_loaded = [];

        function add_image_being_loaded(el) {
            images_being_loaded.push({
                el: el,
                completed: false
            });
        }

        function check_images_being_loaded_percent() {

            var count_total = 0;
            var count_loaded = 0;

            Array.prototype.forEach.call(images_being_loaded, function(img, i) {

                count_total++;

                if (!img.completed) {
                    img.completed = img.el[0].complete;
                }
                if (img.completed) {
                    count_loaded++;
                }

            });

            if (count_total == 0) {
                return 1;
            }
            var images_pc = count_loaded / count_total;
            ////console.log('images_pc=',images_pc);
            return images_pc;

        }

        var ua = navigator.userAgent;

        //USER AGENT DETECTIONS
        var is_android = !!(ua.match(/Android/i));
        var is_blackberry = !!(ua.match(/BlackBerry/i));
        var is_iPhone = !!(ua.match(/iPhone/i));
        var is_iPhone4_or_less = !!(is_iPhone && window.screen.height <= 480);
        var is_iPhone5_or_more = !!(is_iPhone && window.screen.height > 480);
        var is_iPad = !!(ua.match(/iPad/i));
        var is_iPod = !!(ua.match(/iPod/i));
        var is_chromeIOS = !!(ua.match('CriOS'));
        var is_iOS = !!(is_iPhone || is_iPad || is_iPod || is_chromeIOS);
        var is_opera = !!(ua.match(/Opera Mini/i));
        var is_ie_mobile = !!(ua.match(/IEMobile/i));
        var smallScreenWidth = 568;

        var msie_version = msieversion();
        var is_internet_explorer = !(msie_version === false);

        var is_chrome = false;
        var is_safari = false;
        var ua = ua.toLowerCase();
        if (ua.indexOf('safari') != -1) {
            if (ua.indexOf('chrome') > -1) {
                is_chrome = true;
            } else {
                is_safari = true;
            }
        }
        var is_mobile = is_android || is_blackberry || is_iOS || is_opera || is_ie_mobile || (is_internet_explorer && msie_version <= 9);
        var is_desktop = !is_mobile;
        var is_short_width = $(window).width() < smallScreenWidth;

        var everything;

        var count_primary_inits = 0;
        var primary_initializations_completed = false;

        function run_primary_initializations() {
            count_primary_inits++;
            switch (count_primary_inits) {

                case 1:
                    //console.log('initialization ',count_primary_inits,' add mobile classes')

                    if (is_short_width) {
                        remove_from_list(document.querySelectorAll('.desktop-only'));
                    } else {
                        remove_from_list(document.querySelectorAll('.mobile-only'));
                    }

                    break;

                case 2:


                    break;

                case 3:


                    break;

                case 4:

                    menu.el.style.display = "none";

                    break;

                case 5:

                    everything = document.querySelectorAll('body,section,div,ul,li,video,img,span,a,h1,h2,h3,h4,h5');

                    //console.log('initialization ',count_primary_inits,' remove unused device content');
                    if (is_desktop) {
                        add_class_to_list(everything, 'desktop');
                    }
                    if (is_mobile) {
                        add_class_to_list(everything, 'mobile');
                    }
                    if (is_short_width) {
                        add_class_to_list(everything, 'short-width');
                    }

                    break;

                case 6:
                    //console.log('initialization ',count_primary_inits,' replace mobiles texts')
                    if (is_short_width) {
                        $('.mobile-text').each(function() {
                            $(this).html($(this).attr('data-mobile-text'));
                        })
                    }
                    break;

                case 7:
                    //console.log('initialization ',count_primary_inits,' replace hashtag texts');

                    var hashtag_regular_expression = /(\S*#\[[^\]]+\])|(\S*#\S+)/gi;
                    $('.replace-hashtags').each(function() {

                        var str_old = $(this).html() + '';
                        var str_new = str_old.replace(hashtag_regular_expression, function(t) {
                            return '<em>' + t + '</em>';
                        });
                        if (str_new == str_old) {
                            //do nothing
                        } else {
                            $(this).html(str_new);
                        }
                    });
                    break;

                case 8:
                    //console.log('initialization ',count_primary_inits,' replace links');

                    var link_regular_expression = /(https?:\/\/[^\s]+)/g;
                    $('.replace-links').each(function() {
                        var str_old = $(this).html() + '';

                        ////console.log('str_old',str_old);

                        var str_new = str_old.replace(link_regular_expression, function(t) {
                            return '<em>' + t + '</em>';
                        });
                        if (str_new == str_old) {
                            //do nothing
                        } else {
                            $(this).html(str_new);
                        }
                    });
                    break;

                case 9:
                    //console.log('initialization ',count_primary_inits,' run main resize handler');
                    main_resize_handler(); //this already loads backgrounds
                    break;

                case 10:
                    //console.log('initialization ',count_primary_inits,' ask to preload initial sections');

                    $('.header_brand').each(function() {
                        var header_brand_el = $(this);
                        image_load(header_brand_el);
                    });


                    var count = 0;
                    $.each(cards, function(key, card) {

                        if (count < count_cards_showing) {
                            ////console.log('load card ',count);
                            card.load();
                        }
                        count++;
                    });

                    //addScript('https://maps.googleapis.com/maps/api/js');
                    //loadScript('http://maps.googleapis.com/maps/api/js?v=3&sensor=false&callback=google_maps_loaded', function(){
                    //    //console.log('google-loader has been loaded, but not the maps-API ');
                    //    is_google_api_loaded=true;
                    //});

                    loadScript('//maps.googleapis.com/maps/api/js?sensor=false&callback=google_maps_loaded', function() {
                        //console.log('google-loader has been loaded, but not the maps-API ');
                        is_google_api_loaded = true;
                    });

                    break;
                case 11:
                    primary_initializations_completed = true;
                    break;
            }
        }

        function moveProductsLeft() {
            // if (window.innerWidth <= 1024) {
            //     $('#more-products-left').hide();
            //     $('#more-products-right').show();
            // } else {
            //     $('#more-products-left').hide();
            //     $('#more-products-right').hide();
            // }

            /* Tablets */
            if (window.innerWidth > 420 && window.innerWidth <= 1024) {
                $('#products_name1').show();
                $('#products_name2').show();
                $('#products_name3').show();
                $('#products_name4').hide();
                $('#products_name5').hide();
                $('#products_name6').hide();
                $('#products_name7').show();
                $('#products_name8').show();
                $('#products_name9').show();
                $('#products_name10').hide();
                $('#products_name11').hide();
                $('#products_name12').hide();
            }
        }

        function moveProductsRight() {
            if (productsPage == 0) {
                var imageWidth = parseInt($('#products_background').css('width').replace('px', ''));
                if (window.innerWidth <= 667) {
                    imageWidth -= 36;
                }
                $('#products_background').css('left', (-imageWidth / 2) + 'px');
            }
            productsPage = 1;

            // if (window.innerWidth <= 1024) {
            //     $('#more-products-left').show();
            //     $('#more-products-right').hide();
            // } else {
            //     $('#more-products-left').hide();
            //     $('#more-products-right').hide();
            // }

            /* Tablets */
            if (window.innerWidth > 420 && window.innerWidth <= 1024) {
                $('#products_name1').hide();
                $('#products_name2').hide();
                $('#products_name3').hide();
                $('#products_name4').show();
                $('#products_name5').show();
                $('#products_name6').show();
                $('#products_name7').show();
                $('#products_name8').show();
                $('#products_name9').show();
                $('#products_name10').show();
                $('#products_name11').show();
                $('#products_name12').show();
            }
        }

        var check_products_visibility;

        var count_secondary_inits = 0;
        var secondary_initializations_completed = false;

        var productsPage = 0;

        function run_secondary_initializations() {
            count_secondary_inits++;
            switch (count_secondary_inits) {

                case 1:

                    // $('#more-products-left').on('click', function() {
                    //     moveProductsLeft();
                    // });

                    // $('#more-products-right').on('click', function() {
                    //     moveProductsRight();
                    // });

                    $('.products_zoom,.products_button,.products_symbol').on('click', function(e) {
                        var product = parseInt($(this).attr('rel'));
                        // console.log(product);
                        var target = $(e.target);

                        /* Product id map */
                        // if (window.innerWidth <= 1024 && productsPage == 1 && target.attr('class').indexOf('products_button') == -1) {
                        //   if (product == 4) {
                        //     product = 1;
                        //   } else if (product == 3) {
                        //     product = 5;
                        //   } else if (product == 2) {
                        //     product = 6;
                        //   }
                        // }

                        /* Product section setup: last 2 flavors don't have the play video button */
                        if (product == 5 || product == 6) {
                            $('#view-product-video').hide();
                            $('#products_more_info').css('left', '0');
                            $('#products_more_info').css('margin-left', 'auto');
                            $('#products_more_info').css('margin-right', 'auto');
                        } else {
                            $('#view-product-video').show();
                            $('#products_more_info').css('left', 'auto');
                            $('#products_more_info').css('margin-left', '0');
                            $('#products_more_info').css('margin-right', '0');
                        }

                        if(product == 10 || product == 11 || product == 12) {
                            $('#products_more_info').hide();
                            // $('#products_nutritional').css({top: '20%'});
                        } else {
                            $('#products_more_info').show();
                            // $('#products_nutritional').css({top: ((230/614)*100)+'%'});
                        }

                        sections.products_detail.open(product);
                    });

                    break;

                case 2:
                    //console.log('initialization ',count_secondary_inits,' replace mobiles texts')
                    $('#products_close').on('mousedown', function() {
                        if (nutritional_opened) {
                            nutritional_opened = false;
                            $('#products_navigation_animation').fadeIn();
                            $('.products_nutritional').fadeOut();
                        } else {
                            sections.products_detail.close();

                        }
                    });

                    $('#products_more_info').on('mousedown', function() {
                        current_subsection = parseInt(current_product);

                        console.log(current_subsection);
                    });

                    /* Click to load a new video */
                    $('#view-product-video').on('mousedown', function() {
                        var videoToWatch = parseInt(current_product);
                        clickToWatchVideo(videoToWatch, is_iOS);
                    });
                    break;

                case 3:

                    //console.log('initialization ',count_secondary_inits,' remove unused device content');
                    sections.products_detail.el.each(function() {
                        $(this).find('.products_bullet').on('touchstart mousedown', function() {
                            sections.products_detail.change_background($(this).attr('rel'));
                        });
                    });

                    break;

                case 4:
                    //console.log('initialization ',count_secondary_inits,' replace hashtag texts');
                    $('.card .card_share').on('mousedown', function() {
                        share($(this).closest('.card'));
                    });

                    $('#footer').find('li').on('mousedown', function() {
                        if (current_subsection) {
                            current_subsection_back_to_path = $(this).attr('data-href');
                            current_subsection = null;
                        } else {
                            animating_globalScrollTop = true;

                            globalScrollTop_destination = Math.min(body.height_value - browserHeight, sections[$(this).attr('rel')].top_value);

                            if (is_mobile) {
                                globalScrollTop = globalScrollTop_old = globalScrollTop_eased = globalScrollTop_eased_rounded = globalScrollTop_eased_rounded_old = $(window).scrollTop(); //globalScrollTop_destination;;
                            }
                        }

                    });

                    $('#header_more').on('mousedown', function() {
                        clickToWatchVideo(0, is_iOS);
                    });

                    if (grid_slider) {
                        var cardsTouchHandler = function(event) {
                            //window.alert('touch handler');
                            //console.log('productBackgroundTouchHandler()',event);
                            var touch;
                            if (typeof event !== 'undefined') {

                                //event.preventDefault();

                                if (typeof event.touches !== 'undefined') {
                                    touch = event.touches[0];

                                    switch (event.type) {
                                        case 'touchstart':
                                            last_touch = {
                                                x: touch.pageX,
                                                y: touch.pageY
                                            }
                                            break;
                                        case 'touchmove':
                                            //event.preventDefault();

                                            if (last_touch) {
                                                accumulated_touch.x += touch.pageX - last_touch.x;
                                                accumulated_touch.y += touch.pageY - last_touch.y;


                                                if (Math.abs(accumulated_touch.y) > 100) {

                                                    accumulated_touch = {
                                                        x: 0,
                                                        y: 0,
                                                    };
                                                    last_touch = false;

                                                    //console.log('accumulated_touch reset')


                                                } else if (accumulated_touch.x > 100) {

                                                    accumulated_touch = {
                                                        x: 0,
                                                        y: 0,
                                                    };
                                                    last_touch = false;

                                                    grid_slider.prev();

                                                } else if (accumulated_touch.x < -100) {

                                                    accumulated_touch = {
                                                        x: 0,
                                                        y: 0,
                                                    };
                                                    last_touch = false;

                                                    grid_slider.next();
                                                }

                                                //console.log('accumulated_touch',accumulated_touch.x,accumulated_touch.y);
                                            }

                                            break;
                                        case 'touchend':
                                            accumulated_touch = {
                                                x: 0,
                                                y: 0,
                                            }
                                            last_touch = false;
                                        default:
                                            break;
                                    }
                                }
                            }
                        }

                        $('#cards')[0].addEventListener('touchstart', cardsTouchHandler, false);
                        $('#cards')[0].addEventListener('touchmove', cardsTouchHandler, false);
                        $('#cards')[0].addEventListener('touchend', cardsTouchHandler, false);
                    }

                    $('.harmonizacoes_header_more').on('mousedown', function() {
                        animating_globalScrollTop = true;

                        var section_el = $(this).closest('.harmonizacoes_header')
                        var section_id = section_el.attr('id');
                        //console.log('section_id=',section_id);
                        var receita_id = 'recipe_harmonizacoes_' + sections[section_id].subsection;
                        //console.log('receita_id=',receita_id);
                        globalScrollTop_destination = Math.min(body.height_value - browserHeight, sections[receita_id].top_value);

                        if (is_mobile) {
                            globalScrollTop = globalScrollTop_old = globalScrollTop_eased = globalScrollTop_eased_rounded = globalScrollTop_eased_rounded_old = $(window).scrollTop(); //globalScrollTop_destination;
                        }
                    });
                    break;

                case 9:
                    bind_products_background(sections.products_detail.background_1, '1', false, 0);
                    break;

                case 10:
                    bind_products_background(sections.products_detail.background_2, '2', false, 0);
                    break;

                case 11:
                    bind_products_background(sections.products_detail.background_3, '3', false, 0);
                    break;

                case 12:
                    bind_products_background(sections.products_detail.background_4, '4', false, 0);
                    bind_products_background(sections.products_detail.background_5, '5', false, 0);
                    bind_products_background(sections.products_detail.background_6, '6', false, 0);
                    bind_products_background(sections.products_detail.background_7, '7', false, 0);
                    bind_products_background(sections.products_detail.background_8, '8', false, 0);
                    bind_products_background(sections.products_detail.background_9, '9', false, 0);
                    bind_products_background(sections.products_detail.background_10, '10', false, 0);
                    bind_products_background(sections.products_detail.background_11, '11', false, 0);
                    bind_products_background(sections.products_detail.background_12, '12', false, 0);
                    break;
                case 13:
                    initialize_products_controls();

                    if (!is_short_width) {
                        $('.recipe_info_image').each(function() {
                            var recipe_info_image_el = $(this);
                            image_load(recipe_info_image_el);
                        });
                    }


                    break;
                case 14:
                    //console.log('initialization ',count_secondary_inits);
                    $('.show_more').on('touchstart mousedown', function() {

                        var show_more = $(this);

                        grid.show_more();

                        if ((count_cards_showing + grid.cards_per_line) <= count_cards_total) {
                            show_more.show();
                        } else {
                            show_more.hide();
                        }
                    });
                    break;
                case 15:
                    $('.card video').each(function() {
                        var card = $(this).closest('.card');
                        var table = card.find('.table');

                        table.on('click', function() {
                            var video = card.find('video');
                            var play_button = card.find('.card_play');

                            if (video.length) {
                                if (video.is('.initialized')) {

                                    //play_button.fadeOut();
                                } else {

                                    video.addClass('initialized');

                                    video[0].autoplay = true;
                                    video[0].src = video[0].getAttribute('data-src');


                                    video[0].addEventListener('paused', function() {
                                        video.removeClass('playing');
                                        play_button.fadeIn();
                                    });

                                    video[0].addEventListener('playing', function() {
                                        video.addClass('playing');
                                        play_button.fadeOut();
                                    });
                                }
                            }
                            if (video.is('.playing')) {
                                video.removeClass('playing');
                                video[0].currentTime = 0;
                                video[0].pause();
                                play_button.fadeIn();
                            } else {
                                video.addClass('playing');
                                video[0].currentTime = 0;
                                video[0].play();
                                play_button.fadeOut();
                            }
                        });
                    });
                    break;

                case 16:
                    check_products_visibility = function() {
                        // if (current_product <= 1) {
                        //     opacity($('#products_previous'), 0.2);
                        // } else {
                        //     opacity($('#products_previous'), 1);
                        // }

                        // if (current_product >= 6) {
                        //     opacity($('#products_next'), 0.2);
                        // } else {
                        //     opacity($('#products_next'), 1);
                        // }

                        $('#products_selected').text($('#products_name' + current_product).text());

                        products_background.update_destination(current_product - 1)
                    }

                    check_products_visibility();

                    $('#products_selected').on('mousedown', function() {
                        sections.products_detail.open('' + current_product);
                    });

                    if (is_short_width) {
                        $('#products_background').on('mousedown', function() {
                            /* Due to the new product order, we need to map it to the new values */
                            var intendedProduct = current_product;
                            // if (current_product == 4) {
                            //     intendedProduct = 1;
                            // } else if (current_product == 3) {
                            //     intendedProduct = 2;
                            // } else if (current_product == 2) {
                            //     intendedProduct = 3;
                            // } else if (current_product == 1) {
                            //     intendedProduct = 4;
                            // }

                            /* Product section setup: last 2 flavors don't have the play video button */
                            if (intendedProduct == 5 || intendedProduct == 6) {
                                $('#view-product-video').hide();
                                $('#products_more_info').css('top', '40px');
                            } else {
                                $('#view-product-video').show();
                                // $('#products_more_info').css('top', '0px');
                            }

                            if(intendedProduct == 10 || intendedProduct == 11 || intendedProduct == 12) {
                                $('#products_more_info').hide();
                                // $('#products_nutritional').css({top: '20%'});
                            } else {
                                $('#products_more_info').show();
                                // $('#products_nutritional').css({top: ((230/614)*100)+'%'});
                            }

                            sections.products_detail.open('' + intendedProduct);
                        });
                    }

                    // $('#products_previous').on('mousedown', function() {
                    //     if (current_product > 1) {
                    //         current_product--;
                    //     }

                    //     check_products_visibility();
                    // });

                    // $('#products_next').on('mousedown', function() {
                    //     if (current_product < 6) {
                    //         current_product++;
                    //     }
                    //     check_products_visibility();
                    // });

                    if (grid_slider) {
                        $('#cards_previous').on('mousedown touchstart', function(evt) {
                            if (grid_slider) {
                                evt.preventDefault();
                                grid_slider.prev();
                            }
                        });

                        $('#cards_next').on('mousedown touchstart', function(evt) {
                            if (grid_slider) {
                                evt.preventDefault();
                                grid_slider.next();
                            }
                        });
                    }
                    break;
                case 17:
                    $('#products_nutritional').on('mousedown', function() {
                        if (!nutritional_opened) {
                            nutritional_opened = true;
                            $('#products_nutritional_' + current_product).hide();
                            $('#products_nutritional_' + current_product).fadeIn();
                            $('#products_navigation_animation').fadeOut();
                        }
                    });

                    allow_body_size = true;
                    body.commit();

                    break;
                case 18:
                    //console.log('initialization ',count_secondary_inits);
                    force_render_paralax_once = true;


                    $('#header_sanduiche,#header_aba').on('mousedown', function(evt) {
                        //console.log('open menu');
                        //evt.preventDefault();
                        menu.open();
                        return false;

                    });

                    $('#menu_close').on('mousedown', function(evt) {
                        //console.log('close menu');
                        //evt.preventDefault();
                        menu.close();
                        return false;
                    });

                    $('.menu-link').click(function(evt) {
                        //console.log('go to menu item');
                        //evt.preventDefault();
                        menu.close();

                        if (current_subsection) {
                            current_subsection_back_to_path = $(this).attr('href');
                            current_subsection = null;
                        } else {
                            go_to_path($(this).attr('href'), true);
                        }
                        return false;
                    });

                    break;
                case 19:
                    //console.log('initialization ',count_secondary_inits);
                    current_slug = window.location.pathname;
                    //console.log('current_slug',current_slug);
                    go_to_path(current_slug, true);

                    force_render_paralax_once = true;
                    break;
                case 20:
                    //console.log('initialization ',count_secondary_inits);
                    animating_globalScrollTop = true;
                    force_render_paralax_once = true;
                    break;
                case 21:
                    animating_globalScrollTop = true;
                    force_render_paralax_once = true;
                    secondary_initializations_completed = true;
                    break;
            }
        }

        var current_subsection = null;
        var current_subsection_old = null;
        var current_subsection_back_to_path = null;

        function go_to_path(path, instantly) {
            console.log(path);

            var rel = 'header';
            switch (path) {
                case '/':
                    rel = 'header';
                    current_subsection = null;
                    break;
                case '/storytelling':
                case '/storytelling/':
                    rel = 'header';
                    current_subsection = 5;
                    break;
                case '/la_mia_gelateria':
                case '/la_mia_gelateria/':
                    rel = 'wall';
                    current_subsection = null;
                    break;
                case '/isapori':
                case '/isapori/':
                    sections.products_detail.close();
                    rel = 'products';
                    current_subsection = null;
                    break;
                case '/cioccolato_nero':
                case '/cioccolato_nero/':
                    sections.products_detail.open('1');
                    rel = 'products';
                    current_subsection = null;
                    break;
                case '/vaniglia':
                case '/vaniglia/':
                    sections.products_detail.open('2');
                    rel = 'products';
                    current_subsection = null;
                    break;
                case '/caramello_salato':
                case '/caramello_salato/':
                    sections.products_detail.open('3');
                    rel = 'products';
                    current_subsection = null;
                    break;
                case '/limoncello':
                case '/limoncello/':
                    sections.products_detail.open('4');
                    rel = 'products';
                    current_subsection = null;
                    break;
                case '/pistacchio':
                case '/pistacchio/':
                    sections.products_detail.open('5');
                    rel = 'products';
                    current_subsection = null;
                    break;
                case '/panna_cotta':
                case '/panna_cotta/':
                    sections.products_detail.open('6');
                    rel = 'products';
                    current_subsection = null;
                    break;
                case '/gianduia':
                case '/gianduia/':
                    sections.products_detail.open('7');
                    rel = 'products';
                    current_subsection = null;
                    break;
                case '/fragola':
                case '/fragola/':
                    sections.products_detail.open('8');
                    rel = 'products';
                    current_subsection = null;
                    break;
                case '/cappuccino':
                case '/cappuccino/':
                    sections.products_detail.open('9');
                    rel = 'products';
                    current_subsection = null;
                    break;
                case '/limoncello_picole':
                case '/limoncello_picole/':
                    sections.products_detail.open('10');
                    rel = 'products';
                    current_subsection = null;
                    break;
                case '/pisctacchio_picole':
                case '/pisctacchio_picole/':
                    sections.products_detail.open('11');
                    rel = 'products';
                    current_subsection = null;
                    break;
                case '/fragola_picole':
                case '/fragola_picole/':
                    sections.products_detail.open('12');
                    rel = 'products';
                    current_subsection = null;
                    break;
                case '/harmonizacoes_cioccolato_nero':
                case '/harmonizacoes_cioccolato_nero/':
                    rel = 'harmonizacoes';
                    current_subsection = 2;
                    break;
                case '/harmonizacoes_vaniglia':
                case '/harmonizacoes_vaniglia/':
                    rel = 'harmonizacoes';
                    current_subsection = 1;
                    break;
                case '/harmonizacoes_caramello_salato':
                case '/harmonizacoes_caramello_salato/':
                    rel = 'harmonizacoes';
                    current_subsection = 3;
                    break;
                case '/harmonizacoes_limoncello':
                case '/harmonizacoes_limoncello/':
                    rel = 'harmonizacoes';
                    current_subsection = 4;
                    break;
                case '/harmonizacoes_pistacchio':
                case '/harmonizacoes_pistacchio/':
                    rel = 'harmonizacoes';
                    current_subsection = 5;
                    break;
                case '/harmonizacoes_panna_cotta':
                case '/harmonizacoes_panna_cotta/':
                    rel = 'harmonizacoes';
                    current_subsection = 6;
                    break;
                case '/harmonizacoes_gianduia':
                case '/harmonizacoes_gianduia/':
                    rel = 'harmonizacoes';
                    current_subsection = 7;
                    break;
                case '/harmonizacoes_fragola':
                case '/harmonizacoes_fragola/':
                    rel = 'harmonizacoes';
                    current_subsection = 8;
                    break;
                case '/harmonizacoes_cappuccino':
                case '/harmonizacoes_cappuccino/':
                    rel = 'harmonizacoes';
                    current_subsection = 9;
                    break;
                case '/harmonizacoes_limoncello_picole':
                case '/harmonizacoes_limoncello_picole/':
                    rel = 'harmonizacoes';
                    current_subsection = 10;
                    break;
                case '/harmonizacoes_pisctacchio_picole':
                case '/harmonizacoes_pisctacchio_picole/':
                    rel = 'harmonizacoes';
                    current_subsection = 11;
                    break;
                case '/harmonizacoes_fragola_picole':
                case '/harmonizacoes_fragola_picole/':
                    rel = 'harmonizacoes';
                    current_subsection = 12;
                    break;
                case '/dove_trovare':
                case '/dove_trovare/':
                    rel = 'buy';
                    current_subsection = null;
                    break;
                default:
                    rel = 'header';
                    current_subsection = null;
                    break;
            }

            animating_globalScrollTop = true;

            if (!sections[rel]) {
                //console.log('not found ',rel);
                globalScrollTop_destination = 0;
                return;
            }

            globalScrollTop_destination = Math.min(body.height_value - browserHeight, sections[rel].top_value);

            if (rel == 'products') {
                globalScrollTop_destination -= Math.round((browserHeight - sections[rel].height_value) / 2);
            }

            //console.log('go_to_path=',rel,globalScrollTop_destination)

            if (instantly) {
                globalScrollTop = globalScrollTop_old = globalScrollTop_eased = globalScrollTop_eased_rounded = globalScrollTop_eased_rounded_old = globalScrollTop_destination;;
            } else if (is_mobile) {
                globalScrollTop = globalScrollTop_old = globalScrollTop_eased = globalScrollTop_eased_rounded = globalScrollTop_eased_rounded_old = $(window).scrollTop(); //globalScrollTop_destination;;
            }
        }

        var current_slug = window.location.pathname;

        function popstate(evt) {
            if (!intro_completed) return false;

            //console.log('hash changed to ',evt.state)
            if (current_slug !== window.location.pathname) {
                //console.log('need to go to url ',window.location.pathname);
                current_slug = window.location.pathname;
                go_to_path(current_slug);
            }
            evt.preventDefault();
        }

        window.addEventListener("popstate", popstate);

        if (is_internet_explorer) {
            if (msie_version <= 9) {
                //console.log('is internet explorer');
                var transform_x_y_not_3d = function(el, translateX, translateY) {
                    el[0].style.msTransform = 'translate(' + Math.round(translateX) + 'px, ' + Math.round(translateY) + 'px)';
                }
                var transform_x_y = function(el, translateX, translateY) {
                    el[0].style.msTransform = 'translate(' + Math.round(translateX) + 'px, ' + Math.round(translateY) + 'px)';
                }
                var transform_x_y_percent = function(el, translateX, translateY) {
                    el[0].style.msTransform = 'translate(' + Math.round(translateX * 100) / 100 + '%, ' + Math.round(translateY * 100) / 100 + '%)';
                }
                var transform_x_y_vwvh = function(el, translateX, translateY) {
                    el[0].style.msTransform = 'translate(' + Math.round(translateX * 100) / 100 + 'vw, ' + Math.round(translateY * 100) / 100 + 'vh)';
                }
                var transform_y = function(el, translateY) {
                    el[0].style.msTransform = 'translate(0, ' + Math.round(translateY) + 'px)';
                }
                var transform_y_scale = function(el, translateY, scale) {
                    el[0].style.msTransform = 'translate(0, ' + Math.round(translateY) + 'px) scale(' + Math.round(scale * 200) / 200 + ') ';
                }
                var transform_y_scale_rotate = function(el, translateY, scale, degrees) {
                    el[0].style.msTransform = 'translate(0, ' + Math.round(translateY) + 'px) scale(' + Math.round(scale * 200) / 200 + ') rotate(' + Math.round(degrees * 360) / 360 + 'deg)';
                }
                var transform_x_y_scale_rotate = function(el, translateX, translateY, scale, degrees) {
                    el[0].style.msTransform = 'translate(' + translateX + 'px, ' + Math.round(translateY) + 'px) scale(' + Math.round(scale * 200) / 200 + ') rotate(' + Math.round(degrees * 360) / 360 + 'deg)';
                }
            } else {
                //console.log('is internet explorer');
                var transform_x_y_not_3d = function(el, translateX, translateY) {
                    el[0].style.msTransform = 'translate(' + Math.round(translateX) + 'px, ' + Math.round(translateY) + 'px)';
                }

                var transform_x_y = function(el, translateX, translateY) {
                    el[0].style.msTransform = 'translate(' + Math.round(translateX) + 'px, ' + Math.round(translateY) + 'px) translate3d(0px, 0px, 0px)';
                }
                var transform_x_y_percent = function(el, translateX, translateY) {
                    el[0].style.msTransform = 'translate(' + Math.round(translateX * 100) / 100 + '%, ' + Math.round(translateY * 100) / 100 + '%) translate3d(0px, 0px, 0px)';
                }
                var transform_x_y_vwvh = function(el, translateX, translateY) {
                    el[0].style.msTransform = 'translate(' + Math.round(translateX * 100) / 100 + 'vw, ' + Math.round(translateY * 100) / 100 + 'vh) translate3d(0px, 0px, 0px)';
                }
                var transform_y = function(el, translateY) {
                    el[0].style.msTransform = 'translate(0, ' + Math.round(translateY) + 'px) translate3d(0px, 0px, 0px)';
                }
                var transform_y_scale = function(el, translateY, scale) {
                    el[0].style.msTransform = 'translate(0, ' + Math.round(translateY) + 'px) scale(' + Math.round(scale * 200) / 200 + ')  translate3d(0px, 0px, 0px)';
                }
                var transform_y_scale_rotate = function(el, translateY, scale, degrees) {
                    el[0].style.msTransform = 'translate(0, ' + Math.round(translateY) + 'px) scale(' + Math.round(scale * 200) / 200 + ') rotate(' + Math.round(degrees * 360) / 360 + 'deg) translate3d(0px, 0px, 0px)';
                }
                var transform_x_y_scale_rotate = function(el, translateX, translateY, scale, degrees) {
                    el[0].style.msTransform = 'translate(' + translateX + 'px, ' + Math.round(translateY) + 'px) scale(' + Math.round(scale * 200) / 200 + ') rotate(' + Math.round(degrees * 360) / 360 + 'deg) translate3d(0px, 0px, 0px)';
                }
            }

        } else if (is_safari) {
            var transform_x_y_not_3d = function(el, translateX, translateY) {
                el[0].style.webkitTransform = 'translate(' + Math.round(translateX) + 'px, ' + Math.round(translateY) + 'px)';
            }

            var transform_x_y = function(el, translateX, translateY) {
                el[0].style.webkitTransform = 'translate(' + Math.round(translateX) + 'px, ' + Math.round(translateY) + 'px) translate3d(0px, 0px, 0px)';
            }
            var transform_x_y_percent = function(el, translateX, translateY) {
                el[0].style.webkitTransform = 'translate(' + Math.round(translateX * 100) / 100 + '%, ' + Math.round(translateY * 100) / 100 + '%) translate3d(0px, 0px, 0px)';
            }
            var transform_x_y_vwvh = function(el, translateX, translateY) {
                el[0].style.webkitTransform = 'translate(' + Math.round(translateX * 100) / 100 + 'vw, ' + Math.round(translateY * 100) / 100 + 'vh) translate3d(0px, 0px, 0px)';
            }
            var transform_y = function(el, translateY) {
                el[0].style.webkitTransform = 'translate(0, ' + Math.round(translateY) + 'px) translate3d(0px, 0px, 0px)';
            }
            var transform_y_scale = function(el, translateY, scale) {
                el[0].style.webkitTransform = 'translate(0, ' + Math.round(translateY) + 'px) scale(' + Math.round(scale * 200) / 200 + ')  translate3d(0px, 0px, 0px)';
            }
            var transform_y_scale_rotate = function(el, translateY, scale, degrees) {
                el[0].style.webkitTransform = 'translate(0, ' + Math.round(translateY) + 'px) scale(' + Math.round(scale * 200) / 200 + ') rotate(' + Math.round(degrees * 360) / 360 + 'deg) translate3d(0px, 0px, 0px)';
            }
            var transform_x_y_scale_rotate = function(el, translateX, translateY, scale, degrees) {
                el[0].style.webkitTransform = 'translate(' + translateX + 'px, ' + Math.round(translateY) + 'px) scale(' + Math.round(scale * 200) / 200 + ') rotate(' + Math.round(degrees * 360) / 360 + 'deg) translate3d(0px, 0px, 0px)';
            }
        } else {
            var transform_x_y_not_3d = function(el, translateX, translateY) {
                el[0].style.transform = 'translate(' + Math.round(translateX) + 'px, ' + Math.round(translateY) + 'px)';
            }

            var transform_x_y = function(el, translateX, translateY) {
                el[0].style.transform = 'translate(' + Math.round(translateX) + 'px, ' + Math.round(translateY) + 'px) translate3d(0px, 0px, 0px)';
            }
            var transform_x_y_percent = function(el, translateX, translateY) {
                el[0].style.transform = 'translate(' + Math.round(translateX) + '%, ' + Math.round(translateY) + '%) translate3d(0px, 0px, 0px)';
            }
            var transform_x_y_vwvh = function(el, translateX, translateY) {
                el[0].style.transform = 'translate(' + Math.round(translateX) + 'vw, ' + Math.round(translateY) + 'vh) translate3d(0px, 0px, 0px)';
            }
            var transform_y = function(el, translateY) {
                el[0].style.transform = 'translate(0, ' + Math.round(translateY) + 'px) translate3d(0px, 0px, 0px)';
            }
            var transform_y_scale = function(el, translateY, scale) {
                el[0].style.transform = 'translate(0, ' + Math.round(translateY) + 'px) scale(' + Math.round(scale * 200) / 200 + ')  translate3d(0px, 0px, 0px)';
            }
            var transform_y_scale_rotate = function(el, translateY, scale, degrees) {
                el[0].style.transform = 'translate(0, ' + Math.round(translateY) + 'px) scale(' + Math.round(scale * 200) / 200 + ') rotate(' + Math.round(degrees * 360) / 360 + 'deg) translate3d(0px, 0px, 0px)';
            }
            var transform_x_y_scale_rotate = function(el, translateX, translateY, scale, degrees) {
                el[0].style.transform = 'translate(' + translateX + 'px, ' + Math.round(translateY) + 'px) scale(' + Math.round(scale * 200) / 200 + ') rotate(' + Math.round(degrees * 360) / 360 + 'deg) translate3d(0px, 0px, 0px)';
            }
        }

        var opacity = function(el, value) {
            el[0].style.opacity = Math.max(0, Math.min(1, value));
        }

        var dpr = window.devicePixelRatio || 1;

        var supported_dpr_values = [0.75, 1.0, 1.3, 1.5, 2.0, 3.0];
        var dpr_used;
        var dpr_string

        function calc_dpr() {
            //dpr_used = closest_above(supported_dpr_values, dpr);
            //dpr_string = dpr_used.toString();
            //if (dpr_string.match(/^\d+$/)) dpr_string += ".0";

            dpr_used = 1.0;
            dpr_string = '1.0';
        }
        //calc_dpr();

        var image_load = function(image_el) {

            if (is_short_width) {
                var data_attr_name = 'mobile-data-src';
            } else {
                var data_attr_name = 'desktop-data-src';
            }

            var image_src = image_el[0].getAttribute(data_attr_name);

            if ((image_src.split('.png').length > 1)) {
                image_src = image_src.replace(/\bf_auto\b/g, 'f_png');
            } else {
                image_src = image_src.replace(/\bf_auto\b/g, 'f_jpg');
            }
            image_el[0].setAttribute('src', image_src);

            add_image_being_loaded(image_el);

        }


        function cover_container_by_replacing_if_needed(image_el, container_width, container_height) {

            if (container_width == undefined || container_height == undefined) {
                var rect = image_el.parentNode.getBoundingClientRect();
                if (container_width == undefined) {
                    container_width = rect.right - rect.left;
                }

                if (container_height == undefined) {
                    container_height = rect.bottom - rect.top;
                }
            }

            if (container_width == 0) return; //problem
            if (container_height == 0) return; //problem

            /**
             * storytelling_fix
             * This is a list of image elements that should not be treated under the general rule.
             * I'm doing this to make the text in the Storytelling section more readable in the new
             * landscape mode.
             * The only other possible way to do it would be making this site again from scratch.
             */
            var imageExceptions = [
                'storytelling_card2_background',
                'storytelling_card3_background',
                'storytelling_card4_background',
            ];
            var isElementException = imageExceptions.indexOf(image_el.id) >= 0;

            if ((is_mobile && isElementException) || is_short_width) {

                var data_src_attr_name = 'mobile-data-src';
                var data_width_attr_name = 'mobile-data-original-width';
                var data_height_attr_name = 'mobile-data-original-height';

            } else {

                var data_src_attr_name = 'desktop-data-src';
                var data_width_attr_name = 'desktop-data-original-width';
                var data_height_attr_name = 'desktop-data-original-height';

            }

            var original_width = image_el.getAttribute(data_width_attr_name); ////console.log('original_width=',original_width);
            var original_height = image_el.getAttribute(data_height_attr_name); ////console.log('original_height=',original_height);
            var original_ratio = original_width / original_height; ////console.log('original_ratio=',original_ratio);
            var available_space_width = container_width; ////console.log('available_space_width=',available_space_width);
            var available_space_height = container_height; ////console.log('available_space_height=',available_space_height);
            var available_space_ratio = available_space_width / available_space_height; ////console.log('available_space_ratio=',available_space_ratio);
            var to_be_covered_space_width = available_space_width; ////console.log('to_be_covered_space_width=',to_be_covered_space_width);
            var to_be_covered_space_height = available_space_height; ////console.log('to_be_covered_space_height=',to_be_covered_space_height);
            var to_be_covered_space_ratio = to_be_covered_space_width / to_be_covered_space_height; ////console.log('to_be_covered_space_ratio=',to_be_covered_space_ratio);

            var image_width = Math.ceil(cover_width / 20) * 20;;
            var image_height = Math.ceil(cover_height / 20) * 20;;

            if (original_ratio <= to_be_covered_space_ratio) {
                var requested_width = Math.ceil(to_be_covered_space_width / 320) * 320; ////console.log('requested_width=',requested_width);
                var requested_height = Math.ceil(requested_width / original_ratio); ////console.log('requested_height=',requested_height);
            } else {
                var requested_height = Math.ceil(to_be_covered_space_height / 180) * 180; ////console.log('requested_height=',requested_height);
                var requested_width = Math.ceil(requested_height * original_ratio); ////console.log('requested_width=',requested_width);
            }

            requested_width = Math.round(requested_width * dpr_used);
            requested_height = Math.round(requested_height * dpr_used);
            if (requested_width >= original_width || requested_height >= original_height) {
                requested_width = original_width;
                requested_height = original_height;
            }


            var requested_ratio = requested_width / requested_height; ////console.log('requested_ratio=',requested_ratio);

            if (requested_ratio <= to_be_covered_space_ratio) {
                var cover_width = (to_be_covered_space_width); ////console.log('cover_width=',cover_width);
                var cover_height = cover_width / requested_ratio; ////console.log('cover_height=',cover_height);
            } else {
                var cover_height = (to_be_covered_space_height); ////console.log('cover_height=',cover_height);
                var cover_width = cover_height * requested_ratio; ////console.log('cover_width=',cover_width);
            }
            var cover_offset_x = cover_width - available_space_width; //console.log('cover_offset_x=',cover_offset_x);
            var cover_offset_y = cover_height - available_space_height; //console.log('cover_offset_y=',cover_offset_y);

            var image_src = image_el.getAttribute(data_src_attr_name); //TODO cache this?
            if (!image_src) {
                // console.log('image_src null for ', image_el, ' using ', data_src_attr_name);
            }

            /* Replacing backgrounds with landscape specific ones */
            var landscapeReplacements = [
                'storytelling_header_background',
                'storytelling_card5_background',
            ];
            var isSrcException = landscapeReplacements.indexOf(image_el.id) >= 0;

            if (is_mobile && is_short_width == false && isSrcException) {

                /* Landscape image ratios */
                var landscapeRatio = 632 / 1136;

                if (image_el.id == 'storytelling_header_background') {

                    var imageElement = $(image_el);
                    imageElement.attr('src', '../images/storytelling-header-landscape.jpg');
                    var headerSectionHeight = parseInt($('#storytelling_header').css('height').replace('px', ''));
                    imageElement.css('height', headerSectionHeight + 'px');
                    var imageWidth = headerSectionHeight / landscapeRatio;
                    imageElement.css('width', imageWidth + 'px');
                    var imageOffset = (browserWidth - imageWidth) / 2;
                    imageElement.css('left', imageOffset + 'px');

                } else if (image_el.id == 'storytelling_card5_background') {

                    var imageElement = $(image_el);
                    imageElement.attr('src', '../images/storytelling-products-landscape.jpg');

                    var headerSectionHeight = parseInt($('#storytelling_card5').css('height').replace('px', ''));
                    imageElement.css('height', headerSectionHeight + 'px');
                    var imageWidth = headerSectionHeight / landscapeRatio;
                    imageElement.css('width', imageWidth + 'px');
                    var imageOffset = (browserWidth - imageWidth) / 2;
                    imageElement.css('left', imageOffset + 'px');

                }

            } else {
                image_src = image_src.replace(/\bw_auto\b/g, "w_" + requested_width);
                image_src = image_src.replace(/\bh_auto\b/g, "h_" + requested_height);
                image_src = image_src.replace(/\bdpr_auto\b/g, "dpr_1.0"); //+ dpr_string

                if ((image_src.split('.png').length > 1)) {
                    image_src = image_src.replace(/\bf_auto\b/g, 'f_png');
                } else {
                    image_src = image_src.replace(/\bf_auto\b/g, 'f_jpg');
                }

                if (!(image_el.getAttribute('src') == image_src)) {

                    image_el.setAttribute('data-requested-width', requested_width);
                    image_el.setAttribute('data-requested-height', requested_height);

                    image_el.setAttribute('src', '');
                    image_el.setAttribute('src', image_src);

                }

                image_el.setAttribute('width', Math.ceil(cover_width));
                image_el.setAttribute('height', Math.ceil(cover_height));
                image_el.style.width = Math.ceil(cover_width) + 'px';
                image_el.style.height = Math.ceil(cover_height) + 'px';
                image_el.style.left = -Math.round(cover_offset_x / 2) + 'px';
                image_el.style.top = -Math.round(cover_offset_y / 2) + 'px';
            }

            /**
             * Several fixes to make the Storytelling section work on mobile landscape
             */
            fixStorytellingLandscape(is_mobile, is_short_width, current_slug);
        }

        /*
        function cover_container_only_by_resizing(video_el,container_width,container_height){


          if(container_width==undefined || container_height==undefined){
          var rect = video_el.parentNode.getBoundingClientRect();
            if(container_width==undefined){
                container_width=rect.right-rect.left;
              }

              if(container_height==undefined){
                container_height=rect.bottom-rect.top;
              }
          }

          if (container_width == 0) return;   //problem
            if (container_height == 0) return;  //problem

            var requested_width=video_el.getAttribute('data-requested-width');            ////console.log('requested_width=',requested_width);
              var requested_height=video_el.getAttribute('data-requested-height');            ////console.log('requested_height=',requested_height);
              var requested_ratio=requested_width/requested_height;                   ////console.log('requested_ratio=',requested_ratio);
              var available_space_width=container_width;                      ////console.log('available_space_width=',available_space_width);
              var available_space_height=container_height;                    ////console.log('available_space_height=',available_space_height);
        var available_space_ratio=available_space_width/available_space_height;       ////console.log('available_space_ratio=',available_space_ratio);
        var to_be_covered_space_width=available_space_width;                ////console.log('to_be_covered_space_width=',to_be_covered_space_width);
              var to_be_covered_space_height=available_space_height;                ////console.log('to_be_covered_space_height=',to_be_covered_space_height);
        var to_be_covered_space_ratio=to_be_covered_space_width/to_be_covered_space_height; ////console.log('to_be_covered_space_ratio=',to_be_covered_space_ratio);
              if(requested_ratio<=to_be_covered_space_ratio){
                  var cover_width=Math.ceil(to_be_covered_space_width);                   ////console.log('cover_width=',cover_width);
                  var cover_height=Math.ceil((to_be_covered_space_width)/requested_ratio);          ////console.log('cover_height=',cover_height);
              }else{
                  var cover_height=Math.ceil(to_be_covered_space_height);                 ////console.log('cover_height=',cover_height);
                  var cover_width=Math.ceil((to_be_covered_space_height)*requested_ratio);          ////console.log('cover_width=',cover_width);
              }
              var cover_offset_x=cover_width-available_space_width;                 ////console.log('cover_offset_x=',cover_offset_x);
              var cover_offset_y=cover_height-available_space_height;               ////console.log('cover_offset_y=',cover_offset_y);


        if(!video_el.getAttribute('src') || !video_el.getAttribute('src').length){
          var video_src = video_el.getAttribute('data-src'); //TODO cache this?
              //var video_width = calc_stoppoint(container_width);
              //var video_height = calc_stoppoint(container_height);
              //video_src = video_src.replace(/\bw_auto\b/g, "w_" + video_width);
              //video_src = video_src.replace(/\bh_auto\b/g, "h_" + video_height);
              //video_src = video_src.replace(/\bdpr_auto\b/g, "dpr_" + dpr_string);

              if(!( video_el.getAttribute('src') == video_src)){
                video_el.setAttribute('src', '');
                video_el.setAttribute('src', video_src);
                video_el.load(); ////console.log('get video to load on first resize');

              }
        }

            video_el.style.width=Math.ceil(cover_width)+'px';
            video_el.style.height=Math.ceil(cover_height)+'px',
            video_el.style.top=Math.round(-cover_offset_y/2)+'px';
            video_el.style.left=Math.round(-cover_offset_x/2)+'px';
        }
        */

        var image_cover_container = function(image_el, container_width, container_height) {


            //console.log('image_cover_container ',image_el[0].getAttribute('src'),container_width,container_height)
            cover_container_by_replacing_if_needed(image_el[0], container_width, container_height);

            //if(is_short_width){
            //  var data_attr_name = 'mobile-data-src';
            //}else{
            //  var data_attr_name = 'desktop-data-src';
            //}
            //var image_src = image_el[0].getAttribute(data_attr_name); ////console.log('image_src=',image_src);
            //var image_width = calc_stoppoint(container_width); ////console.log('image_width=',image_width);
            //var image_height = calc_stoppoint(container_height);
            //
            //image_src = image_src.replace(/\bw_auto\b/g, "w_" + image_width);
            //image_src = image_src.replace(/\bh_auto\b/g, "h_" + image_height);
            //image_src = image_src.replace(/\bdpr_auto\b/g, "dpr_" + dpr_string);
            //
            //image_el[0].setAttribute('src', image_src);
            //image_el[0].style.width=image_width+'px';
            //image_el[0].style.height=image_height+'px';
            //image_el[0].style.left=(-Math.round((image_width-container_width)/2))+'px';
            //image_el[0].style.top=(-Math.round((image_height-container_height)/2))+'px';

            add_image_being_loaded(image_el);


        }

        function hasClass(el, className) {
            if (el.classList)
                return (el.classList.contains(className));
            else
                return (new RegExp('(^| )' + className + '( |$)', 'gi').test(el.className));
        }


        var needs_resize = false;
        $(window).resize(function() {
            needs_resize = true;
        });


        var allow_body_size = false;

        var body = {
            el: $('#body'),
            width_value: 0,
            height_value: 0,
            commit: function() {
                this.el[0].style.height = this.height_value + 'px';
            }

        }



        //var wrapper = {
        //  el: $('#wrapper'),
        //}

        //remove-pattern//var pattern = {
        //remove-pattern//  el: $('#pattern'),
        //remove-pattern//  width_value: 0,
        //remove-pattern//  height_value: 0,
        //remove-pattern//}



        var sections = {};

        //remove-pattern//sections.pattern= {
        //remove-pattern//  visible:true,
        //remove-pattern//  active:true,
        //remove-pattern//  el: $('#pattern'),
        //remove-pattern//  background: $('#pattern_background'),
        //remove-pattern//  get_background_width_value: function(){ return this.width_value},
        //remove-pattern//  get_background_height_value: function(){ return this.height_value},
        //remove-pattern//  accumulate: false,
        //remove-pattern//  //commit_el_width: function(){ this.el[0].style.width=this.width_value+'px'; },
        //remove-pattern//  calc_height: function(){ this.height_value=browserHeight+152+152; },
        //remove-pattern//  commit_el_height: function(){ this.el[0].style.height=this.height_value+'px'; },
        //remove-pattern//  always_visible:true,
        //remove-pattern//  active:true,
        //remove-pattern//  height_value: 0,
        //remove-pattern//  width_value: 0,
        //remove-pattern//  top_value: 0,
        //remove-pattern//  middle_value: 0,
        //remove-pattern//  bottom_value: 0,
        //remove-pattern//  parallaxed_top: 0,
        //remove-pattern//  parallaxed_bottom: 0,
        //remove-pattern//  get_parallax_diff: function(top,middle,bottom){ return -((Math.max(0,top-sections.wall.height_value)%152)); },
        //remove-pattern//  reposition_internal_elements: function(top,middle,bottom){
        //remove-pattern//
        //remove-pattern//  },
        //remove-pattern//  commit_parallax: function(top,middle,bottom,hide){
        //remove-pattern//    transform_y(this.el, this.parallaxed_diff );
        //remove-pattern//    this.reposition_internal_elements(top,middle,bottom);
        //remove-pattern//  },
        //remove-pattern//};

        sections.header = {
            visible: true,
            active: true,
            el: $('#header'),
            background: $('#header_background'),
            get_background_width_value: function() {
                return this.width_value
            },
            get_background_height_value: function() {
                return this.height_value
            },
            accumulate: true,

            //height_auto:true,
            calc_height: function() {

                if (is_short_width) {

                    this.height_value = Math.max(browserHeight, 480);

                } else if (is_mobile && is_short_width == false && window.innerWidth < 740) {

                    /* Mobile landscape header height */
                    this.height_value = 420;

                } else {

                    this.height_value = browserHeight;
                    if (this.height_min && this.height_value < this.height_min) {
                        this.height_value = this.height_min;
                    }
                }

            },
            height_ratio: 698 / 1440,
            height_min: 698,

            commit_el_width: function() {
                this.el[0].style.width = this.width_value + 'px';
            },
            commit_el_height: function() {
                this.el[0].style.height = this.height_value + 'px';
            },

            height_value: 0,
            width_value: 0,
            top_value: 0,
            middle_value: 0,
            bottom_value: 0,
            parallaxed_top: 0,
            parallaxed_bottom: 0,
            get_parallax_diff: function(top, middle, bottom) {
                return -top;
            }, //-(top-this.top_value)/2;

            el_title: $('#header_title'),
            el_text: $('#header_text'),
            el_play: $('#header_play'),

            el_title_scale: 1,
            el_text_scale: 1,
            el_play_scale: 1,

            afterResize: function() {

                if (is_mobile && is_short_width == false) {

                    /* Mobile landscape */
                    this.el_title_scale = 0.7;
                    /* Header background on landscape mode*/
                    this.background.attr('src', '../images/header-landscape.jpg');

                    /* Calculate the new image dimensions */
                    var imageWidth = 1136;
                    var imageHeight = 637;
                    var bgWidth = this.height_value * imageWidth / imageHeight;
                    var leftOffset = (bgWidth - browserWidth) / 2;

                    this.background.css('width', bgWidth);
                    this.background.css('left', -leftOffset + 'px');

                } else {
                    this.el_title_scale = Math.min(1, browserWidth / (680 + 35 + 35));
                    if (is_short_width && this.el_title_scale > 0.6) {
                        this.el_title_scale = 0.6;
                    }
                }

                transform_x_y_scale_rotate(this.el_title, 0, 0, this.el_title_scale, 0);
            },

            //el_button: $('#header_button'),
            reposition_internal_elements: function(top, middle, bottom) {
                var diff = this.top_value - top;
                diff_abs = Math.abs(diff);

                var y_value = -(diff / 20)
                transform_x_y_scale_rotate(this.el_title, 0, y_value, this.el_title_scale, 0);
                transform_x_y_scale_rotate(this.el_text, 0, y_value, this.el_text_scale, 0);
                transform_x_y_scale_rotate(this.el_play, 0, y_value, this.el_play_scale, 0);

                var opacity_value = 1.5 - diff_abs / 500;
                opacity(this.el_title, opacity_value);
                opacity(this.el_text, opacity_value);
                opacity(this.el_play, opacity_value);

            },
            commit_parallax: function(top, middle, bottom, hide) {
                transform_y(this.el, this.parallaxed_diff);
                this.reposition_internal_elements(top, middle, bottom);
            },
        };




        $('#storytelling_header').each(function() {
            var section_el = $(this);
            var section_id = section_el.attr('id');
            var section_subsection = 5;

            sections[section_id] = {
                visible: true,
                active: true,
                el: section_el,
                background: section_el.find('img.background'),
                get_background_width_value: function() {
                    return this.width_value
                },
                get_background_height_value: function() {
                    return this.height_value
                },
                accumulate: true,
                subsection: section_subsection,

                //height_auto:true,
                calc_height: function() {

                    if (is_short_width) {
                        this.height_value = Math.max(browserHeight, 480);
                    } else if (is_mobile && is_short_width == false) {

                        if (browserWidth <= 660) {
                            this.height_value = 360;
                        } else {
                            this.height_value = 430;
                        }


                    } else {
                        this.height_value = browserHeight;
                        //this.height_value=Math.round(browserWidth*this.height_ratio);
                        if (this.height_min && this.height_value < this.height_min) {
                            this.height_value = this.height_min;
                        }
                    }
                },
                //height_ratio: 698/1440,
                height_min: 600,
                commit_el_width: function() {
                    this.el[0].style.width = this.width_value + 'px';
                },
                commit_el_height: function() {
                    this.el[0].style.height = this.height_value + 'px'
                },
                height_value: 0,
                width_value: 0,
                top_value: 0,
                middle_value: 0,
                bottom_value: 0,
                parallaxed_top: 0,
                parallaxed_bottom: 0,
                get_parallax_diff: function(top, middle, bottom) {
                    return -top;
                }, //-(top-this.top_value)/2;
                afterResize: function() {},
                reposition_internal_elements: function(top, middle, bottom) {},
                commit_parallax: function(top, middle, bottom, hide) {
                    transform_y(this.el, this.parallaxed_diff);
                    //this.reposition_internal_elements(top,middle,bottom);
                },
            };
        });

        $('#storytelling_card1').each(function() {
            var section_el = $(this);
            var section_id = section_el.attr('id');
            var section_subsection = 5;

            sections[section_id] = {
                visible: true,
                active: true,
                el: section_el,
                background: section_el.find('img.background'),
                get_background_width_value: function() {
                    return this.width_value
                },
                get_background_height_value: function() {
                    return this.height_value
                },
                accumulate: is_short_width,
                subsection: section_subsection,

                //height_auto:true,
                calc_height: function() {

                    if (is_short_width) {
                        //this.height_value=Math.max(browserHeight,480);
                        this.width_value = browserWidth;
                        this.height_value = browserWidth;
                    } else {
                        this.width_value = browserWidth / 2;
                        this.height_value = browserWidth / 2;
                        //this.height_value=Math.round(browserWidth*this.height_ratio);
                        if (this.height_min && this.height_value < this.height_min) {
                            this.height_value = this.height_min;
                        }
                    }

                },
                //height_ratio: 698/1440,
                height_min: 1,
                commit_el_width: function() {
                    this.el[0].style.width = this.width_value + 'px';
                },
                commit_el_height: function() {
                    this.el[0].style.height = this.height_value + 'px';
                },
                height_value: 0,
                width_value: 0,
                top_value: 0,
                middle_value: 0,
                bottom_value: 0,
                parallaxed_top: 0,
                parallaxed_bottom: 0,
                get_parallax_diff: function(top, middle, bottom) {
                    return -top;
                }, //-(top-this.top_value)/2;
                afterResize: function() {},
                reposition_internal_elements: function(top, middle, bottom) {},
                commit_parallax: function(top, middle, bottom, hide) {
                    transform_y(this.el, this.parallaxed_diff);
                    //this.reposition_internal_elements(top,middle,bottom);
                },
            };
        });

        $('#storytelling_card2').each(function() {
            var section_el = $(this);
            var section_id = section_el.attr('id');
            var section_subsection = 5;

            sections[section_id] = {
                visible: true,
                active: true,
                el: section_el,
                background: section_el.find('img.background'),
                get_background_width_value: function() {
                    return this.width_value
                },
                get_background_height_value: function() {
                    return this.height_value
                },
                accumulate: true,
                subsection: section_subsection,

                //height_auto:true,
                calc_height: function() {

                    if (is_short_width) {
                        //this.height_value=Math.max(browserHeight,480);
                        this.width_value = browserWidth;
                        this.height_value = browserWidth;
                    } else {
                        this.width_value = browserWidth / 2;
                        this.height_value = browserWidth / 2;
                        //this.height_value=Math.round(browserWidth*this.height_ratio);
                        if (this.height_min && this.height_value < this.height_min) {
                            this.height_value = this.height_min;
                        }
                    }

                },
                //height_ratio: 698/1440,
                height_min: 1,
                commit_el_width: function() {
                    this.el[0].style.width = this.width_value + 'px';
                },
                commit_el_height: function() {
                    this.el[0].style.height = this.height_value + 'px';
                },
                height_value: 0,
                width_value: 0,
                top_value: 0,
                middle_value: 0,
                bottom_value: 0,
                parallaxed_top: 0,
                parallaxed_bottom: 0,
                get_parallax_diff: function(top, middle, bottom) {
                    return -top;
                }, //-(top-this.top_value)/2;
                afterResize: function() {},
                reposition_internal_elements: function(top, middle, bottom) {},
                commit_parallax: function(top, middle, bottom, hide) {
                    transform_y(this.el, this.parallaxed_diff);
                    //this.reposition_internal_elements(top,middle,bottom);
                },
            };
        });

        $('#storytelling_card3').each(function() {
            var section_el = $(this);
            var section_id = section_el.attr('id');
            var section_subsection = 5;

            sections[section_id] = {
                visible: true,
                active: true,
                el: section_el,
                background: section_el.find('img.background'),
                get_background_width_value: function() {
                    return this.width_value
                },
                get_background_height_value: function() {
                    return this.height_value
                },
                accumulate: is_short_width,
                subsection: section_subsection,

                //height_auto:true,
                calc_height: function() {

                    if (is_short_width) {
                        //this.height_value=Math.max(browserHeight,480);
                        this.width_value = browserWidth;
                        this.height_value = browserWidth;
                    } else {
                        this.width_value = browserWidth / 2;
                        this.height_value = browserWidth / 2;
                        //this.height_value=Math.round(browserWidth*this.height_ratio);
                        if (this.height_min && this.height_value < this.height_min) {
                            this.height_value = this.height_min;
                        }
                    }

                },
                //height_ratio: 698/1440,
                height_min: 1,
                commit_el_width: function() {
                    this.el[0].style.width = this.width_value + 'px';
                },
                commit_el_height: function() {
                    this.el[0].style.height = this.height_value + 'px';
                },
                height_value: 0,
                width_value: 0,
                top_value: 0,
                middle_value: 0,
                bottom_value: 0,
                parallaxed_top: 0,
                parallaxed_bottom: 0,
                get_parallax_diff: function(top, middle, bottom) {
                    return -top;
                }, //-(top-this.top_value)/2;
                afterResize: function() {},
                reposition_internal_elements: function(top, middle, bottom) {},
                commit_parallax: function(top, middle, bottom, hide) {
                    transform_y(this.el, this.parallaxed_diff);
                    //this.reposition_internal_elements(top,middle,bottom);
                },
            };
        });

        $('#storytelling_card4').each(function() {
            var section_el = $(this);
            var section_id = section_el.attr('id');
            var section_subsection = 5;

            sections[section_id] = {
                visible: true,
                active: true,
                el: section_el,
                background: section_el.find('img.background'),
                get_background_width_value: function() {
                    return this.width_value
                },
                get_background_height_value: function() {
                    return this.height_value
                },
                accumulate: true,
                subsection: section_subsection,

                //height_auto:true,
                calc_height: function() {

                    if (is_short_width) {
                        //this.height_value=Math.max(browserHeight,480);
                        this.width_value = browserWidth;
                        this.height_value = browserWidth;
                    } else {
                        this.width_value = browserWidth / 2;
                        this.height_value = browserWidth / 2;
                        //this.height_value=Math.round(browserWidth*this.height_ratio);
                        if (this.height_min && this.height_value < this.height_min) {
                            this.height_value = this.height_min;
                        }
                    }

                },
                //height_ratio: 698/1440,
                height_min: 1,
                commit_el_width: function() {
                    this.el[0].style.width = this.width_value + 'px';
                },
                commit_el_height: function() {
                    this.el[0].style.height = this.height_value + 'px';
                },
                height_value: 0,
                width_value: 0,
                top_value: 0,
                middle_value: 0,
                bottom_value: 0,
                parallaxed_top: 0,
                parallaxed_bottom: 0,
                get_parallax_diff: function(top, middle, bottom) {
                    return -top;
                }, //-(top-this.top_value)/2;
                afterResize: function() {},
                reposition_internal_elements: function(top, middle, bottom) {},
                commit_parallax: function(top, middle, bottom, hide) {
                    transform_y(this.el, this.parallaxed_diff);
                    //this.reposition_internal_elements(top,middle,bottom);
                },
            };
        });



        $('#storytelling_card5').each(function() {
            var section_el = $(this);
            var section_id = section_el.attr('id');
            var section_subsection = 5;

            sections[section_id] = {
                visible: true,
                active: true,
                el: section_el,
                background: section_el.find('img.background'),
                get_background_width_value: function() {
                    return this.width_value
                },
                get_background_height_value: function() {
                    return this.height_value
                },
                accumulate: true,
                subsection: section_subsection,

                //height_auto:true,
                calc_height: function() {

                    if (is_short_width) {
                        //this.height_value=Math.max(browserHeight,480);
                        this.height_value = Math.round(browserWidth * (943 / 640));
                    } else if (is_mobile && is_short_width == false) {
                        if (browserWidth <= 660) {
                            this.height_value = 360;
                        } else {
                            this.height_value = 430;
                        }
                    } else {
                        //this.width_value=browserWidth/2;
                        //this.height_value=browserWidth/2;
                        this.height_value = Math.round(browserWidth * (1276 / 2556));
                    }

                },
                commit_el_width: function() {
                    this.el[0].style.width = this.width_value + 'px';
                },
                commit_el_height: function() {
                    this.el[0].style.height = this.height_value + 'px';
                },
                height_value: 0,
                width_value: 0,
                top_value: 0,
                middle_value: 0,
                bottom_value: 0,
                parallaxed_top: 0,
                parallaxed_bottom: 0,
                get_parallax_diff: function(top, middle, bottom) {
                    return -top;
                }, //-(top-this.top_value)/2;
                afterResize: function() {},
                reposition_internal_elements: function(top, middle, bottom) {},
                commit_parallax: function(top, middle, bottom, hide) {
                    transform_y(this.el, this.parallaxed_diff);
                    //this.reposition_internal_elements(top,middle,bottom);
                },
            };
        });




        $('.harmonizacoes_header').each(function() {
            var section_el = $(this);
            var section_id = section_el.attr('id');
            var section_subsection = 0;
            if (section_id == 'header_harmonizacoes_1') {
                section_subsection = 1;
            } else if (section_id == 'header_harmonizacoes_2') {
                section_subsection = 2;
            } else if (section_id == 'header_harmonizacoes_3') {
                section_subsection = 3;
            } else if (section_id == 'header_harmonizacoes_4') {
                section_subsection = 4;
            } else if (section_id == 'header_harmonizacoes_5') {
                section_subsection = 5;
            } else if (section_id == 'header_harmonizacoes_6') {
                section_subsection = 6;
            } else if (section_id == 'header_harmonizacoes_7') {
                section_subsection = 7;
            } else if (section_id == 'header_harmonizacoes_8') {
                section_subsection = 8;
            } else if (section_id == 'header_harmonizacoes_9') {
                section_subsection = 9;
            } else if (section_id == 'header_harmonizacoes_10') {
                section_subsection = 10;
            } else if (section_id == 'header_harmonizacoes_11') {
                section_subsection = 11;
            } else if (section_id == 'header_harmonizacoes_12') {
                section_subsection = 12;
            }

            sections[section_id] = {
                visible: true,
                active: true,
                el: section_el,
                background: section_el.find('img.background'),
                get_background_width_value: function() {
                    return this.width_value
                },
                get_background_height_value: function() {
                    return this.height_value
                },
                accumulate: true,
                subsection: section_subsection,

                //height_auto:true,
                calc_height: function() {

                    if (is_short_width) {
                        this.height_value = Math.max(browserHeight, 480);
                    } else if (is_mobile && is_short_width == false) {

                        /** Mobile landscape: section height is sligtly shorter for the image to fit better */
                        var backgroundImageRatio = 1445 / 720;
                        var landscapeBackgrounds = $('.harmonizacoes_header_background_image');
                        var buttons = $('.harmonizacoes_header_more');

                        for (var i = 0; i < landscapeBackgrounds.length; i++) {

                            var landscapeBackground = $(landscapeBackgrounds[i]);

                            var backgroundHeight = 430;
                            landscapeBackground.css('height', backgroundHeight + 'px');

                            var backgroundWidth = Math.round(this.height_value * backgroundImageRatio);
                            landscapeBackground.css('width', backgroundWidth + 'px');

                            /** Set the section height according to the background image height */
                            this.height_value = Math.round(browserWidth * this.height_ratio);
                            if (this.height_min && this.height_value < this.height_min) {
                                this.height_value = backgroundHeight;
                            }

                            /** Button height (can't use media queries for this because this structure sucks) */
                            var button = $(buttons[i]);
                            button.css('top', 'auto');
                            button.css('bottom', '20px');
                        }
                    } else {
                        this.height_value = browserHeight;
                        //this.height_value=Math.round(browserWidth*this.height_ratio);
                        if (this.height_min && this.height_value < this.height_min) {
                            this.height_value = this.height_min;
                        }
                    }
                },
                height_ratio: 698 / 1440,
                height_min: 698,

                commit_el_width: function() {
                    this.el[0].style.width = this.width_value + 'px';
                },
                commit_el_height: function() {
                    this.el[0].style.height = this.height_value + 'px';
                },

                height_value: 0,
                width_value: 0,
                top_value: 0,
                middle_value: 0,
                bottom_value: 0,
                parallaxed_top: 0,
                parallaxed_bottom: 0,
                get_parallax_diff: function(top, middle, bottom) {
                    return -top;
                }, //-(top-this.top_value)/2;

                el_title: section_el.find('#harmonizacoes_header_title'),
                el_text: section_el.find('#harmonizacoes_header_text'),
                el_more: section_el.find('#harmonizacoes_header_more'),

                el_title_scale: 1,
                el_text_scale: 1,
                el_more_scale: 1,

                afterResize: function() {
                    //this.el_title_scale=Math.min(1,browserWidth/(680+35+35));
                    //transform_x_y_scale_rotate(this.el_title, 0,  0, this.el_title_scale, 0 );
                },

                //el_button: $('#header_button'),
                reposition_internal_elements: function(top, middle, bottom) {
                    var diff = this.top_value - top;
                    diff_abs = Math.abs(diff);

                    var y_value = -(diff / 20)
                    transform_x_y_scale_rotate(this.el_title, 0, y_value, this.el_title_scale, 0);
                    transform_x_y_scale_rotate(this.el_text, 0, y_value, this.el_text_scale, 0);
                    transform_x_y_scale_rotate(this.el_more, 0, y_value, this.el_more_scale, 0);

                    var opacity_value = 1.5 - diff_abs / 500;
                    opacity(this.el_title, opacity_value);
                    opacity(this.el_text, opacity_value);
                    opacity(this.el_more, opacity_value);
                },
                commit_parallax: function(top, middle, bottom, hide) {
                    transform_y(this.el, this.parallaxed_diff);
                    this.reposition_internal_elements(top, middle, bottom);
                },
            };
        });



        $('.harmonizacoes_capsules').each(function() {
            var section_el = $(this);
            var section_id = section_el.attr('id');
            var section_subsection = 0;

            if (section_id == 'capsules_harmonizacoes_1') {
                section_subsection = 1;
            } else if (section_id == 'capsules_harmonizacoes_2') {
                section_subsection = 2;
            } else if (section_id == 'capsules_harmonizacoes_3') {
                section_subsection = 3;
            } else if (section_id == 'capsules_harmonizacoes_4') {
                section_subsection = 4;
            } else if (section_id == 'capsules_harmonizacoes_5') {
                section_subsection = 5;
            } else if (section_id == 'capsules_harmonizacoes_6') {
                section_subsection = 6;
            } else if (section_id == 'capsules_harmonizacoes_7') {
                section_subsection = 7;
            } else if (section_id == 'capsules_harmonizacoes_8') {
                section_subsection = 8;
            } else if (section_id == 'capsules_harmonizacoes_9') {
                section_subsection = 9;
            } else if (section_id == 'capsules_harmonizacoes_10') {
                section_subsection = 10;
            } else if (section_id == 'capsules_harmonizacoes_11') {
                section_subsection = 11;
            } else if (section_id == 'capsules_harmonizacoes_12') {
                section_subsection = 12;
            }

            sections[section_id] = {
                visible: true,
                active: true,
                el: section_el,
                background: section_el.find('img.background'),
                get_background_width_value: function() {
                    return this.width_value
                },
                get_background_height_value: function() {
                    return this.height_value
                },
                accumulate: true,
                subsection: section_subsection,

                //height_auto:true,
                calc_height: function() {

                    if (is_short_width) {
                        this.height_value = Math.round(browserWidth * this.height_ratio);
                        if (this.height_min && this.height_value < 195) {
                            this.height_value = 195;
                        }
                        //this.height_value=Math.max(browserHeight,300);
                    } else if (is_mobile && is_short_width == false) {

                        /** Better height to make the content fit properly */
                        this.height_value = 300;

                    } else {
                        //this.height_value=browserHeight;
                        this.height_value = Math.round(browserWidth * this.height_ratio);
                        if (this.height_min && this.height_value < this.height_min) {
                            this.height_value = this.height_min;
                        }
                    }

                },
                height_ratio: 380 / 1280,
                height_min: 380,

                commit_el_width: function() {
                    this.el[0].style.width = this.width_value + 'px';
                },
                commit_el_height: function() {
                    this.el[0].style.height = this.height_value + 'px';
                },

                height_value: 0,
                width_value: 0,
                top_value: 0,
                middle_value: 0,
                bottom_value: 0,
                parallaxed_top: 0,
                parallaxed_bottom: 0,
                get_parallax_diff: function(top, middle, bottom) {
                    return -top;
                }, //-(top-this.top_value)/2;

                //el_title: section_el.find('#harmonizacoes_header_title'),
                //el_text: section_el.find('#harmonizacoes_header_text'),
                //el_more: section_el.find('#harmonizacoes_header_more'),

                //el_title_scale: 1,
                //el_text_scale:  1,
                //el_more_scale:  1,

                afterResize: function() {
                    //this.el_title_scale=Math.min(1,browserWidth/(680+35+35));
                    //transform_x_y_scale_rotate(this.el_title, 0,  0, this.el_title_scale, 0 );
                },

                //el_button: $('#header_button'),
                reposition_internal_elements: function(top, middle, bottom) {
                    //var diff=this.top_value-top;
                    //diff_abs=Math.abs(diff);

                    //var y_value=-(diff/20)
                    //transform_x_y_scale_rotate(this.el_title, 0,  y_value, this.el_title_scale, 0 );
                    //transform_x_y_scale_rotate(this.el_text,  0,  y_value, this.el_text_scale, 0 );
                    //transform_x_y_scale_rotate(this.el_more,  0,  y_value, this.el_more_scale, 0 );
                    //
                    //var opacity_value=1.5-diff_abs/500;
                    //opacity(this.el_title, opacity_value);
                    //opacity(this.el_text,  opacity_value);
                    //opacity(this.el_more,  opacity_value);
                },
                commit_parallax: function(top, middle, bottom, hide) {
                    transform_y(this.el, this.parallaxed_diff);
                    //this.reposition_internal_elements(top,middle,bottom);
                },
            };
        });


        $('.harmonizacoes_recipe').each(function() {
            var section_el = $(this);
            var section_id = section_el.attr('id');
            var section_subsection = 0;
            if (section_id == 'recipe_harmonizacoes_1') {
                section_subsection = 1;
            } else if (section_id == 'recipe_harmonizacoes_2') {
                section_subsection = 2;
            } else if (section_id == 'recipe_harmonizacoes_3') {
                section_subsection = 3;
            } else if (section_id == 'recipe_harmonizacoes_4') {
                section_subsection = 4;
            } else if (section_id == 'recipe_harmonizacoes_5') {
                section_subsection = 5;
            } else if (section_id == 'recipe_harmonizacoes_6') {
                section_subsection = 6;
            } else if (section_id == 'recipe_harmonizacoes_7') {
                section_subsection = 7;
            } else if (section_id == 'recipe_harmonizacoes_8') {
                section_subsection = 8;
            } else if (section_id == 'recipe_harmonizacoes_9') {
                section_subsection = 9;
            } else if (section_id == 'recipe_harmonizacoes_10') {
                section_subsection = 10;
            } else if (section_id == 'recipe_harmonizacoes_11') {
                section_subsection = 11;
            } else if (section_id == 'recipe_harmonizacoes_12') {
                section_subsection = 12;
            }

            var section_recipe_width = section_el.find('img.background')[0].getAttribute('mobile-data-original-width');
            var section_recipe_height = section_el.find('img.background')[0].getAttribute('mobile-data-original-height');

            sections[section_id] = {
                visible: true,
                active: true,
                el: section_el,
                background: section_el.find('img.background'),
                get_background_width_value: function() {
                    return this.width_value
                },
                get_background_height_value: function() {
                    return this.height_value
                },
                accumulate: true,
                subsection: section_subsection,

                //height_auto:true,
                calc_height: function() {

                    if (is_short_width) {
                        this.height_value = Math.round(browserWidth * (section_recipe_height / section_recipe_width));
                    } else {

                        /** Specific mobile landscape rules */
                        if (is_mobile && is_short_width == false) {

                            var backgroundImageRatio = 1136 / 620;

                            var landscapeBackgrounds = $('.harmonizacoes_recipe_background_landscape');
                            var landscapeRecipes = $('.recipe_info_image');
                            var recipeInfoContainers = $('.recipe_info_container');

                            for (var i = 0; i < landscapeBackgrounds.length; i++) {

                                var landscapeBackground = $(landscapeBackgrounds[i]);
                                var landscapeRecipe = $(landscapeRecipes[i]);
                                var recipeInfoContainer = $(recipeInfoContainers[i]);
                                var backgroundHeight = 0;
                                var recipeRatio = 0;

                                /** Background landscape product image. This really does suck */
                                if (this.subsection == 1) { /** Chocolate */
                                    landscapeBackground.attr('src', '../images/chocolate-landscape.jpg');
                                    landscapeRecipe.attr('src', '../images/receita-chocolate-landscape.png');
                                    recipeRatio = 1280 / 900;
                                } else if (this.subsection == 2) { /** Vanilla */
                                    landscapeBackground.attr('src', '../images/vanilla-landscape.jpg');
                                    landscapeRecipe.attr('src', '../images/receita-vanilla-landscape.png');
                                    recipeRatio = 1280 / 700;
                                } else if (this.subsection == 3) { /** Caramelo */
                                    landscapeBackground.attr('src', '../images/caramelo-landscape.jpg');
                                    landscapeRecipe.attr('src', '../images/receita-caramelo-landscape.png');
                                    recipeRatio = 1280 / 700;
                                } else if (this.subsection == 4) { /** Limão */
                                    landscapeBackground.attr('src', '../images/limao-landscape.jpg');
                                    landscapeRecipe.attr('src', '../images/receita-limao-landscape.png');
                                    recipeRatio = 1280 / 900;
                                } else if (this.subsection == 5) { /** Pistacchio */
                                    landscapeBackground.attr('src', '../images/pistacchio-landscape.jpg');
                                    landscapeRecipe.attr('src', '../images/receita-pistacchio-landscape.png');
                                    recipeRatio = 1280 / 900;
                                } else if (this.subsection == 6) { /** Panna Cotta */
                                    landscapeBackground.attr('src', '../images/panna-landscape.jpg');
                                    landscapeRecipe.attr('src', '../images/receita-panna-landscape.png');
                                    recipeRatio = 1280 / 900;
                                } else if (this.subsection == 7) { /** Panna Cotta */
                                    landscapeBackground.attr('src', '../images/panna-landscape.jpg');
                                    landscapeRecipe.attr('src', '../images/receita-panna-landscape.png');
                                    recipeRatio = 1280 / 900;
                                } else if (this.subsection == 8) { /** Panna Cotta */
                                    landscapeBackground.attr('src', '../images/panna-landscape.jpg');
                                    landscapeRecipe.attr('src', '../images/receita-panna-landscape.png');
                                    recipeRatio = 1280 / 900;
                                } else if (this.subsection == 9) { /** Panna Cotta */
                                    landscapeBackground.attr('src', '../images/panna-landscape.jpg');
                                    landscapeRecipe.attr('src', '../images/receita-panna-landscape.png');
                                    recipeRatio = 1280 / 900;
                                } else if (this.subsection == 10) { /** Panna Cotta */
                                    landscapeBackground.attr('src', '../images/panna-landscape.jpg');
                                    landscapeRecipe.attr('src', '../images/receita-panna-landscape.png');
                                    recipeRatio = 1280 / 900;
                                } else if (this.subsection == 11) { /** Panna Cotta */
                                    landscapeBackground.attr('src', '../images/panna-landscape.jpg');
                                    landscapeRecipe.attr('src', '../images/receita-panna-landscape.png');
                                    recipeRatio = 1280 / 900;
                                } else if (this.subsection == 12) { /** Panna Cotta */
                                    landscapeBackground.attr('src', '../images/panna-landscape.jpg');
                                    landscapeRecipe.attr('src', '../images/receita-panna-landscape.png');
                                    recipeRatio = 1280 / 900;
                                }

                                landscapeBackground.css('width', this.width_value);
                                var backgroundHeight = Math.round(this.width_value / backgroundImageRatio);
                                landscapeBackground.css('height', backgroundHeight + 'px');

                                recipeInfoContainer.css('top', backgroundHeight + 'px');
                                recipeHeight = Math.round(this.width_value / recipeRatio);

                                /** Set the section height, according to the image height */
                                this.height_value = Math.round(browserWidth * this.height_ratio);
                                if (this.height_min && this.height_value < this.height_min) {
                                    this.height_value = backgroundHeight + recipeHeight;
                                }

                            }

                        } else {
                            //this.height_value=browserHeight;
                            this.height_value = Math.round(browserWidth * this.height_ratio);
                            if (this.height_min && this.height_value < this.height_min) {
                                this.height_value = this.height_min;
                            }
                        }
                    }

                },
                height_ratio: 580 / 1280,
                height_min: 580,

                commit_el_width: function() {
                    this.el[0].style.width = this.width_value + 'px';
                },
                commit_el_height: function() {
                    this.el[0].style.height = this.height_value + 'px';
                },

                height_value: 0,
                width_value: 0,
                top_value: 0,
                middle_value: 0,
                bottom_value: 0,
                parallaxed_top: 0,
                parallaxed_bottom: 0,
                get_parallax_diff: function(top, middle, bottom) {
                    return -top;
                }, //-(top-this.top_value)/2;

                //el_title: section_el.find('#harmonizacoes_header_title'),
                //el_text: section_el.find('#harmonizacoes_header_text'),
                //el_more: section_el.find('#harmonizacoes_header_more'),

                //el_title_scale: 1,
                //el_text_scale:  1,
                //el_more_scale:  1,

                afterResize: function() {
                    //this.el_title_scale=Math.min(1,browserWidth/(680+35+35));
                    //transform_x_y_scale_rotate(this.el_title, 0,  0, this.el_title_scale, 0 );
                },

                //el_button: $('#header_button'),
                reposition_internal_elements: function(top, middle, bottom) {
                    //var diff=this.top_value-top;
                    //diff_abs=Math.abs(diff);

                    //var y_value=-(diff/20)
                    //transform_x_y_scale_rotate(this.el_title, 0,  y_value, this.el_title_scale, 0 );
                    //transform_x_y_scale_rotate(this.el_text,  0,  y_value, this.el_text_scale, 0 );
                    //transform_x_y_scale_rotate(this.el_more,  0,  y_value, this.el_more_scale, 0 );
                    //
                    //var opacity_value=1.5-diff_abs/500;
                    //opacity(this.el_title, opacity_value);
                    //opacity(this.el_text,  opacity_value);
                    //opacity(this.el_more,  opacity_value);
                },
                commit_parallax: function(top, middle, bottom, hide) {
                    transform_y(this.el, this.parallaxed_diff);
                    //this.reposition_internal_elements(top,middle,bottom);
                },
            };
        });


        sections.wall = {
            visible: true,
            active: true,
            el: $('#wall'),
            background: $('#wall_background'),
            get_background_width_value: function() {
                return this.width_value
            },
            get_background_height_value: function() {
                return this.height_value
            },
            accumulate: true,

            //height_auto:true,
            calc_height: function() {
                //if(is_short_width){
                //  this.height_value=Math.max(browserHeight,620);
                //}else{
                this.height_value = Math.round(browserWidth * this.height_ratio);
                if (this.height_min && this.height_value < this.height_min) {
                    this.height_value = this.height_min;
                }

                //}
            },
            //height_ratio: 698/1440,
            //height_min: 698,
            height_ratio: 620 / 1440,
            height_min: 620,

            //commit_el_width: function(){ this.el[0].style.width=this.width_value+'px'; },
            commit_el_height: function() {
                this.el[0].style.height = this.height_value + 'px';
            },

            height_value: 0,
            width_value: 0,
            top_value: 0,
            middle_value: 0,
            bottom_value: 0,
            parallaxed_top: 0,
            parallaxed_bottom: 0,
            get_parallax_diff: function(top, middle, bottom) {

                var value = -top + Math.min(0, (-this.height_value) + top)
                    //console.log();
                return value;
            },

            el_badge: $('#icecream_badge'),
            el_title: $('#wall_title'),
            el_text: $('#wall_text'),
            el_separator: $('#icecream_separator'),

            el_badge_scale: 1,
            el_title_scale: 1,
            el_text_scale: 1,
            el_separator_scale: 1,

            afterResize: function() {
                this.el_title_scale = 0.7;
                transform_x_y_scale_rotate(this.el_title, 0, 0, this.el_title_scale, 0);
                //this.el_title_scale=Math.min(1,browserWidth/1000);
            },

            reposition_internal_elements: function(top, middle, bottom) {

                var diff = this.bottom_value - bottom;
                diff_abs = Math.abs(diff);

                var y_value = Math.min(0, diff / 20);
                transform_x_y_scale_rotate(this.el_badge, 0, y_value, this.el_badge_scale, 0);
                transform_x_y_scale_rotate(this.el_title, 0, y_value, this.el_title_scale, 0);
                transform_x_y_scale_rotate(this.el_text, 0, y_value, this.el_text_scale, 0);
                transform_x_y_scale_rotate(this.el_separator, 0, y_value, this.el_separator_scale, 0);

                var opacity_value = 1.5 - diff_abs / (browserHeight * 0.75);
                opacity(this.el_badge, opacity_value);
                opacity(this.el_title, opacity_value);
                opacity(this.el_text, opacity_value);
                opacity(this.el_separator, opacity_value);

                //opacity(this.el_title, 1.5-diff_abs/500);
                //opacity(this.el_text, 1.5-diff_abs/500);

            },
            commit_parallax: function(top, middle, bottom, hide) {
                transform_y(this.el, this.parallaxed_diff);
                this.reposition_internal_elements(top, middle, bottom);
            },

        };


        /** Mobile vertical */
        if (is_short_width && is_mobile) {

            var grid = {
                cards_per_line: 1,
                max_card_width: 9999,
                card_width: 0,
                card_height: 0,
                row_widths: [],

                recalc: function() {

                    var this_grid = this;

                    this.card_width = this.card_height = browserWidth;

                    var left_value = 0;
                    $.each(cards, function(key, card) {

                        //if(card.card_index==(count_cards_total-1)){
                        //  card.accumulate=true;
                        //}else{
                        card.accumulate = false;
                        //}
                        //if(card.hidden){
                        //  card.accumulate=false;
                        //  return;
                        //}

                        card.left_value = left_value;
                        card.width_value = grid.row_widths[card.card_index % grid.cards_per_line];
                        card.height_value = grid.card_height;
                        //card.accumulate=false;
                        left_value += card.width_value;

                        card.commit_el_width();
                        card.commit_el_height();
                        card.commit_el_left();

                    });


                },

                show_more: function() {

                },



            }




        } else {

            var grid = {
                cards_per_line: 3,
                max_card_width: 480,
                card_width: 0,
                card_height: 0,
                row_widths: [],

                recalc: function() {

                    var this_grid = this;




                    this.cards_per_line = Math.ceil(browserWidth / this.max_card_width);
                    this.row_widths = [];
                    var accumulated_width = 0;
                    for (var i = 0; i < this.cards_per_line; i++) {
                        this.row_widths[i] = Math.floor(browserWidth / this.cards_per_line);
                        accumulated_width += this.row_widths[i];
                    }
                    var missing_width = browserWidth - accumulated_width;
                    this.row_widths[this.row_widths.length - 1] += missing_width;

                    this.card_width = this.card_height = this.row_widths[this.row_widths.length - 1];

                    ////console.log('this.row_widths=',this.row_widths);

                    var left_value = 0;
                    var i = 0;
                    $.each(cards, function(key, card) {

                        if (card.hidden) {
                            card.accumulate = false;
                            return;
                        }

                        card.left_value = left_value;
                        card.width_value = grid.row_widths[card.card_index % grid.cards_per_line];
                        card.height_value = grid.card_height;

                        if ((card.card_index % grid.cards_per_line) == (grid.cards_per_line - 1)) {
                            ////console.log('card.card_index >> accumulate');
                            card.accumulate = true;
                            left_value = 0;
                        } else {
                            card.accumulate = false;
                            left_value += card.width_value;
                        }

                        card.commit_el_width();
                        card.commit_el_height();
                        card.commit_el_left();

                    });


                },

                show_more: function() {
                    // console.log("calling show more");
                    var count_show_more = 0;

                    //count_cards_showing=0;

                    $.each(cards, function(key, card) {

                        //if(!card.hidden){
                        //  count_cards_showing++;
                        //  return;
                        //}
                        //if(is_short_width){
                        //  if(count_show_more>=2){
                        //    return;
                        //  }
                        //}else{

                        var maxShowMore = 12;
                        if (is_mobile) {
                            maxShowMore = 8; /** On mobile landscape, load 2 cards at a time */
                        }
                        if (count_show_more >= maxShowMore) {
                            // console.log("leaving");
                            return;
                        }
                        //}


                        if (card.hidden) {
                            // console.log("entered");
                            count_show_more++;
                            card.active = true;
                            card.hidden = false;
                            //card.visible=true;
                            count_cards_showing++;
                            card.el.removeClass('hidden');
                            card.el.show();
                            card.load();
                        }

                    });

                    //console.log('count_show_more=',count_show_more);
                    if (count_show_more > 0) {
                        // console.log("resizing");
                        main_resize_handler();
                        //grid.recalc();
                        force_render_paralax_once = true;
                    }
                }
            }
        }



        var cards = {};
        var count_cards_total = 0;
        var count_cards_showing = 0;
        var unordered_cards = {};
        $('section.card').each(function() {
            var card_id = this.getAttribute('id');
            ////console.log('card_id=',card_id)
            var card_type = this.getAttribute('data-type');

            if (card_type == 'instagram-video' && is_mobile) {
                return;
            }

            unordered_cards[card_id] = {
                id: card_id,

                el: $('#' + card_id),
                //background: $('#grid_background'),
                //get_background_width_value: function(){ return this.width_value},
                //get_background_height_value: function(){ return this.height_value},
                accumulate: true,

                commit_el_width: function() {
                    this.el[0].style.width = this.width_value + 'px';
                },
                commit_el_height: function() {
                    this.el[0].style.height = this.height_value + 'px';
                },
                commit_el_left: function() {
                    this.el[0].style.left = this.left_value + 'px';
                },

                left_value: 0,
                width_value: 0,
                height_value: 0,
                top_value: 0,
                middle_value: 0,
                bottom_value: 0,
                parallaxed_top: 0,
                parallaxed_bottom: 0,
                parallaxed_diff: 0,

                scale_diff: 0,
                horizontal_diff: 0,
                rotate_diff: 0,

                parallax_constant: 0,
                horizontal_constant: 0,

                loaded: false,

                load: function() {
                    if (!this.loaded) {
                        this.loaded == true;
                        $(this.el).find('img').each(function() {
                            $(this).attr('src', $(this).attr('data-src'));
                            //add_image_being_loaded($(this));
                        });
                        $(this.el).find('video').each(function() {
                            $(this).attr('poster', $(this).attr('poster-src'));
                        });
                    }

                },

                afterResize: function() {
                    this.parallax_constant = this.top_value + (grid.card_height / grid.cards_per_line) * (this.card_index % grid.cards_per_line) * 1.333;

                    this.horizontal_constant = -1 + Math.random() * 2;
                    while (Math.abs(this.horizontal_constant) < 0.5) this.horizontal_constant = -1 + Math.random() * 2;
                    if ((Math.random()) >= 0.5) {
                        this.horizontal_constant = 1;
                    } else {
                        this.horizontal_constant = -1;
                    }

                    ////console.log('this.horizontal_constant=',this.horizontal_constant);
                },
                get_parallax_diff: function(top, middle, bottom) {
                    //if((this.middle_value-middle) > 0 ){


                    //return (-top);

                    //

                    //if(true || diff<0){
                    this.scale_diff = 1;
                    this.rotate_diff = 0;
                    this.horizontal_diff = 0;
                    //return -top;
                    //}
                    var diff = 0;

                    //if(is_short_width){
                    //
                    //}else{
                    var diff = (this.parallax_constant - (bottom * 1 + middle) / 2);

                    //var radius=browserHeight/2-diff/2;
                    //var angle=Math.min(3.14/10,Math.asin(Math.min(radius,Math.max(0,diff))/radius));
                    //var degrees=angle*57.2957795;
                    //var x=radius-radius*Math.cos(angle);
                    //var y=radius*Math.sin(angle);
                    //var rotate=degrees;
                    ////if(this.card_index==1){
                    ////  //console.log(x,y);
                    ////}
                    //

                    this.scale_diff = Math.max(0.94, Math.min(1, 1 - Math.max(0, diff + 5) / (grid.card_height * 1)));
                    //this.rotate_diff=-this.horizontal_constant*degrees;
                    ////this.horizontal_diff=this.horizontal_constant*x/2;
                    //return -top+Math.max(0,y);
                    ////return -top
                    var diff = (this.parallax_constant - (bottom * 1 + middle) / 2);
                    //this.scale_diff=Math.max(0.9,Math.min(1,  1-  Math.max(0,diff+5)/(grid.card_height*1)   ));
                    //this.rotate_diff=-(1-  Math.max(0.5,Math.min(1,  1-  Math.max(0,diff-0)/(grid.card_height*4)   ))        )*160*this.horizontal_constant;
                    //this.horizontal_diff=-Math.max(0,diff)*this.rotate_diff*0.08;
                    //////console.log('this.horizontal_diff=',this.horizontal_diff);
                    //}

                    return -top + Math.max(0, diff); //-grid.cards_per_line*grid.card_height/2  )  ;
                    //}else{
                    //  return -top;
                    //}


                },

                card_index: count_cards_total,

                //reposition_internal_elements: function(top,middle,bottom){
                //
                //},
                commit_parallax: function(top, middle, bottom, hide) {
                    ////console.log(this.el);
                    //transform_y_scale(this.el, this.parallaxed_diff, this.scale_diff );
                    if (hide) {
                        transform_x_y_scale_rotate(this.el, this.horizontal_diff, this.parallaxed_diff * 10, this.scale_diff, this.rotate_diff);
                    } else {
                        transform_x_y_scale_rotate(this.el, this.horizontal_diff, this.parallaxed_diff, this.scale_diff, this.rotate_diff);
                    }

                    //this.reposition_internal_elements(top,middle,bottom);
                },
            }

            //$(this).css({'z-index': 2000-count_cards_total})
            count_cards_total++;


            //cards[card_id] = sections[card_id] =

        });

        var cards_array_shuffle = [];
        var ordered_cards_array = [];
        $.each(unordered_cards, function(key, card) {
            var position = card.el[0].getAttribute('data-position');
            if (position) {
                position = parseInt(position) - 1;
                ////console.log('position=',position);
                while (ordered_cards_array[position]) {
                    position++;
                }
                ordered_cards_array[position] = card;
                card.ordered = true;
            } else {
                cards_array_shuffle.push(card);
            }
        });

        function shuffle(o) {
            for (var j, x, i = o.length; i; j = Math.floor(Math.random() * i), x = o[--i], o[i] = o[j], o[j] = x);
            return o;
        }
        shuffle(cards_array_shuffle);
        var index = 0;
        $.each(cards_array_shuffle, function(key, card) {

            while (ordered_cards_array[index]) {
                index++;
            }
            ordered_cards_array[index] = card;
        });

        ////console.log('ordered_cards_array=',ordered_cards_array);

        index = 0;
        Array.prototype.forEach.call(ordered_cards_array, function(card, i) {

            var hidden = false;
            var active = false;
            if (is_short_width) { /** Mobile portrait */
                if (index > 0) {
                    hidden = true;
                }
            } else if (is_mobile) { /** Mobile landscape: show 2 cards only */
                if (index >= 4) {
                    hidden = true;
                }
            } else { /** Desktop */
                if (index >= 12) {
                    hidden = true;
                }
            }

            if (!hidden) {
                card.el.show();
                count_cards_showing++;
            }
            card.card_index = index;
            card.visible = !hidden;
            card.active = !hidden;
            card.hidden = hidden;


            cards[card.id] = sections[card.id] = card;
            index++;
        });



        if (is_short_width && is_mobile) {
            var grid_slider = {
                next_el: $('#cards_next'),
                prev_el: $('#cards_previous'),
                position: 0,
                destination: 0,
                reset: function() { /*suspectLoop();*/

                },
                update_destination: function(num) {
                    this.destination = num;
                },
                update_position: function() { /*suspectLoop();*/
                    var diff = (this.destination - this.position) / 2;
                    var maxmove = Math.max(0.08);
                    if (diff < -maxmove) diff = -maxmove;
                    if (diff > maxmove) diff = maxmove;

                    this.position += diff;
                    if (this.destination == 0 || this.destination == 1) {
                        if (Math.abs(this.destination - this.position) < 0.01) {
                            this.position = this.destination;
                        }
                    }
                },


                out_of_screen: true,
                commit_position: function() { /*suspectLoop();*/
                    var pos = this.position;
                    var slides = ordered_cards_array;
                    Array.prototype.forEach.call(slides, function(slide, i) { /*suspectLoop();*/
                        //addClass(element_el,className);
                        var el_pos = i - pos;
                        while (el_pos > 2) {
                            el_pos -= slides.length;
                        }
                        while (el_pos < -2) {
                            el_pos += slides.length;
                        }
                        //console.log('el_pos=',el_pos);
                        //console.log('slide.el=',slide.el);

                        if (el_pos <= -2 || el_pos >= 2) {
                            if (!slide.hidden) {
                                slide.hidden = true;
                                slide.el.hide();
                            }
                        } else {
                            if (slide.hidden) {
                                slide.hidden = false;
                                slide.el.show();
                                slide.el.removeClass('hidden');
                                slide.load();
                            }
                        }

                        if (!slide.hidden) {
                            transform_x_y_percent(slide.el, el_pos * 100, 0);
                        }



                    });

                    //this.el.style.opacity=this.position;
                    //
                    ////transform_x_y_percent([this.el],0,this.position*100);
                    ////transform_x_y_vwvh([this.menu_link_el],0,100+this.position*100);
                    //
                    //if(this.position==0){
                    //  if(!this.out_of_screen){
                    //    this.out_of_screen=true;
                    //    this.el.style.display='none';
                    //    //transform_x_y_percent(this.el,100,0);
                    //  }
                    //}else{
                    //  if(this.out_of_screen){
                    //    this.out_of_screen=false;
                    //    this.el.style.display='block';
                    //    //transform_x_y_percent(this.el,0,0);
                    //  }
                    //}

                },

                prev: function() {
                    var slides = ordered_cards_array;
                    //if(this.destination>0){
                    this.destination -= 1;
                    this.counter = 0;
                    this.check();
                    //}

                },
                next: function() {
                    var slides = ordered_cards_array;
                    //if(this.destination<(slides.length-1)){
                    this.destination += 1;
                    this.counter = 0;
                    this.check();
                    //}
                },

                check: function() {
                    //var slides=ordered_cards_array;
                    //if(this.destination>0){
                    //  this.prev_el.fadeIn();
                    //}else{
                    //  this.prev_el.fadeOut();
                    //}
                    //
                    //if(this.destination<(slides.length-1)){
                    //  this.next_el.fadeIn();
                    //}else{
                    //  this.next_el.fadeOut();
                    //}
                },

                //counter:0,
                update: function() {

                    //if( current_slug=='/' && !current_subsection && !grid_previous_hovered && !grid_next_hovered){
                    //  this.counter++;
                    //  if(this.counter>60*10){
                    //    this.next();
                    //  }
                    //}else{
                    //  this.counter=0;
                    //}
                    if (this.position !== this.destination) {
                        this.update_position();
                        this.commit_position();
                    }
                },

                //adapt: function(){
                //  var slides=this.slides;
                //  Array.prototype.forEach.call(slides, function(slide, i){ /*suspectLoop();*/
                //
                //    var img=slide.querySelectorAll('img');
                //    //console.log('img=',img);
                //    cover_container_by_replacing_if_needed(img[0],sections.header.get_background_width_value(),sections.header.get_background_height_value());
                //
                //  });
                //}
            };
        }



        //$.


        //sections.grid= {
        //  visible:true,
        //  active:true,
        //  el: $('#grid'),
        //  background: $('#grid_background'),
        //  get_background_width_value: function(){ return this.width_value},
        //  get_background_height_value: function(){ return this.height_value},
        //  accumulate: true,
        //
        //  //commit_el_width: function(){ this.el[0].style.width=this.width_value+'px'; },
        //  commit_el_height: function(){ this.el[0].style.height=this.height_value+'px'; },
        //
        //  height_value: 0,
        //  width_value: 0,
        //  top_value: 0,
        //  middle_value: 0,
        //  bottom_value: 0,
        //  parallaxed_top: 0,
        //  parallaxed_bottom: 0,
        //  get_parallax_diff: function(top,middle,bottom){ return -top; },
        //  reposition_internal_elements: function(top,middle,bottom){
        //
        //  },
        //};

        if (grid_slider) {
            sections.cards = {
                visible: true,
                active: true,
                always_visible: true,
                el: $('#cards'),
                background: null,
                accumulate: true,

                //commit_el_width: function(){ this.el[0].style.width=this.width_value+'px'; },
                //commit_el_height: function(){ this.el[0].style.height=this.height_value+'px'; },

                height_value: browserWidth,
                width_value: browserWidth,
                top_value: 0,
                middle_value: 0,
                bottom_value: 0,
                parallaxed_top: 0,
                parallaxed_bottom: 0,
                get_parallax_diff: function(top, middle, bottom) {

                    var diff = bottom - this.top_value;
                    ////console.log('diff=',diff);
                    if (diff < -300) {
                        diff = -300;
                    }
                    if (diff > 0) {
                        diff = 0;
                    }

                    return -top + diff;
                },
                //reposition_internal_elements: function(top,middle,bottom){
                //
                //},
                commit_parallax: function(top, middle, bottom, hide) {
                    transform_y(this.el, this.parallaxed_diff);
                    //this.reposition_internal_elements(top,middle,bottom);
                },
            };
        }


        sections.divider_before_products = {
            visible: true,
            active: true,
            always_visible: true,
            el: $('#divider_before_products'),
            background: null,
            accumulate: true,

            //commit_el_width: function(){ this.el[0].style.width=this.width_value+'px'; },
            //commit_el_height: function(){ this.el[0].style.height=this.height_value+'px'; },

            height_value: 6,
            width_value: 0,
            top_value: 0,
            middle_value: 0,
            bottom_value: 0,
            parallaxed_top: 0,
            parallaxed_bottom: 0,
            get_parallax_diff: function(top, middle, bottom) {

                var diff = bottom - this.top_value;
                ////console.log('diff=',diff);
                if (diff < -300) {
                    diff = -300;
                }
                if (diff > 0) {
                    diff = 0;
                }

                return -top + diff;
            },
            //reposition_internal_elements: function(top,middle,bottom){
            //
            //},
            commit_parallax: function(top, middle, bottom, hide) {
                transform_y(this.el, this.parallaxed_diff);
                //this.reposition_internal_elements(top,middle,bottom);
            },
        };

        var nutritional_opened = false;
        var current_product = 1;

        sections.products_detail = {
            visible: true,
            active: true,
            el: $('#products_detail'),
            //background: $('#products_detail_background'),
            //get_background_width_value: function(){ return this.width_value},
            //get_background_height_value: function(){ return this.height_value},
            accumulate: false,

            controls: {
                el: $('#products_controls'),
            },
            closer: {
                el: $('#products_close'),
            },
            bullets: [],

            //height_auto:true,
            calc_height: function() {

                if (is_short_width) {
                    //this.width_value=browserWidth*4;
                    this.height_value = Math.max(568, browserHeight);
                } else {
                    this.height_value = Math.round(browserWidth * this.height_ratio);
                    if (this.height_min && this.height_value < this.height_min) {
                        this.height_value = this.height_min;
                    }
                }
            },
            height_ratio: 621 / 1280,
            height_min: 580,

            //commit_el_width: function(){ this.el[0].style.width=this.width_value+'px'; },
            commit_el_height: function() {
                this.el[0].style.height = this.height_value + 'px';
            },

            height_value: 0,
            width_value: 0,
            top_value: 0,
            middle_value: 0,
            bottom_value: 0,
            parallaxed_top: 0,
            parallaxed_bottom: 0,
            get_parallax_diff: function(top, middle, bottom) {
                return -top; /*(top-this.top_value)/2;*/
            },

            el_title1: $('#products_detail_title1'),
            el_text1: $('#products_detail_text1'),
            el_title2: $('#products_detail_title2'),
            el_text2: $('#products_detail_text2'),
            el_title3: $('#products_detail_title3'),
            el_text3: $('#products_detail_text3'),
            el_title4: $('#products_detail_title4'),
            el_text4: $('#products_detail_text4'),
            el_title5: $('#products_detail_title5'),
            el_text5: $('#products_detail_text5'),
            el_title6: $('#products_detail_title6'),
            el_text6: $('#products_detail_text6'),
            el_title7: $('#products_detail_title7'),
            el_text7: $('#products_detail_text7'),
            el_title8: $('#products_detail_title8'),
            el_text8: $('#products_detail_text8'),
            el_title9: $('#products_detail_title9'),
            el_text9: $('#products_detail_text9'),
            el_title10: $('#products_detail_title10'),
            el_text10: $('#products_detail_text10'),
            el_title11: $('#products_detail_title11'),
            el_text11: $('#products_detail_text11'),
            el_title12: $('#products_detail_title12'),
            el_text12: $('#products_detail_text12'),

            el_title1_scale: 1,
            el_text1_scale: 1,
            el_title2_scale: 1,
            el_text2_scale: 1,
            el_title3_scale: 1,
            el_text3_scale: 1,
            el_title4_scale: 1,
            el_text4_scale: 1,
            el_title5_scale: 1,
            el_text5_scale: 1,
            el_title6_scale: 1,
            el_text6_scale: 1,
            el_title7_scale: 1,
            el_text7_scale: 1,
            el_title8_scale: 1,
            el_text8_scale: 1,
            el_title9_scale: 1,
            el_text9_scale: 1,
            el_title10_scale: 1,
            el_text10_scale: 1,
            el_title11_scale: 1,
            el_text11_scale: 1,
            el_title12_scale: 1,
            el_text12_scale: 1,

            el_more_info: $('#products_more_info'),
            el_view_video: $('#view-product-video'),
            el_nutritional: $('#products_nutritional'),

            backgrounds: {
                el: $('#products_detail_backgrounds'),
            },
            background_1: {
                el: $('#products_detail_backgrounds'),
            },
            background_2: {
                el: $('#products_detail_backgrounds'),
            },
            background_3: {
                el: $('#products_detail_backgrounds'),
            },
            background_4: {
                el: $('#products_detail_backgrounds'),
            },
            background_5: {
                el: $('#products_detail_backgrounds'),
            },
            background_6: {
                el: $('#products_detail_backgrounds'),
            },
            background_7: {
                el: $('#products_detail_backgrounds'),
            },
            background_8: {
                el: $('#products_detail_backgrounds'),
            },
            background_9: {
                el: $('#products_detail_backgrounds'),
            },
            background_10: {
                el: $('#products_detail_backgrounds'),
            },
            background_11: {
                el: $('#products_detail_backgrounds'),
            },
            background_12: {
                el: $('#products_detail_backgrounds'),
            },

            computer_element_positions: function() {

            },

            afterResize: function() {
                var titleScale = 0.7;

                transform_x_y_scale_rotate(this.el_title1, 0, 0, titleScale, 0);
                transform_x_y_scale_rotate(this.el_title2, 0, 0, titleScale, 0);
                transform_x_y_scale_rotate(this.el_title3, 0, 0, titleScale, 0);
                transform_x_y_scale_rotate(this.el_title4, 0, 0, titleScale, 0);
                transform_x_y_scale_rotate(this.el_title5, 0, 0, titleScale, 0);
                transform_x_y_scale_rotate(this.el_title6, 0, 0, titleScale, 0);

            },

            reposition_internal_elements: function(top, middle, bottom) {
                var diff = this.top_value + 0.125 * this.height_value - middle;
                ////console.log('diff',diff)
                var diff_abs = Math.abs(diff);

                var x_translate = this.hide_translate_position * browserWidth;
                ////console.log('y_translate=',y_translate);

                var y_value = diff / 20;
                transform_x_y_scale_rotate(this.el_title1, 0, y_value, this.el_title1_scale, 0);
                transform_x_y_scale_rotate(this.el_text1, 0, y_value, this.el_text1_scale, 0);
                transform_x_y_scale_rotate(this.el_title2, 0, y_value, this.el_title2_scale, 0);
                transform_x_y_scale_rotate(this.el_text2, 0, y_value, this.el_text2_scale, 0);
                transform_x_y_scale_rotate(this.el_title3, 0, y_value, this.el_title3_scale, 0);
                transform_x_y_scale_rotate(this.el_text3, 0, y_value, this.el_text3_scale, 0);
                transform_x_y_scale_rotate(this.el_title4, 0, y_value, this.el_title4_scale, 0);
                transform_x_y_scale_rotate(this.el_text4, 0, y_value, this.el_text4_scale, 0);
                transform_x_y_scale_rotate(this.el_title5, 0, y_value, this.el_title5_scale, 0);
                transform_x_y_scale_rotate(this.el_text5, 0, y_value, this.el_text5_scale, 0);
                transform_x_y_scale_rotate(this.el_title6, 0, y_value, this.el_title6_scale, 0);
                transform_x_y_scale_rotate(this.el_text6, 0, y_value, this.el_text6_scale, 0);
                transform_x_y_scale_rotate(this.el_title7, 0, y_value, this.el_title7_scale, 0);
                transform_x_y_scale_rotate(this.el_text7, 0, y_value, this.el_text7_scale, 0);
                transform_x_y_scale_rotate(this.el_title8, 0, y_value, this.el_title8_scale, 0);
                transform_x_y_scale_rotate(this.el_text8, 0, y_value, this.el_text8_scale, 0);
                transform_x_y_scale_rotate(this.el_title9, 0, y_value, this.el_title9_scale, 0);
                transform_x_y_scale_rotate(this.el_text9, 0, y_value, this.el_text9_scale, 0);
                transform_x_y_scale_rotate(this.el_title10, 0, y_value, this.el_title10_scale, 0);
                transform_x_y_scale_rotate(this.el_text10, 0, y_value, this.el_text10_scale, 0);
                transform_x_y_scale_rotate(this.el_title11, 0, y_value, this.el_title11_scale, 0);
                transform_x_y_scale_rotate(this.el_text11, 0, y_value, this.el_text11_scale, 0);
                transform_x_y_scale_rotate(this.el_title12, 0, y_value, this.el_title12_scale, 0);
                transform_x_y_scale_rotate(this.el_text12, 0, y_value, this.el_text12_scale, 0);

                transform_x_y_scale_rotate(this.el_more_info, 0, y_value, this.el_more_info, 0);
                transform_x_y_scale_rotate(this.el_view_video, 0, y_value, this.el_view_video, 0);
                transform_x_y_scale_rotate(this.el_nutritional, 0, y_value, this.el_nutritional, 0);

                var opacity_value = 1.5 - diff_abs / 500;
                opacity(this.el_title1, opacity_value);
                opacity(this.el_text1, opacity_value);
                opacity(this.el_title2, opacity_value);
                opacity(this.el_text2, opacity_value);
                opacity(this.el_title3, opacity_value);
                opacity(this.el_text3, opacity_value);
                opacity(this.el_title4, opacity_value);
                opacity(this.el_text4, opacity_value);
                opacity(this.el_title5, opacity_value);
                opacity(this.el_text5, opacity_value);
                opacity(this.el_title6, opacity_value);
                opacity(this.el_text6, opacity_value);
                opacity(this.el_title7, opacity_value);
                opacity(this.el_text7, opacity_value);
                opacity(this.el_title8, opacity_value);
                opacity(this.el_text8, opacity_value);
                opacity(this.el_title9, opacity_value);
                opacity(this.el_text9, opacity_value);
                opacity(this.el_title10, opacity_value);
                opacity(this.el_text10, opacity_value);
                opacity(this.el_title11, opacity_value);
                opacity(this.el_text11, opacity_value);
                opacity(this.el_title12, opacity_value);
                opacity(this.el_text12, opacity_value);
                // opacity(this.el_more_info, opacity_value );
                // opacity(this.el_view_video, opacity_value );
                opacity(this.el_nutritional, opacity_value);

                if (!(this.hide_translate_position_commited == this.hide_translate_position)) {

                    if (x_translate == 0) {
                        transform_x_y_not_3d(this.backgrounds.el, x_translate, 0);
                        //transform_x_y_not_3d(this.background_1.el, x_translate, 0 );
                        //transform_x_y_not_3d(this.background_2.el, x_translate, 0 );
                        //transform_x_y_not_3d(this.background_3.el, x_translate, 0 );
                        //transform_x_y_not_3d(this.background_4.el, x_translate, 0 );
                    } else {
                        transform_x_y(this.backgrounds.el, x_translate, 0);
                        //transform_x_y(this.background_1.el, x_translate, 0 );
                        //transform_x_y(this.background_2.el, x_translate, 0 );
                        //transform_x_y(this.background_3.el, x_translate, 0 );
                        //transform_x_y(this.background_4.el, x_translate, 0 );
                    }



                    this.hide_translate_position_commited = this.hide_translate_position;
                }

                /* Mobile landscape product background */
                if (is_mobile && is_short_width == false) {

                    var bg1 = $($('.background.desktop-only.products_detail_background1.mobile')[0]);
                    var bg2 = $($('.background.desktop-only.products_detail_background2.mobile')[0]);
                    var bg3 = $($('.background.desktop-only.products_detail_background3.mobile')[0]);
                    var bg4 = $($('.background.desktop-only.products_detail_background4.mobile')[0]);
                    var bg5 = $($('.background.desktop-only.products_detail_background5.mobile')[0]);
                    var bg6 = $($('.background.desktop-only.products_detail_background6.mobile')[0]);
                    var bg7 = $($('.background.desktop-only.products_detail_background7.mobile')[0]);
                    var bg8 = $($('.background.desktop-only.products_detail_background8.mobile')[0]);
                    var bg9 = $($('.background.desktop-only.products_detail_background9.mobile')[0]);
                    var bg10 = $($('.background.desktop-only.products_detail_background10.mobile')[0]);
                    var bg11 = $($('.background.desktop-only.products_detail_background11.mobile')[0]);
                    var bg12 = $($('.background.desktop-only.products_detail_background12.mobile')[0]);

                    /* Calculate the new image dimensions */
                    var imageWidth = 1280;
                    var imageHeight = 621;
                    var sectionHeight = 580;
                    var bgWidth = sectionHeight * imageWidth / imageHeight;
                    var leftOffset = (bgWidth - browserWidth) / 2;

                    /* It may be necessary to add a small offset in smaller screens */

                    bg1.css('width', bgWidth);
                    bg1.css('left', -leftOffset + 'px');
                    if (browserWidth <= 667) {
                        bg1.css('left', (-leftOffset - 60) + 'px');
                    }

                    bg2.css('width', bgWidth);
                    bg2.css('left', -leftOffset + 'px');
                    if (browserWidth <= 736) {
                        bg2.css('left', (-leftOffset - 140) + 'px');
                    }

                    bg3.css('width', bgWidth);
                    bg3.css('left', -leftOffset + 'px');
                    if (browserWidth <= 600) {
                        bg3.css('left', (-leftOffset - 30) + 'px');
                    }

                    bg4.css('width', bgWidth);
                    bg4.css('left', -leftOffset + 'px');
                    if (browserWidth <= 736) {
                        bg4.css('left', (-leftOffset + 140) + 'px');
                    }

                    var bg5_0 = $($('.background.desktop-only.products_detail_background5.mobile')[0]);
                    bg5_0.css('top', '0px');

                    bg5.css('width', bgWidth);
                    bg5.css('left', -leftOffset + 'px');
                    if (browserWidth <= 667) {
                        bg5.css('left', (-leftOffset - 100) + 'px');
                    }

                    bg6.css('width', bgWidth);
                    bg6.css('left', -leftOffset + 'px');
                    if (browserWidth <= 740) {
                        bg6.css('left', (-leftOffset - 160) + 'px');
                    }

                    bg7.css('width', bgWidth);
                    bg7.css('left', -leftOffset + 'px');
                    if (browserWidth <= 740) {
                        bg7.css('left', (-leftOffset - 160) + 'px');
                    }

                    bg8.css('width', bgWidth);
                    bg8.css('left', -leftOffset + 'px');
                    if (browserWidth <= 740) {
                        bg8.css('left', (-leftOffset - 160) + 'px');
                    }

                    bg9.css('width', bgWidth);
                    bg9.css('left', -leftOffset + 'px');
                    if (browserWidth <= 740) {
                        bg9.css('left', (-leftOffset - 160) + 'px');
                    }

                    bg10.css('width', bgWidth);
                    bg10.css('left', -leftOffset + 'px');
                    if (browserWidth <= 740) {
                        bg10.css('left', (-leftOffset - 160) + 'px');
                    }

                    bg11.css('width', bgWidth);
                    bg11.css('left', -leftOffset + 'px');
                    if (browserWidth <= 740) {
                        bg11.css('left', (-leftOffset - 160) + 'px');
                    }

                    bg12.css('width', bgWidth);
                    bg12.css('left', -leftOffset + 'px');
                    if (browserWidth <= 740) {
                        bg12.css('left', (-leftOffset - 160) + 'px');
                    }
                }

            },
            commit_parallax: function(top, middle, bottom, hide) {
                transform_y(this.el, this.parallaxed_diff);
                this.reposition_internal_elements(top, middle, bottom);
            },

            hide_translate_position: 1,
            hide_translate_position_commited: 1,

            animation: function() {
                this.hide_translate_position = 1 + sections.products.hide_translate_position;
                ////console.log('this.hide_translate_position=',this.hide_translate_position);
            },

            opened: false,
            hidden: false,

            open: function(id) {
                var was_closed = !this.opened;

                if (!this.opened) {
                    this.opened = true;
                    sections.products.close();
                    this.active = true;
                    this.hidden = false;
                    force_render_paralax_once = true;

                    this.el.show();
                }

                current_product = parseInt(id);
                //console.log('current_product=',current_product);

                image_cover_container($('.products_nutritional[rel="'+current_product+'"]'), sections.products_detail.width_value, sections.products_detail.height_value);

                if (nutritional_opened) {
                    $('.products_nutritional').fadeOut();
                    $('#products_nutritional_' + current_product).hide();
                    $('#products_nutritional_' + current_product).fadeIn();
                }

                // console.log(sections);

                sections.products_detail.background_1.deactivate();
                sections.products_detail.background_2.deactivate();
                sections.products_detail.background_3.deactivate();
                sections.products_detail.background_4.deactivate();
                sections.products_detail.background_5.deactivate();
                sections.products_detail.background_6.deactivate();
                sections.products_detail.background_7.deactivate();
                sections.products_detail.background_8.deactivate();
                sections.products_detail.background_9.deactivate();
                sections.products_detail.background_10.deactivate();
                sections.products_detail.background_11.deactivate();
                sections.products_detail.background_12.deactivate();

                sections.products_navigation.button_1.el[0].style.color = '';
                sections.products_navigation.button_2.el[0].style.color = '';
                sections.products_navigation.button_3.el[0].style.color = '';
                sections.products_navigation.button_4.el[0].style.color = '';
                sections.products_navigation.button_5.el[0].style.color = '';
                sections.products_navigation.button_6.el[0].style.color = '';
                sections.products_navigation.button_7.el[0].style.color = '';
                sections.products_navigation.button_8.el[0].style.color = '';
                sections.products_navigation.button_9.el[0].style.color = '';
                sections.products_navigation.button_10.el[0].style.color = '';
                sections.products_navigation.button_11.el[0].style.color = '';
                sections.products_navigation.button_12.el[0].style.color = '';

                switch (Number(id)) {
                    case 1:
                        products_aba.go(1);
                        sections.products_detail.background_1.activate();
                        dots_change(sections.products_detail.background_1);
                        sections.products_navigation.button_1.el[0].style.color = '#847140';

                        $('#view-product-video').show();
                        if (is_mobile && is_short_width) {
                            $('#products_more_info').css('top', '64px');
                        } else if (is_mobile && is_short_width == false) {
                            $('#products_more_info').css('top', '0px');
                            $('#products_more_info').css('left', 'auto');
                            $('#products_more_info').css('margin-left', '0');
                            $('#products_more_info').css('margin-right', '0');
                        } else {
                            $('#products_more_info').css('left', 'auto');
                            $('#products_more_info').css('margin-left', '0');
                            $('#products_more_info').css('margin-right', '0');
                        }
                        break;
                    case 2:
                        products_aba.go(2);
                        sections.products_detail.background_2.activate();
                        dots_change(sections.products_detail.background_2);
                        sections.products_navigation.button_2.el[0].style.color = '#847140';

                        $('#view-product-video').show();
                        if (is_mobile && is_short_width) {
                            $('#products_more_info').css('top', '64px');
                        } else if (is_mobile && is_short_width == false) {
                            $('#products_more_info').css('top', '0px');
                            $('#products_more_info').css('left', 'auto');
                            $('#products_more_info').css('margin-left', '0');
                            $('#products_more_info').css('margin-right', '0');
                        } else {
                            $('#products_more_info').css('left', 'auto');
                            $('#products_more_info').css('margin-left', '0');
                            $('#products_more_info').css('margin-right', '0');
                        }

                        break;
                    case 3:
                        products_aba.go(3);
                        sections.products_detail.background_3.activate();
                        dots_change(sections.products_detail.background_3);
                        sections.products_navigation.button_3.el[0].style.color = '#847140';

                        $('#view-product-video').show();
                        if (is_mobile && is_short_width) {
                            $('#products_more_info').css('top', '64px');
                        } else if (is_mobile && is_short_width == false) {
                            $('#products_more_info').css('top', '0px');
                            $('#products_more_info').css('left', 'auto');
                            $('#products_more_info').css('margin-left', '0');
                            $('#products_more_info').css('margin-right', '0');
                        } else {
                            $('#products_more_info').css('left', 'auto');
                            $('#products_more_info').css('margin-left', '0');
                            $('#products_more_info').css('margin-right', '0');
                        }

                        break;
                    case 4:
                        products_aba.go(4);
                        sections.products_detail.background_4.activate();
                        dots_change(sections.products_detail.background_4);
                        sections.products_navigation.button_4.el[0].style.color = '#847140';

                        $('#view-product-video').show();
                        if (is_mobile && is_short_width) {
                            $('#products_more_info').css('top', '64px');
                        } else if (is_mobile && is_short_width == false) {
                            $('#products_more_info').css('top', '0px');
                            $('#products_more_info').css('left', 'auto');
                            $('#products_more_info').css('margin-left', '0');
                            $('#products_more_info').css('margin-right', '0');
                        } else {
                            $('#products_more_info').css('left', 'auto');
                            $('#products_more_info').css('margin-left', '0');
                            $('#products_more_info').css('margin-right', '0');
                        }
                        break;
                    case 5:
                        products_aba.go(5);
                        sections.products_detail.background_5.activate();
                        dots_change(sections.products_detail.background_5);
                        sections.products_navigation.button_5.el[0].style.color = '#847140';

                        /* Product section setup: last 2 flavors don't have the play video button */
                        $('#view-product-video').hide();
                        if (is_mobile && is_short_width) {
                            // $('#products_more_info').css('top', '40px');
                        } else if (is_mobile && is_short_width == false) {
                            $('#products_more_info').css('top', '40px');
                            $('#products_more_info').css('left', '0');
                            $('#products_more_info').css('margin-left', 'auto');
                            $('#products_more_info').css('margin-right', 'auto');
                        } else {
                            $('#products_more_info').css('left', '0');
                            $('#products_more_info').css('margin-left', 'auto');
                            $('#products_more_info').css('margin-right', 'auto');
                        }

                        break;
                    case 6:
                        products_aba.go(6);
                        sections.products_detail.background_6.activate();
                        dots_change(sections.products_detail.background_6);
                        sections.products_navigation.button_6.el[0].style.color = '#847140';

                        $('#view-product-video').hide();
                        if (is_mobile && is_short_width) {
                            // $('#products_more_info').css('top', '40px');
                        } else if (is_mobile && is_short_width == false) {
                            $('#products_more_info').css('top', '40px');
                            $('#products_more_info').css('left', '0');
                            $('#products_more_info').css('margin-left', 'auto');
                            $('#products_more_info').css('margin-right', 'auto');
                        } else {
                            $('#products_more_info').css('left', '0');
                            $('#products_more_info').css('margin-left', 'auto');
                            $('#products_more_info').css('margin-right', 'auto');
                        }
                        break;
                    case 7:
                        products_aba.go(7);
                        sections.products_detail.background_7.activate();
                        dots_change(sections.products_detail.background_7);
                        sections.products_navigation.button_7.el[0].style.color = '#847140';

                        $('#view-product-video').hide();
                        if (is_mobile && is_short_width) {
                            // $('#products_more_info').css('top', '40px');
                        } else if (is_mobile && is_short_width == false) {
                            $('#products_more_info').css('top', '40px');
                            $('#products_more_info').css('left', '0');
                            $('#products_more_info').css('margin-left', 'auto');
                            $('#products_more_info').css('margin-right', 'auto');
                        } else {
                            $('#products_more_info').css('left', '0');
                            $('#products_more_info').css('margin-left', 'auto');
                            $('#products_more_info').css('margin-right', 'auto');
                        }
                        break;
                    case 8:
                        products_aba.go(8);
                        sections.products_detail.background_8.activate();
                        dots_change(sections.products_detail.background_8);
                        sections.products_navigation.button_8.el[0].style.color = '#847140';

                        $('#view-product-video').hide();
                        if (is_mobile && is_short_width) {
                            // $('#products_more_info').css('top', '40px');
                        } else if (is_mobile && is_short_width == false) {
                            $('#products_more_info').css('top', '40px');
                            $('#products_more_info').css('left', '0');
                            $('#products_more_info').css('margin-left', 'auto');
                            $('#products_more_info').css('margin-right', 'auto');
                        } else {
                            $('#products_more_info').css('left', '0');
                            $('#products_more_info').css('margin-left', 'auto');
                            $('#products_more_info').css('margin-right', 'auto');
                        }
                        break;
                    case 9:
                        products_aba.go(9);
                        sections.products_detail.background_9.activate();
                        dots_change(sections.products_detail.background_9);
                        sections.products_navigation.button_9.el[0].style.color = '#847140';

                        $('#view-product-video').hide();
                        if (is_mobile && is_short_width) {
                            // $('#products_more_info').css('top', '40px');
                        } else if (is_mobile && is_short_width == false) {
                            $('#products_more_info').css('top', '40px');
                            $('#products_more_info').css('left', '0');
                            $('#products_more_info').css('margin-left', 'auto');
                            $('#products_more_info').css('margin-right', 'auto');
                        } else {
                            $('#products_more_info').css('left', '0');
                            $('#products_more_info').css('margin-left', 'auto');
                            $('#products_more_info').css('margin-right', 'auto');
                        }
                        break;
                    case 10:
                        products_aba.go(10);
                        sections.products_detail.background_10.activate();
                        dots_change(sections.products_detail.background_10);
                        sections.products_navigation.button_10.el[0].style.color = '#847140';

                        $('#view-product-video').hide();
                        if (is_mobile && is_short_width) {
                            // $('#products_more_info').css('top', '40px');
                        } else if (is_mobile && is_short_width == false) {
                            $('#products_more_info').css('top', '40px');
                            $('#products_more_info').css('left', '0');
                            $('#products_more_info').css('margin-left', 'auto');
                            $('#products_more_info').css('margin-right', 'auto');
                        } else {
                            $('#products_more_info').css('left', '0');
                            $('#products_more_info').css('margin-left', 'auto');
                            $('#products_more_info').css('margin-right', 'auto');
                        }
                        break;
                    case 11:
                        products_aba.go(11);
                        sections.products_detail.background_11.activate();
                        dots_change(sections.products_detail.background_11);
                        sections.products_navigation.button_11.el[0].style.color = '#847140';

                        $('#view-product-video').hide();
                        if (is_mobile && is_short_width) {
                            // $('#products_more_info').css('top', '40px');
                        } else if (is_mobile && is_short_width == false) {
                            $('#products_more_info').css('top', '40px');
                            $('#products_more_info').css('left', '0');
                            $('#products_more_info').css('margin-left', 'auto');
                            $('#products_more_info').css('margin-right', 'auto');
                        } else {
                            $('#products_more_info').css('left', '0');
                            $('#products_more_info').css('margin-left', 'auto');
                            $('#products_more_info').css('margin-right', 'auto');
                        }
                        break;
                    case 12:
                        products_aba.go(12);
                        sections.products_detail.background_12.activate();
                        dots_change(sections.products_detail.background_12);
                        sections.products_navigation.button_12.el[0].style.color = '#847140';

                        $('#view-product-video').hide();
                        if (is_mobile && is_short_width) {
                            // $('#products_more_info').css('top', '40px');
                        } else if (is_mobile && is_short_width == false) {
                            $('#products_more_info').css('top', '40px');
                            $('#products_more_info').css('left', '0');
                            $('#products_more_info').css('margin-left', 'auto');
                            $('#products_more_info').css('margin-right', 'auto');
                        } else {
                            $('#products_more_info').css('left', '0');
                            $('#products_more_info').css('margin-left', 'auto');
                            $('#products_more_info').css('margin-right', 'auto');
                        }
                        break;
                }

                //if(current_background_object){
                //  for(var i=0; i<current_background_object.images.length; i++){
                //    var img=current_background_object.images[i];
                //    if(img.index==0){
                //      img.activate();
                //    }else{
                //      img.deactivate();
                //    }
                //  }
                //}

                if (was_closed) {
                    if (activated_image) {
                        activated_image.position = activated_image.destination;
                        activated_image.commit_position();
                    }
                }


                this.el.find('.products_detail_title, .products_detail_text').hide();

                $('#products_detail_title' + id).show();
                $('#products_detail_text' + id).show();
                //$('#products_symbol_'+id).show();

            },

            close: function() {
                if (this.opened) {
                    this.opened = false;

                    /* Map the current product back to the correct ones due to the order change */
                    // if (current_product == 4) {
                    //     current_product = 1;
                    // } else if (current_product == 3) {
                    //     current_product = 2;
                    // } else if (current_product == 2) {
                    //     current_product = 3;
                    // } else if (current_product == 1) {
                    //     current_product = 4;
                    // }

                    sections.products.open();
                }
            },

            finishedOpening: function() {

            },

            finishedClosing: function() {
                this.active = false;
                force_render_paralax_once = true;
                this.hidden = true;
                this.el.hide();

                if (current_background_object) {
                    for (var i = 0; i < current_background_object.images.length; i++) {
                        var img = current_background_object.images[i];
                        img.position = 0;
                        img.destination = 0;
                        img.commit_position();
                    }
                }
            },


            change_background: function(id) {

            },
        };

        sections.products = {
            visible: true,
            active: true,
            el: $('#products'),
            background: $('#products_background'),
            get_background_width_value: function() {
                return this.width_value
            },
            get_background_height_value: function() {
                return this.height_value
            },
            accumulate: true,

            //height_auto:true,
            calc_height: function() {
                if (is_short_width) {
                    this.width_value = browserWidth * 6;
                    this.height_value = Math.max(568, browserHeight);
                } else {
                    this.height_value = Math.round(browserWidth * this.height_ratio);
                    if (this.height_min && this.height_value < this.height_min) {
                        this.height_value = this.height_min;
                    }
                }

            },
            height_ratio: 621 / 1280,
            height_min: 580,

            commit_el_width: function() {
                this.el[0].style.width = this.width_value + 'px';
            },
            commit_el_height: function() {
                this.el[0].style.height = this.height_value + 'px';
            },

            height_value: 0,
            width_value: 0,
            top_value: 0,
            middle_value: 0,
            bottom_value: 0,
            parallaxed_top: 0,
            parallaxed_bottom: 0,
            get_parallax_diff: function(top, middle, bottom) {
                return -top; /*(top-this.top_value)/2;*/
            },

            el_title: $('#products_title'),
            el_text: $('#products_text'),

            el_title_scale: 1,
            el_text_scale: 1,

            computer_element_positions: function() {


            },

            afterResize: function() {
                /* Product menu: mobile landscape and <= 1024 */
                if (window.innerWidth >= 480 && window.innerWidth <= 1024) {
                    moveProductsLeft();

                    this.background.attr('src', '../images/products-background-fix.jpg');

                    /* Normal height calculation */
                    this.height_value = Math.round(browserWidth * this.height_ratio);
                    if (this.height_min && this.height_value < this.height_min) {
                        this.height_value = this.height_min;
                    }

                    // 1280 x 621
                    var imageWidth = window.innerWidth;
                    var imageHeight = imageWidth / 1280 * 621;

                    this.background.css('width', (imageWidth * 2) + 'px');
                    this.background.css('height', (imageHeight * 2) + 'px');
                    this.background.css('left', '0px');
                    $('#products').css('background-color', '#000');

                    /* Hide the product names (they're in the images) */
                    $('#products_name4').hide();
                    $('#products_name5').hide();
                    $('#products_name6').hide();

                    if (window.innerWidth >= 480 && window.innerWidth <= 568) {
                        this.background.css('top', '20px');
                        this.background.css('left', '-12px');
                    } else if (window.innerWidth > 568 && window.innerWidth <= 600) {
                        this.background.css('top', '20px');
                    } else if (window.innerWidth >= 700 && window.innerWidth < 768) {
                        this.background.css('top', '-40px');
                    } else if (window.innerWidth >= 768 && window.innerWidth < 860) {
                        this.background.css('top', '-60px');
                    } else if (window.innerWidth >= 860) {
                        this.background.css('top', '-140px');
                    }
                }

                /* Desktop */
                else if (window.innerWidth > 1024) {
                    moveProductsLeft();

                    /* Show the product names */
                    // $('#products_name1').show();
                    // $('#products_name2').show();
                    // $('#products_name3').show();
                    // $('#products_name4').show();
                    // $('#products_name5').show();
                    // $('#products_name6').show();
                    // $('#products_name7').show();
                    // $('#products_name8').show();
                    // $('#products_name9').show();
                    // $('#products_name10').show();
                    // $('#products_name11').show();
                    // $('#products_name12').show();
                } else if (window.innerWidth >= 370 && window.innerWidth < 420) {
                    /* Should be a simple css rule :( */
                    $('#products_background').css('left', '-37px');
                    $('#products_background').css('top', '-240px');
                } else if (window.innerWidth > 320 && window.innerWidth < 370) {
                    $('#products_background').css('left', '-26px');
                    $('#products_background').css('top', '-200px');
                } else if (window.innerWidth <= 320) {
                    $('#products_background').css('left', '-26px');
                    $('#products_background').css('top', '-140px');
                }
            },

            reposition_internal_elements: function(top, middle, bottom) {
                var diff = this.top_value + 0.125 * this.height_value - middle;
                var diff_abs = Math.abs(diff);

                var y_value = diff / 20;
                var x_translate = 0; //this.hide_translate_position*this.width_value;
                ////console.log('y_translate=',y_translate);
                transform_x_y_scale_rotate(this.el_title, x_translate, y_value, this.el_title_scale, 0);
                transform_x_y_scale_rotate(this.el_text, x_translate, y_value, this.el_text_scale, 0);

                var opacity_value = 1.5 - diff_abs / 500;
                opacity(this.el_title, opacity_value);
                opacity(this.el_text, opacity_value);
            },

            commit_parallax: function(top, middle, bottom, hide) {
                var x_translate = this.hide_translate_position * browserWidth;

                if (is_mobile) {
                    transform_x_y(this.el, x_translate, 0);
                } else {
                    if (hide) {
                        transform_x_y(this.el, x_translate, this.parallaxed_diff * 10);
                    } else {
                        transform_x_y(this.el, x_translate, this.parallaxed_diff);
                    }
                }

                this.reposition_internal_elements(top, middle, bottom);
            },


            hide_translate_position: 0,
            hide_translate_position_commited: 0,
            hide_translate_destination: 0,


            animation: function() {
                ////console.log('animation triggered');
                if (!(this.hide_translate_position == this.hide_translate_destination)) {
                    this.hide_translate_position = this.hide_translate_position + (this.hide_translate_destination - this.hide_translate_position) / 8;
                    if (Math.abs(this.hide_translate_destination - this.hide_translate_position) < 0.001) {
                        this.hide_translate_position = this.hide_translate_destination;
                        if (this.hide_translate_position < 0) {
                            this.finishedClosing();
                        } else {
                            this.finishedOpening();
                        }
                    }
                    ////console.log('this.hide_translate_position=',this.hide_translate_position);
                    force_render_paralax_once = true;
                }
            },

            opened: true,
            hidden: false,

            open: function() {
                if (!this.opened) {
                    this.opened = true;
                    this.active = true;
                    this.hidden = false;
                    this.hide_translate_destination = 0;
                    ////console.log('told to open products');
                    this.el.show();

                }
            },

            close: function() {
                if (this.opened) {
                    this.opened = false;
                    ////console.log('told to close products');
                    this.hide_translate_destination = -1;

                }
            },

            finishedOpening: function() {
                sections.products_detail.finishedClosing();
            },

            finishedClosing: function() {
                this.active = false;
                sections.products_detail.finishedOpening();
                this.hidden = true;
                force_render_paralax_once = true;
                ////console.log('finished closing products');
                this.el.hide();
            },

        };



        sections.products_navigation = {

            visible: true,
            active: true,
            el: $('#products_navigation'),
            background: null,
            //get_background_width_value: function(){ return this.width_value},
            //get_background_height_value: function(){ return this.height_value},
            accumulate: false,

            //height_auto:true,
            //calc_height: function(){
            //  //this.height_value=Math.round(browserWidth*this.height_ratio);
            //  //if(this.height_min && this.height_value<this.height_min){
            //  //  this.height_value=this.height_min;
            //  //}
            //},
            //height_ratio: 614/1280,
            //height_min: 500,

            //commit_el_width: function(){ this.el[0].style.width=this.width_value+'px'; },
            commit_el_height: function() {
                this.el[0].style.height = this.height_value + 'px';
            },

            height_value: 100,
            width_value: 0,
            top_value: 0,
            middle_value: 0,
            bottom_value: 0,
            parallaxed_top: 0,
            parallaxed_bottom: 0,
            get_parallax_diff: function(top, middle, bottom) {
                return -top - 100; /*(top-this.top_value)/2;*/
            },
            aba: {
                el: $('#products_aba'),
            },
            button_1: {
                el: $('.products_button[rel="1"]'),
            },
            button_2: {
                el: $('.products_button[rel="2"]'),
            },
            button_3: {
                el: $('.products_button[rel="3"]'),
            },
            button_4: {
                el: $('.products_button[rel="4"]'),
            },
            button_5: {
                el: $('.products_button[rel="5"]'),
            },
            button_6: {
                el: $('.products_button[rel="6"]'),
            },
            button_7: {
                el: $('.products_button[rel="7"]'),
            },
            button_8: {
                el: $('.products_button[rel="8"]'),
            },
            button_9: {
                el: $('.products_button[rel="9"]'),
            },
            button_10: {
                el: $('.products_button[rel="10"]'),
            },
            button_11: {
                el: $('.products_button[rel="11"]'),
            },
            button_12: {
                el: $('.products_button[rel="12"]'),
            },

            internal: {
                el: $('#products_navigation_animation'),
            },

            computer_element_positions: function() {


            },

            afterResize: function() {
                //this.el_title_scale=Math.min(1,browserWidth/1300);
            },

            hide_translate_position: 1,
            hide_translate_position_commited: 1,

            animation: function() {
                this.hide_translate_position = 1 + sections.products.hide_translate_position;
                ////console.log('this.hide_translate_position=',this.hide_translate_position);
            },


            reposition_internal_elements: function(top, middle, bottom) {


            },
            commit_parallax: function(top, middle, bottom, hide) {

                var x_translate = this.hide_translate_position * browserWidth;

                if (is_mobile) {
                    transform_x_y(this.el, 0, -100);
                    transform_x_y(this.internal.el, x_translate, 0);
                } else {
                    transform_x_y(this.el, x_translate, this.parallaxed_diff);
                }

                //transform_y(this.el, this.parallaxed_diff );
                this.reposition_internal_elements(top, middle, bottom);
            },


        };

        function bind_aba(obj, id, active, position) {
            obj.id = id;
            obj.active = active;
            obj.in_display = false;
            obj.activate = function(instantly) {
                ////console.log(obj.el[0].getAttribute('id'),'activate');
                if (!obj.active) {
                    obj.active = true;
                    if (!obj.in_display) {
                        obj.in_display = true;
                        obj.el[0].style.display = 'block';
                    }
                }

            };
            obj.deactivate = function(instantly) {
                ////console.log(obj.el[0].getAttribute('id'),'deactivate');
                if (obj.active) {
                    obj.active = false;
                    if (obj.in_display) {
                        obj.in_display = false;
                        obj.el[0].style.display = 'none';
                    }

                }
            }
        }

        var activated_image;

        function bind_products_image(obj) {
            obj.position = 0;
            obj.destination = 0;
            obj.update_destination = function(num) {
                ////console.log(obj.el[0].getAttribute('id'),'update_destination',num);
                obj.destination = num;
            };
            obj.update_position = function() {
                var diff = (obj.destination - obj.position) / 8;
                var maxmove = Math.max(0.08);
                if (diff < -maxmove) diff = -maxmove;
                if (diff > maxmove) diff = maxmove;

                obj.position += diff;

                if (Math.abs(obj.destination - obj.position) < 0.01) {
                    obj.position = obj.destination;
                }
            };
            obj.in_display = false;
            obj.commit_position = function() {

                obj.el.style.opacity = Math.round(Math.max(0, Math.min(1, obj.position)) * 100) / 100;
                if (obj.position == 0) {
                    if (obj.in_display) {
                        obj.in_display = false;
                        obj.el.style.display = 'none';
                    }
                } else {
                    if (!obj.in_display) {
                        obj.in_display = true;
                        obj.el.style.display = 'block';
                    }
                }
            };
            obj.active = false;
            obj.activate = function() {

                ////console.log(obj.el.getAttribute('id'),'activate');
                if (!obj.active) {
                    obj.active = true;

                    if (activated_image) {
                        activated_image.el.style.zIndex = 2561;
                    }

                    //obj.position=0;
                    activated_image = obj;

                    obj.update_destination(1);

                    activated_image.el.style.zIndex = 2562;
                }

            };
            obj.deactivate = function() {
                ////console.log(obj.el.getAttribute('id'),'deactivate');
                if (obj.active) {
                    obj.active = false;
                    obj.update_destination(0);
                }
            }
        }

        function bind_products_background(obj, id, active, position) {

            obj.id = id;
            obj.position = position;
            obj.destination = position;
            obj.update_destination = function(num) {
                ////console.log(obj.el[0].getAttribute('id'),'update_destination',num);
                obj.destination = num;
            };
            obj.update_position = function() {
                obj.position = obj.destination;
            };
            obj.in_display = false;
            obj.commit_position = function() {

            };
            obj.active = active;
            obj.activate = function(instantly) {
                ////console.log(obj.el[0].getAttribute('id'),'activate');
                if (!obj.active) {
                    obj.active = true;
                    obj.update_destination(1);
                }

            };
            obj.deactivate = function(instantly) {
                ////console.log(obj.el[0].getAttribute('id'),'deactivate');
                if (obj.active) {
                    obj.active = false;
                    obj.update_destination(0);
                }
            }

            obj.animate = function() {
                for (var i = 0; i < obj.images.length; i++) {
                    var img = obj.images[i];
                    if (img.position !== img.destination) {
                        img.update_position();
                        img.commit_position();
                    }
                }
            }

            obj.images = [];

            var imgs = obj.el[0].querySelectorAll('img.products_detail_background' + id);
            Array.prototype.forEach.call(imgs, function(img_el, i) {
                obj.images.push({
                    el: img_el,
                    isImage: true,
                    loaded: false,
                    completed: false,
                    index: i,
                    //fullscreen: hasClass(img_el,'fullscreen'),
                });


            });

            for (var i = 0; i < obj.images.length; i++) {
                var img = obj.images[i];
                bind_products_image(img);
            }

            if (!obj.loaded) {

                obj.loaded = true;
                var completed = true;

                if (obj.images.length) {
                    for (var i = 0; i < obj.images.length; i++) {
                        var img = obj.images[i];

                        completed = false;
                        ////console.log('img.el=',img.el);
                        img.loaded = true;

                        image_cover_container([img.el], browserWidth, sections.products.get_background_height_value());
                    }
                }

                obj.completed = completed;

            }
        }

        sections.divider_after_products = {
            visible: true,
            active: true,
            el: $('#divider_after_products'),
            background: null,
            accumulate: true,

            //commit_el_width: function(){ this.el[0].style.width=this.width_value+'px'; },
            //commit_el_height: function(){ this.el[0].style.height=this.height_value+'px'; },

            height_value: 6,
            width_value: 0,
            top_value: 0,
            middle_value: 0,
            bottom_value: 0,
            parallaxed_top: 0,
            parallaxed_bottom: 0,
            get_parallax_diff: function(top, middle, bottom) {
                return -top;
            },

            commit_parallax: function(top, middle, bottom, hide) {
                if (is_mobile) return;
                transform_y(this.el, this.parallaxed_diff);
                //this.reposition_internal_elements(top,middle,bottom);
            },
        };


        function initialize_products_controls() {
            sections.products_detail.bullets = [];
            var count_dots = 0;
            var bullets = sections.products_detail.controls.el[0].querySelectorAll('li.products_bullet');
            Array.prototype.forEach.call(bullets, function(bullet_el, i) {
                sections.products_detail.bullets.push({
                    el: bullet_el,
                    index: count_dots,
                    hover: false,
                    position: 0.4,
                    destination: 0.4,
                    active: false,
                    visible: false,
                });
                count_dots++;
            });

            for (var i = 0; i < sections.products_detail.bullets.length; i++) {
                var bullet = sections.products_detail.bullets[i];
                bind_bullet(bullet);
            }

            sections.products_detail.el.onmouseenter = function() {
                sections.products_detail.hover = true;
            }

            sections.products_detail.el.onmouseleave = function() {
                sections.products_detail.hover = false;
            }
        }

        var dot_clicked = -1;

        function change_bullet_to_index(new_index) {

            for (var i = 0; i < sections.products_detail.bullets.length; i++) {
                var item = sections.products_detail.bullets[i];
                if (item.visible) {
                    if (item.index == new_index) {
                        //item.destination=1;
                        item.active = true;
                        ////console.log('clicked ',bullet.index);
                        clicked_index = new_index;
                        current_active_dot = new_index;

                    } else {
                        //item.destination=0.4;
                        item.active = false;
                    }
                }
            }
            for (var i = 0; i < current_background_object.images.length; i++) {
                var img = current_background_object.images[i];
                if (img.index == new_index) {
                    img.activate();
                } else {
                    img.deactivate();
                }
            }
        }

        function bind_bullet(bullet) {

            bullet.el.onmouseenter = function() {
                bullet.hover = true;
                bullet.position = 1;
                bullet.destination = 1;
                bullet.commit_position();
            }

            bullet.el.onmouseleave = function() {
                bullet.hover = false;
            }

            function bullet_click() {


                var clicked_index = -1;
                for (var i = 0; i < sections.products_detail.bullets.length; i++) {
                    var item = sections.products_detail.bullets[i];
                    if (item.visible) {
                        if (item.index == bullet.index) {
                            //item.destination=1;
                            item.active = true;
                            ////console.log('clicked ',bullet.index);
                            clicked_index = bullet.index;
                            current_active_dot = bullet.index;

                        } else {
                            //item.destination=0.4;
                            item.active = false;
                        }
                    }
                }

                for (var i = 0; i < current_background_object.images.length; i++) {
                    var img = current_background_object.images[i];
                    if (img.index == clicked_index) {
                        img.activate();
                    } else {
                        img.deactivate();
                    }
                }

                //if(!sections.products_detail.active) return;
                //////console.log('bullet.index=',bullet.index);
                ////menu_open_section(bullet.target);
                //if( bullet.index !== scroll_x_destination ){
                //  dot_clicked=bullet.index;
                //  //scroll_x_destination=bullet.index;
                //  ////console.log('new scroll_x_destination=',scroll_x_destination);
                //}
                //mosaic[scroll_y_destination][scroll_x_destination]
            }

            bullet.el.onmousedown = function(evt) {
                if (evt.buttons == 2) return;
                bullet_click();
            };

            bullet.el.addEventListener('touchstart', function(evt) {
                bullet_click();
                evt.preventDefault();
            }, false);

            bullet.update_destination = function(num) {
                console.log('this=',this);
                this.destination = num;
            }

            bullet.update_position = function() {
                var diff = (this.destination - this.position) / 8;
                var maxmove = Math.max(0.08);
                if (diff < -maxmove) diff = -maxmove;
                if (diff > maxmove) diff = maxmove;

                this.position += diff;
                if (this.destination == 0 || this.destination == 1) {
                    if (Math.abs(this.destination - this.position) < 0.01) {
                        this.position = this.destination;
                    }
                }
            }

            bullet.commit_position = function() {
                bullet.el.style.opacity = Math.round(this.position * 10000) / 10000;
            }
        }

        var current_background_object = null;
        var count_active_dots;
        var current_active_dot = 0;

        function dots_change(background_object) {

            if (current_background_object) {
                for (var i = 0; i < current_background_object.images.length; i++) {
                    var img = current_background_object.images[i];
                    img.deactivate();
                }
            }

            current_active_dot = 0;
            current_background_object = background_object;


            for (var i = 0; i < current_background_object.images.length; i++) {
                var img = current_background_object.images[i];
                if (img.index == 0) {
                    img.activate();
                } else {
                    img.deactivate();
                }
            }

            count_active_dots = background_object.images.length;
            ////console.log('count_active_dots=',count_active_dots);

            //if(count_active_dots>1){
            //  //sections.products_detail.controls.activate();
            //  sections.products_detail.controls.el[0].style.display='block';
            //}else{
            //  sections.products_detail.controls.el[0].style.display='none';
            //  //sections.products_detail.controls.deactivate();
            //  return;
            //}

            for (var i = 0; i < sections.products_detail.bullets.length; i++) {
                var bullet = sections.products_detail.bullets[i];

                if (bullet.index >= count_active_dots) {
                    if (bullet.visible) {
                        bullet.visible = false;
                        bullet.el.style.display = 'none';
                    }
                } else if (bullet.index == 0) {
                    bullet.active = true;
                    if (!bullet.visible) {
                        bullet.visible = true;
                        bullet.el.style.display = 'block';
                    }
                } else {
                    bullet.active = false;
                    if (!bullet.visible) {
                        bullet.visible = true;
                        bullet.el.style.display = 'block';
                    }
                }
            }

            //reposition dots
            ////console.log('dots translate = ',-Math.round((count_active_dots*15)/2));
            if (is_short_width) {
                transform_x_y(sections.products_detail.controls.el, -Math.round((count_active_dots * 42) / 2), 0);
                sections.products_detail.controls.el[0].style.width = count_active_dots * 42 + 'px';
                sections.products_detail.controls.el[0].style.height = 1 * 42 + 'px';
            } else {
                transform_x_y(sections.products_detail.controls.el, 0, -Math.round((count_active_dots * 42) / 2));
                sections.products_detail.controls.el[0].style.height = count_active_dots * 42 + 'px';
                sections.products_detail.controls.el[0].style.width = 1 * 42 + 'px';
            }
        }

        function dots_updater() {
            for (var i = 0; i < sections.products_detail.bullets.length; i++) {
                var bullet = sections.products_detail.bullets[i];
                bullet.index = i;


                if (bullet.hover || bullet.active) {
                    bullet.destination = 1;
                } else {
                    bullet.destination = 0.4;
                }

                if (bullet.destination !== bullet.position) {
                    bullet.update_position();
                    bullet.commit_position();
                }
            }

        }

        sections.buy = {
            visible: true,
            active: true,
            el: $('#buy'),
            background: null, //$('#buy_background'),
            get_background_width_value: function() {
                return this.width_value
            },
            get_background_height_value: function() {
                return this.height_value
            },
            accumulate: true,

            //height_auto:true,
            calc_height: function() {
                if (is_short_width) {
                    this.height_value = Math.max(browserHeight, 400);
                } else {
                    this.height_value = Math.round(browserWidth * this.height_ratio);
                    if (this.height_min && this.height_value < this.height_min) {
                        this.height_value = this.height_min;
                    }
                }
            },
            height_ratio: 480 / 1440,
            height_min: 480,

            //commit_el_width: function(){ this.el[0].style.width=this.width_value+'px'; },
            commit_el_height: function() {
                this.el[0].style.height = this.height_value + 'px';
            },

            height_value: 0,
            width_value: 0,
            top_value: 0,
            middle_value: 0,
            bottom_value: 0,
            parallaxed_top: 0,
            parallaxed_bottom: 0,
            get_parallax_diff: function(top, middle, bottom) {
                return -top;
            },

            el_title: $('#buy_title'),
            el_text: $('#buy_text'),
            el_button: $('#buy_button'),

            el_title_scale: 1,
            el_text_scale: 1,



            afterResize: function() {
                //this.el_title_scale=Math.min(1,browserWidth/1300);
            },

            reposition_internal_elements: function(top, middle, bottom) {
                var diff = this.middle_value - middle;
                var diff_abs = Math.abs(diff);

                var y_value = diff / 20;
                transform_x_y_scale_rotate(this.el_title, 0, y_value, this.el_title_scale, 0);
                transform_x_y_scale_rotate(this.el_text, 0, y_value, this.el_text_scale, 0);
                transform_x_y_scale_rotate(this.el_button, 0, y_value, this.el_text_scale, 0);

                var opacity_value = 1.5 - diff_abs / 500;
                opacity(this.el_title, opacity_value);
                opacity(this.el_text, opacity_value);
                opacity(this.el_button, opacity_value);

            },
            commit_parallax: function(top, middle, bottom, hide) {
                if (is_mobile) return;
                transform_y(this.el, this.parallaxed_diff);
                this.reposition_internal_elements(top, middle, bottom);
            },
        };

        sections.footer = {
            visible: true,
            active: true,
            el: $('#footer'),
            background: null,
            accumulate: true,
            subsection: 'any',

            //commit_el_width: function(){ this.el[0].style.width=this.width_value+'px'; },
            // commit_el_height: function(){this.el[0].style.height=this.height_value+'px';},

            height_value: 60,
            width_value: 0,
            top_value: 0,
            middle_value: 0,
            bottom_value: 0,
            parallaxed_top: 0,
            parallaxed_bottom: 0,
            get_parallax_diff: function(top, middle, bottom) {
                return -top;
            },
            reposition_internal_elements: function(top, middle, bottom) {

            },

            commit_parallax: function(top, middle, bottom, hide) {
                if (is_mobile) return;
                transform_y(this.el, this.parallaxed_diff);
                this.reposition_internal_elements(top, middle, bottom);
            },
        };


        var browserWidth = 0;
        var browserHeight = 0;

        var main_resize_handler = function() {

                browserWidth = $(window).width();
                browserHeight = $(window).height();
                calc_dpr();

                var new_is_short_width = browserWidth < smallScreenWidth;

                if (new_is_short_width !== is_short_width) {
                    location.reload();
                }

                grid.recalc();

                globalScrollTop_eased_rounded_old = null;

                var accumulated_height = 0;

                $.each(sections, function(key, section) {

                    //if(!section.active) return;

                    if (section.subsection == 'any') {
                        //always render
                        //console.log('always show ',key);
                    } else {
                        if (current_subsection && !section.subsection) {
                            //does not render
                            //console.log('does not show ',key);
                            section.el[0].style.display = 'none';
                            return;

                        } else if (!current_subsection && !section.subsection) {
                            //console.log('show2 ',key);
                            if (section.visible && section.active) {
                                section.el[0].style.display = 'block';
                            }
                        } else {
                            if (current_subsection === section.subsection) {
                                //it is the same, render
                                //console.log('show ',key);
                                if (section.visible && section.active) {
                                    section.el[0].style.display = 'block';
                                }

                            } else {
                                //not the same subsection
                                //console.log('not the same subsection so hide',key);
                                section.el[0].style.display = 'none';
                                return;
                            }
                        }
                    }

                    section.top_value = Math.round(accumulated_height);
                    section.el[0].style.top = section.top_value + 'px';

                    section.width_value = browserWidth;

                    if (section.calc_height) {
                        //set new height
                        section.calc_height();
                        //section.el[0].style.height=section.height_value+'px';
                        section.commit_el_height();
                    } else {
                        section.height_value = section.el.height();
                    }

                    if (section.width_auto) {
                        section.width_value = Math.round(browserWidth);
                        section.commit_el_width();
                    }




                    section.bottom_value = Math.round(section.top_value + section.height_value);
                    section.middle_value = (section.bottom_value + section.top_value) / 2;

                    if (section.accumulate) {
                        accumulated_height += section.height_value;
                    }



                    if (section.background && section.background.length) {
                        image_cover_container(section.background, section.get_background_width_value(), section.get_background_height_value());
                    }

                    if (section.computer_element_positions) section.computer_element_positions();

                    ////console.log('accumulated_height=',accumulated_height);
                });

                body.height_value = Math.round(accumulated_height);

                if (allow_body_size) {
                    body.commit();
                }

                $.each(sections, function(key, section) {
                    section.visible = true;
                });
                $.each(sections, function(key, section) {
                    if (section.afterResize) section.afterResize();
                });


                /**
                 * We apply this restriction to prevent this code from running on mobile landscape.
                 * If it does, when the visibility status of the mobile browsers' address bars changes (shows up
                 * or hides), the height of the images is recalculated, fucking everything up.
                 */
                if (is_mobile == false || (is_mobile && is_short_width)) {
                    sections.products_detail.el.find('img').each(function() {
                        //sections.products.get_background_width_value()
                        image_cover_container($(this), browserWidth, sections.products.get_background_height_value());
                    });
                } else {
                    fixStorytellingLandscape(is_mobile, is_short_width, current_slug);
                }

                //if(main_loader_completed){
                //  storytelling_slider.adapt();
                //}

                treshold_buy = Math.min(body.height_value - browserHeight, sections.buy.top_value) - 100;
                treshold_products = (sections.products.top_value - (browserHeight - sections.products.height_value) / 2 - 50);
                treshold_wall = sections.wall.top_value - 100;
            }
            //add_resize_handler(main_resize_handler,0);




        var animating_globalScrollTop = false;
        var globalScrollTop_destination = 0;
        var globalScrollTop = $(window).scrollTop();
        var globalScrollTop_old = globalScrollTop;
        var globalScrollTop_eased = globalScrollTop;
        var globalScrollTop_eased_rounded = globalScrollTop;
        var globalScrollTop_eased_rounded_old = 0;
        var force_render_paralax_once = false;
        var visible_top = 0;
        var visible_bottom = 0;
        var visible_middle = 0;

        //var scrollHandlersByPriority=[[],[],[],[],[],[]];

        if (is_mobile) {
            //$('body')[0].addEventListener('touchmove', function(){
            //  if(!animating_globalScrollTop){
            //    globalScrollTop=$(window).scrollTop()
            //  }
            //}, false);

            //$('body').bind('touchmove', function(e) {
            //  if(!animating_globalScrollTop){
            //    globalScrollTop_eased_rounded=globalScrollTop=$(window).scrollTop()
            //  }
            //
            //});
            //}else{
        } else {
            $(document).scroll(function() {
                if (!animating_globalScrollTop) {
                    globalScrollTop = $(window).scrollTop()
                }
            });
            $(window).scroll(function() {
                if (!animating_globalScrollTop) {
                    globalScrollTop = $(window).scrollTop()
                }
            });
        }
        //}


        var treshold_buy;
        var treshold_products;
        var treshold_wall;
        var count_measure_scroll_top = 0;
        var force_scroll_to_top = 5;
        var updater_count = 0;
        var first_run = true;
        var updater_fullfill_subcriptions = function(forceParalaxRender) {
            updater_count++;

            //switch(updater_count){
            //  //removepackshots//case 1:  bind_scalable(sections.products_navigation.packshot_1,             '1', true,   1 );  break;
            //  //removepackshots//case 2:  bind_scalable(sections.products_navigation.packshot_2,             '2', true,   1 );  break;
            //  //removepackshots//case 3:  bind_scalable(sections.products_navigation.packshot_3,             '3', true,   1 );  break;
            //  //removepackshots//case 4:  bind_scalable(sections.products_navigation.packshot_4,             '4', true,   1 );  break;
            //  //remove-products-symbol//case 5:  bind_scalable(sections.products_navigation.symbol_1,               '1', false,  0 );   break;
            //  //remove-products-symbol//case 6:  bind_scalable(sections.products_navigation.symbol_2,               '2', false,  0 );   break;
            //  //remove-products-symbol//case 7:  bind_scalable(sections.products_navigation.symbol_3,               '3', false,  0 );   break;
            //  //remove-products-symbol//case 8:  bind_scalable(sections.products_navigation.symbol_4,               '4', false,  0 );   break;
            //}



            if (current_subsection_old === current_subsection) {
                //do nothing
            } else {

                //console.log('change to subsection ', current_subsection);

                main_resize_handler();

                current_subsection_old = current_subsection;

                if (!current_subsection) {
                    go_to_path(current_subsection_back_to_path, true);
                    current_subsection_back_to_path = '/';
                } else {
                    current_subsection_back_to_path = current_slug;
                    globalScrollTop_destination = globalScrollTop = globalScrollTop_old = globalScrollTop_eased = globalScrollTop_eased_rounded = globalScrollTop_eased_rounded_old = 0;
                    force_scroll_to_top = 5;
                }

                force_render_paralax_once = true;


                needs_resize = false;

            }

            if (needs_resize) {
                main_resize_handler();
                needs_resize = false;
                return;
            }

            if (force_scroll_to_top > 0) {
                force_scroll_to_top--;
                $(window).scrollTop(0);
                //console.log('scroll to top');
            }

            if ( /*sections.buy.visible &&*/ updater_count > 5) {
                run_map();
            }

            if (animating_globalScrollTop) {

                globalScrollTop = globalScrollTop_destination;
                //console.log('animating_globalScrollTop=',globalScrollTop);
                ////console.log('animating scrolltop',globalScrollTop);
                $(window).scrollTop(globalScrollTop_eased);
                if (Math.abs(globalScrollTop_eased - globalScrollTop_destination) < 2) {
                    animating_globalScrollTop = false;
                    ////console.log('stop animating scrolltop');
                }
            } else {
                if (is_mobile) {
                    count_measure_scroll_top++;
                    if (count_measure_scroll_top > 10) {
                        count_measure_scroll_top = 0;
                        globalScrollTop = $(window).scrollTop();
                    }

                }
            }

            globalScrollTop_eased += (globalScrollTop - globalScrollTop_eased) / 8;
            globalScrollTop_eased_rounded = Math.round(globalScrollTop_eased);

            if (!animating_globalScrollTop && intro_completed) {
                var new_slug = '/';

                if (current_subsection) {
                    switch (current_subsection) {
                        case 2:
                            new_slug = '/harmonizacoes_cioccolato_nero/';
                            break;
                        case 1:
                            new_slug = '/harmonizacoes_vaniglia/';
                            break;
                        case 3:
                            new_slug = '/harmonizacoes_caramello_salato/';
                            break;
                        case 4:
                            new_slug = '/harmonizacoes_limoncello/';
                            break;
                        case 5:
                            new_slug = '/harmonizacoes_pistacchio/';
                            break;
                        case 6:
                            new_slug = '/harmonizacoes_panna_cotta/';
                            break;
                        case 7:
                            new_slug = '/harmonizacoes_gianduia/';
                            break;
                        case 8:
                            new_slug = '/harmonizacoes_fragola/';
                            break;
                        case 9:
                            new_slug = '/harmonizacoes_cappuccino/';
                            break;
                        case 10:
                            new_slug = '/harmonizacoes_limoncello_picole/';
                            break;
                        case 11:
                            new_slug = '/harmonizacoes_pisctacchio_picole/';
                            break;
                        case 12:
                            new_slug = '/harmonizacoes_fragola_picole/';
                            break;
                    }
                } else if (globalScrollTop_eased_rounded > treshold_buy) {
                    new_slug = '/dove_trovare/';

                } else if (globalScrollTop_eased_rounded > treshold_products) {
                    new_slug = '/isapori/';

                    if (sections.products_detail.opened) {
                        if (current_product == 2) {
                            new_slug = '/cioccolato_nero/';
                        } else if (current_product == 1) {
                            new_slug = '/vaniglia/';
                        } else if (current_product == 3) {
                            new_slug = '/caramello_salato/';
                        } else if (current_product == 4) {
                            new_slug = '/limoncello/';
                        } else if (current_product == 5) {
                            new_slug = '/pistacchio/';
                        } else if (current_product == 6) {
                            new_slug = '/panna_cotta/';
                        } else if (current_product == 7) {
                            new_slug = '/gianduia/';
                        } else if (current_product == 8) {
                            new_slug = '/fragola/';
                        } else if (current_product == 9) {
                            new_slug = '/cappuccino/';
                        } else if (current_product == 10) {
                            new_slug = '/limoncello_picole/';
                        } else if (current_product == 11) {
                            new_slug = '/pisctacchio_picole/';
                        } else if (current_product == 12) {
                            new_slug = '/fragola_picole/';
                        }
                    }

                } else if (globalScrollTop_eased_rounded > treshold_wall) {
                    new_slug = '/la_mia_gelateria/';
                }
                if (new_slug !== current_slug) {
                    current_slug = new_slug;
                    if (window.history && window.history.pushState) {
                        window.history.pushState('', document.title, new_slug);
                    }

                    /**
                     * Several fixes needed to make the Storytelling section work on mobile landscape
                     */
                    fixStorytellingLandscape(is_mobile, is_short_width, current_slug);
                    fixFooterPosition(is_mobile, current_slug, already_fixed_footer);
                }


            }

            visible_top = globalScrollTop_eased_rounded;
            visible_bottom = visible_top + browserHeight;
            visible_middle = (visible_bottom + visible_top) / 2;

            if (menu.position !== menu.destination) {
                menu.update_position();
                menu.commit_position();
            }

            if (sections.products_detail.opened || sections.products_detail.hide_translate_position !== 1) {
                if (sections.products_detail.backgrounds.position !== sections.products_detail.backgrounds.destination) {
                    sections.products_detail.backgrounds.update_position();
                    sections.products_detail.backgrounds.commit_position();
                }

                sections.products_detail.background_1.animate();
                sections.products_detail.background_2.animate();
                sections.products_detail.background_3.animate();
                sections.products_detail.background_4.animate();
                sections.products_detail.background_5.animate();
                sections.products_detail.background_6.animate();
                sections.products_detail.background_7.animate();
                sections.products_detail.background_8.animate();
                sections.products_detail.background_9.animate();
                sections.products_detail.background_10.animate();
                sections.products_detail.background_11.animate();
                sections.products_detail.background_12.animate();

                dots_updater();
            }

            if (products_background.position !== products_background.destination) {
                products_background.update_position();
                products_background.commit_position();
            }


            sections.products.animation();
            sections.products_detail.animation();
            sections.products_navigation.animation();

            if (grid_slider) {
                grid_slider.update();
            }


            if (is_mobile) {
                if (forceParalaxRender || sections.products_detail.opened || sections.products_detail.hide_translate_position !== 1) {

                    if (!current_subsection) {
                        sections.products.commit_parallax();
                        sections.products_detail.commit_parallax();
                        sections.products_navigation.commit_parallax();
                    }
                }
            } else {
                if (forceParalaxRender || (globalScrollTop_eased_rounded !== globalScrollTop_eased_rounded_old) || force_render_paralax_once) {
                    $.each(sections, function(key, section) {

                        if (section.subsection == 'any') {
                            //always render
                            //console.log('always render ',key);
                        } else {
                            if (current_subsection && !section.subsection) {
                                //does not render
                                //console.log('does not render ',key);
                                return;

                            } else if (!current_subsection && !section.subsection) {
                                //console.log('show2 ',key);


                            } else {
                                if (current_subsection === section.subsection) {
                                    //it is the same, render
                                    //console.log('render ',key);
                                } else {
                                    //not the same subsection
                                    //console.log('not the same subsection ',key);
                                    return;
                                }
                            }
                        }
                        if (!section.active && !section.always_visible) return;

                        ////console.log('try');
                        section.parallaxed_diff = section.get_parallax_diff(visible_top, visible_middle, visible_bottom);

                        section.parallaxed_top = Math.round(section.top_value + section.parallaxed_diff + visible_top);
                        section.parallaxed_bottom = Math.round(section.bottom_value + section.parallaxed_diff + visible_top);



                        var visible;

                        if (section.hidden) {
                            visible = false;
                            section.visible = true;
                            //console.log('something hidden here and it is ',key);
                        } else if (section.always_visible) {
                            visible = true;
                            section.visible = true;
                        } else if (section.parallaxed_top > visible_bottom) {
                            //section.el[0].style.display='none';
                            visible = false;
                        } else if (section.parallaxed_bottom < visible_top) {
                            //section.el[0].style.display='none';
                            visible = false;
                        } else {
                            visible = true;
                            section.visible = true;
                            //section.el[0].style.display='block';
                        }
                        if (section.visible) {
                            //
                            if (!visible) {
                                section.commit_parallax(visible_top, visible_middle, visible_bottom, true);
                            } else {
                                section.commit_parallax(visible_top, visible_middle, visible_bottom, false);
                            }

                        }
                        section.visible = visible;

                        //section.el.attr($.extend(section,{
                        //  'visible_top': visible_top,
                        //  'visible_bottom': visible_bottom
                        //}));


                        ////console.log('accumulated_height=',accumulated_height);
                    });

                    globalScrollTop_eased_rounded_old = globalScrollTop_eased_rounded;


                }
            }

            /*
          var tmp_subscriptions_object=updater_subscriptions_object;
          var tmp_subscriptions_array=updater_subscriptions_array;
          updater_subscriptions_object={};
          updater_subscriptions_array=[];
          $.each( tmp_subscriptions_object, function( key, value ) {
              ////console.log( key );
              value();
          });
          $.each( tmp_subscriptions_array, function( index, value ) {
              ////console.log( index );
              value();
          });
      */

            if (first_run) {
                first_run = false;
                //if(wrapper.el.length){
                //  wrapper.el.removeClass('hidden');
                //}
                $.each(sections, function(key, section) {
                    if (!section.active) return;
                    section.visible = true;
                    section.el.removeClass('hidden');
                });


            }
        }

        var sharebox = false;


        function share(card) {

            if (!sharebox) {
                sharebox =   {
                    el: $('#share'),
                    close_el: $('#share_close'),
                    title_el: $('#share_title'),
                    text_el: $('#share_text'),
                    facebook_el: $('#share_facebook'),
                    twitter_el: $('#share_twitter'),

                    card: null,
                    open: function() {
                        sharebox.el.fadeIn();
                    },

                    close: function() {
                        sharebox.el.fadeOut();
                    },
                }

                sharebox.close_el.on('touchstart mousedown', function() {
                    sharebox.close();
                });

                sharebox.facebook_el.on('click', function() {
                    ////console.log('share on facebook');
                    var winWidth = 520;
                    var winHeight = 350;
                    var winTop = (screen.height / 2) - (winHeight / 2);
                    var winLeft = (screen.width / 2) - (winWidth / 2);
                    var url = 'http://www.nestlegelato.com.br' + sharebox.card.data('permalink');
                    //url='http://www.google.com';
                    //window.open('http://www.facebook.com/sharer.php?s=100&p[title]=' + title + '&p[summary]=' + descr + '&p[url]=' + url + '&p[images][0]=' + image, 'sharer', 'top=' + winTop + ',left=' + winLeft + ',toolbar=0,status=0,width=' + winWidth + ',height=' + winHeight);
                    window.open('http://www.facebook.com/sharer.php?s=100&p[title]=' + '&p[url]=' + url, 'sharer', 'top=' + winTop + ',left=' + winLeft + ',toolbar=0,status=0,width=' + winWidth + ',height=' + winHeight);

                });

                sharebox.twitter_el.on('click', function() {
                    //console.log('share on twitter');



                    var winWidth = 520;
                    var winHeight = 253;
                    var winTop = (screen.height / 2) - (winHeight / 2);
                    var winLeft = (screen.width / 2) - (winWidth / 2);
                    var url = 'https://twitter.com/intent/tweet?text=' + encodeURI('Nestlé Gelato. Inspirado nas autênticas gelaterias italianas. L\'arte italiana. Per te. ') + escape('http://www.nestlegelato.com.br' + sharebox.card.data('permalink'));
                    //url='http://www.google.com';
                    //window.open('http://www.facebook.com/sharer.php?s=100&p[title]=' + title + '&p[summary]=' + descr + '&p[url]=' + url + '&p[images][0]=' + image, 'sharer', 'top=' + winTop + ',left=' + winLeft + ',toolbar=0,status=0,width=' + winWidth + ',height=' + winHeight);
                    window.open(url, 'sharer', 'top=' + winTop + ',left=' + winLeft + ',toolbar=0,status=0,width=' + winWidth + ',height=' + winHeight);
                });

            }

            sharebox.card = card;
            sharebox.open();


        }



        var updater_run = function() {
            ////console.log('animator run');
            window.requestAnimationFrame(updater_run);
            updater_fullfill_subcriptions();
        }




        //removepackshots//sections.products_navigation.el.each(function(){
        //removepackshots// $(this).find('.products_packshot,.products_button,.products_symbol').on('click',function(){
        //removepackshots//   ////console.log('clicou ',$(this).attr('rel'));
        //removepackshots//   sections.products_detail.open($(this).attr('rel'));
        //removepackshots// });
        //removepackshots//});

        //sections.products_navigation.el.each(function(){




        var map = {
            initialized: false,
            el: document.getElementById("map"),
            gmap: null,
            initialLocation: null,
            geolocationInitialized: false,
            markersInitialized: false,
            youMarker: null,
            lastLat: ' -23.5505199',
            lastLng: '-46.63330939999997',
            pdvList: null,

            initializeMarkers: function() {
                if (map.markersInitialized) {
                    return;
                }
                map.markersInitialized = true;

                //Read markers file
                $.get("/markers.json", {}, function(data) {
                    map.pdvList = data;
                }, "json");
            },

            putYouMarker: function(latLng) {
                //console.log('latLng=',latLng);
                map.lastLat = latLng.lat();
                map.lastLng = latLng.lng();
                if (map.youMarker) {
                    map.youMarker.setPosition(latLng);
                } else {
                    map.youMarker = new google.maps.Marker({
                        position: latLng,
                        map: map.gmap,
                        title: 'Você',
                        icon: {
                            url: '/images/icons/you.png',
                            scaledSize: new google.maps.Size(55, 40), // scaled size
                            origin: new google.maps.Point(0, 0), // origin
                            anchor: new google.maps.Point(54 / 2, 40) // anchor
                        },
                    });
                }
            },

            initializeGeolocation: function() {
                if (!map.geolocationInitialized) {
                    map.geolocationInitialized = true;
                    if (navigator.geolocation) {
                        browserSupportFlag = true;
                        navigator.geolocation.getCurrentPosition(function(position) {
                            map.initialLocation = new google.maps.LatLng(position.coords.latitude, position.coords.longitude);
                            map.gmap.setZoom(16);
                            map.gmap.setCenter(map.initialLocation);
                            map.putYouMarker(map.initialLocation);
                            map.updateMarkers();

                        }, function() {
                            // Update markers regardless of geolocation permission
                            map.updateMarkers();
                        });
                    } else {
                        // Update markers regardless of geolocation capabilities
                        map.updateMarkers();
                    }
                }
            },

            initialize: function() {

                var customMapType = new google.maps.StyledMapType([{
                    "featureType": "all",
                    "elementType": "labels.text.fill",
                    "stylers": [{
                        "saturation": 36
                    }, {
                        "color": "#4d4d4d"
                    }, {
                        "lightness": 0
                    }]
                }, {
                    "featureType": "all",
                    "elementType": "labels.text.stroke",
                    "stylers": [{
                        "visibility": "on"
                    }, {
                        "color": "#101010"
                    }, {
                        "lightness": 0
                    }]
                }, {
                    "featureType": "all",
                    "elementType": "labels.icon",
                    "stylers": [{
                        "visibility": "off"
                    }]
                }, {
                    "featureType": "administrative",
                    "elementType": "geometry.fill",
                    "stylers": [{
                        "color": "#171717"
                    }, {
                        "lightness": 0
                    }]
                }, {
                    "featureType": "administrative",
                    "elementType": "geometry.stroke",
                    "stylers": [{
                        "color": "#171717"
                    }, {
                        "lightness": 0
                    }, {
                        "weight": 1.2
                    }]
                }, {
                    "featureType": "landscape",
                    "elementType": "geometry",
                    "stylers": [{
                        "color": "#171717"
                    }, {
                        "lightness": 0
                    }]
                }, {
                    "featureType": "poi",
                    "elementType": "geometry",
                    "stylers": [{
                        "color": "#101010"
                    }, {
                        "lightness": 0
                    }]
                }, {
                    "featureType": "road.highway",
                    "elementType": "geometry.fill",
                    "stylers": [{
                        "color": "#141414"
                    }, {
                        "lightness": 0
                    }]
                }, {
                    "featureType": "road.highway",
                    "elementType": "geometry.stroke",
                    "stylers": [{
                        "color": "#141414"
                    }, {
                        "lightness": 0
                    }, {
                        "weight": 0.2
                    }]
                }, {
                    "featureType": "road.arterial",
                    "elementType": "geometry",
                    "stylers": [{
                        "color": "#101010"
                    }, {
                        "lightness": 0
                    }]
                }, {
                    "featureType": "road.local",
                    "elementType": "geometry",
                    "stylers": [{
                        "color": "#101010"
                    }, {
                        "lightness": 0
                    }]
                }, {
                    "featureType": "transit",
                    "elementType": "geometry",
                    "stylers": [{
                        "color": "#101010"
                    }, {
                        "lightness": 0
                    }]
                }, {
                    "featureType": "water",
                    "elementType": "geometry",
                    "stylers": [{
                        "color": "#000000"
                    }, {
                        "lightness": 0
                    }]
                }]);
                var customMapTypeId = 'custom_style';

                var options = {
                    zoom: 16,
                    //minZoom: 14,
                    mapTypeId: google.maps.MapTypeId.ROADMAP,
                    center: {
                        lat: -23.5505199,
                        lng: -46.63330939999997
                    }, //são paulo
                    mapTypeControlOptions: {
                        mapTypeIds: [google.maps.MapTypeId.ROADMAP, customMapTypeId]
                    },
                    panControl: true,
                    zoomControl: true,
                    mapTypeControl: false,
                    scaleControl: false,
                    streetViewControl: false,
                    overviewMapControl: false,
                    backgroundColor: '#101010',
                };

                var browserSupportFlag = new Boolean();

                map.gmap = new google.maps.Map(map.el, options);
                map.gmap.mapTypes.set(customMapTypeId, customMapType);
                map.gmap.setMapTypeId(customMapTypeId);

                //create the marker
                map.updateMarkers = function() {

                    if (map.pdvList !== null && map.gmap.getZoom() >= 14) {
                        for (var i = 0; i < map.pdvList.length; i++) {
                            var pdv = map.pdvList[i];
                            var latlngpdv = new google.maps.LatLng(pdv.lat, pdv.lng);
                            if (map.gmap.getBounds().contains(latlngpdv)) {
                                var marker = new google.maps.Marker({
                                    position: latlngpdv,
                                    map: map.gmap,
                                    title: pdv.content,
                                    icon: '/images/icons/' + pdv.icon + '4.png'
                                });
                                map.infoBox(map, marker, pdv);
                            }
                        }
                    }
                };

                map.gmap.addListener('dragend', function(e) {
                    map.updateMarkers();
                });

                map.gmap.addListener('zoom_changed', function(e) {
                    map.updateMarkers();
                });


                var infoWindow = new google.maps.InfoWindow();
                map.infoBox = function(map, marker, data) {
                    // Attaching a click event to the current marker
                    var evtbind = 'mouseover';
                    if (is_mobile) {
                        evtbind = 'click';
                    }

                    google.maps.event.addListener(marker, evtbind, function(e) {

                        infoWindow.setContent(data.content);

                        var addrfriendly = data.address.split('\xa0').join(' ').split('CEP').join('').split(',').join(' ').split('  ').join(' ');
                        var addrfriendlyescaped = encodeURI(addrfriendly); //.split('%C2%A0').join('%20').split('%26nbsp%3B').join('%20').split('%20%20').join('%20');

                        var route = 'http://maps.google.com/maps?saddr=' + map.lastLat + ',' + map.lastLng + '&daddr=' + addrfriendlyescaped; //

                        var content = '<div id="content" class="gmap-info-window">';
                        content += '<div class="top"></div>';
                        content += '<div class="internal">';
                        if (data.title && data.title.length) content += '<div class="gmap-info-window-title">' + data.title + '</div>';
                        if (data.address && data.address.length) content += '<div>Endereço: ' + data.address + '</div>';
                        if (data.phone && data.phone.length) content += '<div class="gmap-info-window-phone">Telefone: ' + data.phone + '</div>';

                        content += '<div class="gmap-info-window-route"><a href="' + route + '" target="_blank">TRAÇAR ROTA</a></div>';

                        content += '</div>';
                        content += '<div class="bottom"></div>';
                        content += '</div>';
                        infoWindow.setContent(content);
                        infoWindow.open(map.gmap, marker);

                        var iwOuter = $('.gm-style-iw');
                        var iwBackground = iwOuter.prev();
                        var iwArrow = iwOuter.next();
                        // Remove the background shadow DIV
                        iwBackground.children(':nth-child(2)').css({
                            'display': 'none'
                        });
                        iwBackground.children(':nth-child(4)').css({
                            'display': 'none'
                        });
                        iwArrow.css({
                            'display': 'none'
                        });
                        iwBackground.css({
                            'display': 'none'
                        });
                    });
                }



                // Browser doesn't support Geolocation
                //else {
                //  browserSupportFlag = false;
                //  handleNoGeolocation(browserSupportFlag);
                //}

                $('#buy_searchbutton,#buy_button').on('mousedown', function() {
                    if ($('#buy_searchfield')[0].style.display == 'block') {
                        $('#buy_form').submit();
                    } else {
                        map.initializeGeolocation();
                        $('#buy_title').fadeOut();
                        $('#buy_text').fadeOut();
                        $('#buy_button').fadeOut();
                        $('#buy_searchbutton').fadeIn();
                        $('#buy_searchfield').fadeIn();
                        $('#map-disabler').hide();
                    }
                });

                $('#buy_form').submit(function(evt) {
                    evt.preventDefault();
                    //var input = document.getElementById('latlng').value;
                    //var latlngStr = input.split(',', 2);
                    //var latlng = {lat: parseFloat(latlngStr[0]), lng: parseFloat(latlngStr[1])};
                    //
                    ////console.log('input val = ',$('#buy_input').val());
                    //map.gmap.setCenter({ address: $('#buy_input').val()});

                    //infowindow = new google.maps.InfoWindow();

                    $('#buy_searchfield').fadeOut();

                    var geocoder = new google.maps.Geocoder();
                    var geocodeOptions = {
                        'address': $('#buy_input').val(),
                        region: 'BR',
                    };
                    ////console.log('geocodeOptions=',geocodeOptions);
                    geocoder.geocode(geocodeOptions, function(results, status) {
                        if (status === google.maps.GeocoderStatus.OK) {
                            if (results[0]) {
                                map.gmap.setZoom(16);
                                map.gmap.setCenter(results[0].geometry.location);
                                map.putYouMarker(results[0].geometry.location);
                                map.updateMarkers();
                            } else {
                                map.updateMarkers();
                            }
                        } else {
                            map.updateMarkers();
                        }
                    });

                    //var service = new google.maps.places.PlacesService(map.gmap);
                    //  service.nearbySearch({
                    //    location: pyrmont,
                    //    radius: 500,
                    //    types: ['address']
                    //  }, callback);
                    //}
                    //
                    //function callback(results, status) {
                    //  if (status === google.maps.places.PlacesServiceStatus.OK) {
                    //    for (var i = 0; i < results.length; i++) {
                    //      //console.log('results[i]=',results[i]);
                    //      //createMarker(results[i]);
                    //    }
                    //  }
                    //}
                    //
                    //function createMarker(place) {
                    //  var placeLoc = place.geometry.location;
                    //  var marker = new google.maps.Marker({
                    //    map: map,
                    //    position: place.geometry.location
                    //  });
                    //
                    //  google.maps.event.addListener(marker, 'click', function() {
                    //    infowindow.setContent(place.name);
                    //    infowindow.open(map, this);
                    //  });
                    //}

                    return false;
                })

                map.initializeMarkers();

                map.initialized = true;
            },

            //handleNoGeolocation: function(errorFlag) {
            //  if (errorFlag == true) {
            //    alert("Geolocation service failed.");
            //    map.initialLocation = google.maps.LatLng(60, 105);
            //  } else {
            //    alert("Your browser doesn't support geolocation. We've placed you in Siberia.");
            //    map.initialLocation = google.maps.LatLng(40.69847032728747, -73.9514422416687);
            //  }
            //  map.gmap.setCenter(map.initialLocation);
            //},


            // Try W3C Geolocation (Preferred)

        };

        var run_map = function() {

            ////console.log('run_map');

            if (!map.initialized) {
                //console.log('would initialize map');
                if (is_google_api_loaded && is_google_maps_api_loaded && typeof google === 'object' && typeof google.maps === 'object') {
                    //console.log('will initialize map');
                    map.initialize();
                }
            }


        }


        var menu = {
            el: document.getElementById('menu'),
            menu_link_el: document.getElementById('menu_link'),
            position: -1,
            destination: -1,
            reset: function() { /*suspectLoop();*/

            },
            update_destination: function(num) {
                this.destination = num;
            },
            update_position: function() { /*suspectLoop();*/
                var diff = (this.destination - this.position) / 2;
                var maxmove = Math.max(0.08);
                if (diff < -maxmove) diff = -maxmove;
                if (diff > maxmove) diff = maxmove;

                this.position += diff;
                if (this.destination == 0 || this.destination == 1) {
                    if (Math.abs(this.destination - this.position) < 0.01) {
                        this.position = this.destination;
                    }
                }
            },


            out_of_screen: true,
            commit_position: function() { /*suspectLoop();*/

                this.el.style.opacity = 1 + this.position;

                //transform_x_y_percent([this.el],0,this.position*100);
                //transform_x_y_vwvh([this.menu_link_el],0,100+this.position*100);

                if (this.position == -1) {
                    if (!this.out_of_screen) {
                        this.out_of_screen = true;
                        this.el.style.display = 'none';
                        //transform_x_y_percent(this.el,100,0);
                    }
                } else {
                    if (this.out_of_screen) {
                        this.out_of_screen = false;
                        this.el.style.display = 'block';
                        //transform_x_y_percent(this.el,0,0);
                    }
                }

            },

            opened: false,

            open: function() {
                if (!this.opened) {
                    this.opened = true;

                    this.update_destination(0);
                }
            },

            close: function() {
                if (this.opened) {
                    this.opened = false;

                    this.update_destination(-1);

                }
            },
        };

        //      var storytelling = {
        //        el: document.getElementById('storytelling'),
        //      position:-1,
        //      destination:-1,
        //      reset: function(){ /*suspectLoop();*/
        //
        //      },
        //      update_destination: function(num){
        //        this.destination=num;
        //      },
        //      update_position: function(){ /*suspectLoop();*/
        //        var diff=(this.destination-this.position)/2;
        //        var maxmove=Math.max(0.08);
        //        if(diff<-maxmove) diff=-maxmove;
        //        if(diff> maxmove) diff= maxmove;
        //
        //        this.position+=diff;
        //        if(this.destination==0 || this.destination==1){
        //          if(Math.abs(this.destination-this.position)<0.01){
        //            this.position=this.destination;
        //          }
        //        }
        //      },
        //
        //
        //      out_of_screen: true,
        //      commit_position: function(){ /*suspectLoop();*/
        //
        //        this.el.style.opacity=this.position;
        //
        //        //transform_x_y_percent([this.el],0,this.position*100);
        //        //transform_x_y_vwvh([this.menu_link_el],0,100+this.position*100);
        //
        //        if(this.position==0){
        //          if(!this.out_of_screen){
        //            this.out_of_screen=true;
        //            this.el.style.display='none';
        //            //transform_x_y_percent(this.el,100,0);
        //          }
        //        }else{
        //          if(this.out_of_screen){
        //            this.out_of_screen=false;
        //            this.el.style.display='block';
        //            //transform_x_y_percent(this.el,0,0);
        //          }
        //        }
        //
        //      },
        //
        //      opened:false,
        //
        //      open: function(){
        //        if(!this.opened){
        //          this.opened=true;
        //
        //          this.update_destination(1);
        //        }
        //      },
        //
        //      close: function(){
        //        if(this.opened){
        //          this.opened=false;
        //
        //          this.update_destination(0);
        //
        //        }
        //      },
        //
        //
        //
        //      };

        //      var storytelling_previous_hovered=false;
        //    var storytelling_next_hovered=false;
        //
        //      var storytelling_slider = {
        //        slides: storytelling.el.querySelectorAll('.slide'),
        //        next_el: $('#storytelling_next'),
        //        prev_el: $('#storytelling_previous'),
        //        position:0,
        //      destination:0,
        //      reset: function(){ /*suspectLoop();*/
        //
        //      },
        //      update_destination: function(num){
        //        this.destination=num;
        //      },
        //      update_position: function(){ /*suspectLoop();*/
        //        var diff=(this.destination-this.position)/2;
        //        var maxmove=Math.max(0.08);
        //        if(diff<-maxmove) diff=-maxmove;
        //        if(diff> maxmove) diff= maxmove;
        //
        //        this.position+=diff;
        //        if(this.destination==0 || this.destination==1){
        //          if(Math.abs(this.destination-this.position)<0.01){
        //            this.position=this.destination;
        //          }
        //        }
        //      },
        //
        //
        //      out_of_screen: true,
        //      commit_position: function(){ /*suspectLoop();*/
        //        var pos=this.position;
        //        var slides=this.slides;
        //        Array.prototype.forEach.call(slides, function(slide, i){ /*suspectLoop();*/
        //          //addClass(element_el,className);
        //          var el_pos=i-pos;
        //          while(el_pos>2){
        //            el_pos-=slides.length;
        //          }
        //          while(el_pos<-2){
        //            el_pos+=slides.length;
        //          }
        //          //console.log('el_pos=',el_pos);
        //          transform_x_y_percent([slide],el_pos*100,0);
        //
        //        });
        //
        //        //this.el.style.opacity=this.position;
        ////
        //        ////transform_x_y_percent([this.el],0,this.position*100);
        //        ////transform_x_y_vwvh([this.menu_link_el],0,100+this.position*100);
        ////
        //        //if(this.position==0){
        //        //  if(!this.out_of_screen){
        //        //    this.out_of_screen=true;
        //        //    this.el.style.display='none';
        //        //    //transform_x_y_percent(this.el,100,0);
        //        //  }
        //        //}else{
        //        //  if(this.out_of_screen){
        //        //    this.out_of_screen=false;
        //        //    this.el.style.display='block';
        //        //    //transform_x_y_percent(this.el,0,0);
        //        //  }
        //        //}
        //
        //      },
        //
        //      prev: function(){
        //        if(this.destination>0){
        //          this.destination-=1;
        //          this.counter=0;
        //          this.check();
        //        }
        //
        //      },
        //      next: function(){
        //        if(this.destination<(this.slides.length-1)){
        //          this.destination+=1;
        //          this.counter=0;
        //          this.check();
        //        }
        //      },
        //
        //      check: function(){
        //        if(this.destination>0){
        //          this.prev_el.fadeIn();
        //        }else{
        //          this.prev_el.fadeOut();
        //        }
        //
        //        if(this.destination<(this.slides.length-1)){
        //          this.next_el.fadeIn();
        //        }else{
        //          this.next_el.fadeOut();
        //        }
        //      },
        //
        //      counter:0,
        //
        //        update: function(){
        //
        //          if( current_slug=='/' && !current_subsection && !storytelling_previous_hovered && !storytelling_next_hovered){
        //            this.counter++;
        //            if(this.counter>60*10){
        //              this.next();
        //            }
        //          }else{
        //            this.counter=0;
        //          }
        //          if(this.position !== this.destination){
        //            this.update_position();
        //            this.commit_position();
        //          }
        //        },
        //
        //        adapt: function(){
        //          var slides=this.slides;
        //          Array.prototype.forEach.call(slides, function(slide, i){ /*suspectLoop();*/
        //
        //          var img=slide.querySelectorAll('img');
        //          //console.log('img=',img);
        //          cover_container_by_replacing_if_needed(img[0],sections.header.get_background_width_value(),sections.header.get_background_height_value());
        //
        //        });
        //        }
        //      };

        var products_background = {
            el: document.getElementById('products_background'),
            position: 0,
            destination: 0,
            reset: function() { /*suspectLoop();*/

            },
            update_destination: function(num) {
                this.destination = num;
            },
            update_position: function() { /*suspectLoop();*/
                var diff = (this.destination - this.position) / 2;
                var maxmove = Math.max(0.08);
                if (diff < -maxmove) diff = -maxmove;
                if (diff > maxmove) diff = maxmove;

                this.position += diff;
                if (this.destination == 0 || this.destination == 1) {
                    if (Math.abs(this.destination - this.position) < 0.01) {
                        this.position = this.destination;
                    }
                }
            },

            //out_of_screen: false,
            commit_position: function() { /*suspectLoop();*/
                /* Moves the product menu on mobile */
                transform_x_y_percent([this.el], -this.position * 16, 0);
            }
        };


        var last_touch = false;
        var accumulated_touch = {
            x: 0,
            y: 0,
        };

        /* Gestures only available in mobile (portrait or landscape) */
        if (is_mobile) {
            //console.log('touch handler events');

            var productsBackgroundTouchHandler = function(event) {
                //window.alert('touch handler');
                //console.log('productsBackgroundTouchHandler()',event);
                var touch;
                if (typeof event !== 'undefined') {

                    //event.preventDefault();

                    if (typeof event.touches !== 'undefined') {
                        touch = event.touches[0];

                        switch (event.type) {
                            case 'touchstart':
                                last_touch = {
                                    x: touch.pageX,
                                    y: touch.pageY
                                }
                                break;
                            case 'touchmove':
                                //event.preventDefault();

                                if (last_touch) {
                                    accumulated_touch.x += touch.pageX - last_touch.x;
                                    accumulated_touch.y += touch.pageY - last_touch.y;


                                    if (Math.abs(accumulated_touch.y) > 100) {

                                        accumulated_touch = {
                                            x: 0,
                                            y: 0,
                                        };
                                        last_touch = false;

                                        //console.log('accumulated_touch reset')

                                    } else if (accumulated_touch.x > 100) {

                                        accumulated_touch = {
                                            x: 0,
                                            y: 0,
                                        };
                                        last_touch = false;

                                        if (current_product > 1) {
                                            current_product--;
                                        }
                                        check_products_visibility();
                                    } else if (accumulated_touch.x < -100) {

                                        accumulated_touch = {
                                            x: 0,
                                            y: 0,
                                        };
                                        last_touch = false;

                                        if (current_product < 6) {
                                            current_product++;
                                        }
                                        check_products_visibility();
                                    }

                                    //console.log('accumulated_touch',accumulated_touch.x,accumulated_touch.y);
                                }

                                break;
                            case 'touchend':
                                accumulated_touch = {
                                    x: 0,
                                    y: 0,
                                }
                                last_touch = false;
                            default:
                                break;
                        }
                    }
                }
            }

            /* Drag/slide/gesture listeners */
            // products_background.el.addEventListener('touchstart', productsBackgroundTouchHandler, false);
            // products_background.el.addEventListener('touchmove', productsBackgroundTouchHandler, false);
            // products_background.el.addEventListener('touchend', productsBackgroundTouchHandler, false);


            var productBackgroundTouchHandler = function(event) {
                //window.alert('touch handler');
                //console.log('productBackgroundTouchHandler()',event);
                var touch;
                if (typeof event !== 'undefined') {

                    //event.preventDefault();

                    if (typeof event.touches !== 'undefined') {
                        touch = event.touches[0];

                        switch (event.type) {
                            case 'touchstart':
                                last_touch = {
                                    x: touch.pageX,
                                    y: touch.pageY
                                }
                                break;
                            case 'touchmove':
                                //event.preventDefault();

                                if (last_touch) {
                                    accumulated_touch.x += touch.pageX - last_touch.x;
                                    accumulated_touch.y += touch.pageY - last_touch.y;


                                    if (Math.abs(accumulated_touch.y) > 100) {

                                        accumulated_touch = {
                                            x: 0,
                                            y: 0,
                                        };
                                        last_touch = false;

                                        //console.log('accumulated_touch reset')

                                    } else if (accumulated_touch.x > 100) {

                                        accumulated_touch = {
                                            x: 0,
                                            y: 0,
                                        };
                                        last_touch = false;

                                        if (current_active_dot > 0) {
                                            change_bullet_to_index(current_active_dot - 1)
                                        }
                                    } else if (accumulated_touch.x < -100) {

                                        accumulated_touch = {
                                            x: 0,
                                            y: 0,
                                        };
                                        last_touch = false;

                                        if (current_active_dot < (count_active_dots - 1)) {
                                            change_bullet_to_index(current_active_dot + 1)
                                        }
                                    }

                                    //console.log('accumulated_touch',accumulated_touch.x,accumulated_touch.y);
                                }

                                break;
                            case 'touchend':
                                accumulated_touch = {
                                    x: 0,
                                    y: 0,
                                }
                                last_touch = false;
                            default:
                                break;
                        }
                    }
                }
            }

            $('#products_detail_backgrounds')[0].addEventListener('touchstart', productBackgroundTouchHandler, false);
            $('#products_detail_backgrounds')[0].addEventListener('touchmove', productBackgroundTouchHandler, false);
            $('#products_detail_backgrounds')[0].addEventListener('touchend', productBackgroundTouchHandler, false);
        }

        var products_aba = {
            _el: document.getElementById('products_aba'),
            _position: 1,
            go: function(position) {
                this._position = position;

                var $button = $('.products_button[rel='+position+']');
                var x = $button.offset().left + ($button.width() / 2) - $('#products_navigation').offset().left;

                transform_x_y([this._el], x, 0);
            }
        };

        $(window).on('resize', function(){
          try {
            if ($(window).width() <= 1024) {
              $('.products_list').slick({
                infinite: false,
                speed: 300,
                prevArrow: $('#more-products-left'),
                nextArrow: $('#more-products-right'),
                slidesToShow: 3,
                slidesToScroll: 3,
                responsive: [
                  {
                    breakpoint: 567,
                    settings: {

                        slidesToShow: 1,
                        slidesToScroll: 1,
                        prevArrow: $('#products_previous'),
                        nextArrow: $('#products_next'),
                    }
                  }
                ]
              });
            } else {
              $('.products_list').slick('unslick');
            }
          } catch(e) {}

          products_aba.go(products_aba._position);
        });

        var layout_loader_blackout = {
            el: document.getElementById('blackout'),
        }

        var layout_loader_screen = {
            el: document.getElementById('loader'),
            position: 0,
            destination: 0,
            reset: function() { /*suspectLoop();*/

            },
            update_destination: function(num) {
                this.destination = num;
            },
            update_position: function() { /*suspectLoop();*/
                //if(this.destination==1 || this.destination==0){
                var diff = (this.destination - this.position) / 20;
                //}else{
                //  var diff=(this.destination-this.position)/20;
                //}

                //if(this.destination>0 && this.destination<0.5){
                //  var maxmove=this.destination*Math.max(0.01);
                //}else{
                var maxmove = Math.max(0.08);
                //}

                if (diff < -maxmove) diff = -maxmove;
                if (diff > maxmove) diff = maxmove;

                this.position += diff;
                if (this.destination == 0 || this.destination == 1) {
                    if (Math.abs(this.destination - this.position) < 0.01) {
                        this.position = this.destination;
                    }
                }
            },


            //out_of_screen: false,
            commit_position: function() { /*suspectLoop();*/

                this.el.style.opacity = this.position;

                //if(this.position==0){
                //  if(!this.out_of_screen){
                //    this.out_of_screen=true;
                //    transform_x_y_percent(this.el,100,0);
                //  }
                //}else{
                //  if(this.out_of_screen){
                //    this.out_of_screen=false;
                //    transform_x_y_percent(this.el,0,0);
                //  }
                //}
                //this.el.style.width=(this.position*100)+'%';
            }
        };


        var layout_loader_display = {
            el: document.getElementById('loader_display'),
            position: 0,
            destination: 0,
            reset: function() { /*suspectLoop();*/

            },
            update_destination: function(num) {
                this.destination = num;
            },
            update_position: function() { /*suspectLoop();*/
                if (this.destination == 1 || this.destination == 0) {
                    var diff = (this.destination - this.position) / 2;
                } else {
                    var diff = (this.destination - this.position) / 20;
                }
                var maxmove = 1 / 14 / 2;

                if (diff < -maxmove) diff = -maxmove;
                if (diff > maxmove) diff = maxmove;

                if (diff < 0.005) {
                    diff = 0.005;
                }

                this.position += diff;
                if (this.destination == 0 || this.destination == 1) {
                    if (Math.abs(this.destination - this.position) < 0.0005) {
                        this.position = this.destination;
                    }

                }
            },
            commit_position: function() { /*suspectLoop();*/

                var classUse = 'floater sprite loader' + Math.floor(this.position * 13);
                ////console.log('classUse=',classUse);
                //$(this.el).addClass(classUse);
                this.el.className = classUse;
                //this.el.style.width=Math.round(this.position*100*100)/100+'%';
            }
        };

        var count_wait_total = 0;
        var count_wait_after_dom_was_loaded = 0;
        var asked_to_preload_initial_sections = false;
        var frames_loading_count_for_checking_load_errors = 0;
        var wait_for_dom_load = function() {
            //updater_didnt_run_count=0;

            calls = 0;

            count_wait_total++;

            if (dom_is_loaded) { //(count_wait_after_dom_was_loaded<10 || count_wait_total<10 || !asked_to_preload_initial_sections)

                if (primary_initializations_completed) {

                    //console.log('dom is loaded and initialized, move to main loader');
                    window.requestAnimationFrame(main_loader_run);

                    transform_x_y_percent([layout_loader_screen.el], 0, 0);
                    opacity([layout_loader_screen.el], 0);
                    layout_loader_screen.update_destination(1);

                } else {
                    count_wait_after_dom_was_loaded++;
                    window.requestAnimationFrame(wait_for_dom_load);
                    run_primary_initializations();
                }

            } else {
                window.requestAnimationFrame(wait_for_dom_load);
            }
        }

        var frames_at_100_percent = 0;
        var main_loader_completed = false;
        var fake_percent = 0.3;


        var frames_at_main_loader = 0;
        var main_loader_run = function() {
            frames_loading_count_for_checking_load_errors++;
            frames_at_main_loader++;
            calls = 0;


            layout_loader_screen.update_position();
            layout_loader_screen.commit_position();

            //if(intro_card){
            //  intro_card.opacity+=calc_diff(intro_card.opacity,Math.min(1,frames_at_main_loader*0.01));
            //  opacity(intro_card.el, intro_card.opacity);
            //}

            if (main_loader_completed) {

                remove(layout_loader_blackout.el);
                layout_loader_blackout = null;

                $(window).trigger('resize');

                window.requestAnimationFrame(intro_run);
                return;
            } else {
                window.requestAnimationFrame(main_loader_run);

            }

            if (layout_loader_screen) {
                if (layout_loader_screen.position < 0.9) {
                    return;
                }
            }

            updater_fullfill_subcriptions();
            run_secondary_initializations();


            var count_sections = 0;
            var count_completed = 0;

            var images_pc = check_images_being_loaded_percent();
            count_sections += 5 * 1;
            count_completed += 5 * images_pc;

            var percent_completed = 0;
            if (count_sections == 0) {
                percent_completed = 1;
            } else {
                percent_completed = count_completed / count_sections;
            }

            fake_percent += 0.001;
            if (fake_percent > 1) fake_percent = 1;
            if (percent_completed >= 1) fake_percent += 0.01;

            if (percent_completed >= 1 && (fake_percent > 0.4 || frames_at_main_loader > 60 * 3)) {
                layout_loader_display.update_destination(percent_completed);
            } else {
                layout_loader_display.update_destination(Math.min(fake_percent, 0.3 + percent_completed * 0.7));
            }

            layout_loader_display.update_position();
            layout_loader_display.commit_position();

            if (percent_completed >= 0.9 && layout_loader_display.position >= 1 /*0.99*/ ) {
                frames_at_100_percent++;

                if (frames_at_100_percent >= 10 && secondary_initializations_completed) {
                    main_loader_completed = true;
                    //console.log('tell main loader is completed')
                }
            }
        }

        var intro_opacity = 0;
        var intro_completed = false;
        var first_section_initialized = false;
        var intro_run = function() {
            //updater_didnt_run_count=0;
            calls = 0;

            updater_fullfill_subcriptions();

            if (intro_completed) {

                //console.log('intro completed');
                //layout_blackout.update_position();

                //if(intro_card){
                //  invert(intro_card.el, 0);
                //}
                //opacity(layout_title.el, 1);
                //opacity(layout_subtitle.el, 1);


                //layout_loader_display.position=1;
                //layout_loader_display.commit_position();
                //opacity(layout_loader_display.el, 1);


                //layout_body.commit_position();
                //remove(layout_loader_screen.el);
                //transform_x_y_percent([layout_loader_screen.el],0,-intro_opacity*100);
                remove(layout_loader_screen.el);
                layout_loader_screen = null;

                window.requestAnimationFrame(updater_run);
                return;
            } else {
                //last_animation_function=intro_run;
                //last_animation_call=
                window.requestAnimationFrame(intro_run);
            }

            intro_opacity += calc_diff(intro_opacity, 1);
            ////console.log('intro_opacity=',intro_opacity);
            transform_x_y_percent([layout_loader_screen.el], 0, -intro_opacity * 100);

            //opacity(layout_title.el, intro_opacity);
            //opacity(layout_subtitle.el, intro_opacity);
            //opacity(layout_loader_display.el, 1-intro_opacity);

            //layout_loader_display.update_position();
            //layout_loader_display.commit_position();

            if (intro_opacity > 0.99) {
                //console.log('tell intro is completed')
                intro_completed = true;
            }


        }

        //main_resize_handler();
        //updater_run();
        wait_for_dom_load();

        if (PROFILE) console.log('Global Initialize time: ' + ((new Date().getTime()) - global_start) + 'ms');
    }

    if (document.readyState != 'loading') {
        ready();
    } else {
        document.addEventListener('DOMContentLoaded', ready);
    }

})();
